import { ApiBase } from './ApiBase';
import { IEvent } from '../Utilities/Interface/IEvent';
import { IAdaptableBlotter } from '../Utilities/Interface/IAdaptableBlotter';
import { IAuditEventApi } from './Interface/IAuditEventApi';
import { EventDispatcher } from '../Utilities/EventDispatcher';
import { AuditLogEventArgs } from './Events/AuditEvents';
export declare class AuditEventApi extends ApiBase implements IAuditEventApi {
    _onAuditStateChanged: EventDispatcher<IAdaptableBlotter, AuditLogEventArgs>;
    _onAuditCellEdited: EventDispatcher<IAdaptableBlotter, AuditLogEventArgs>;
    _onAuditFunctionApplied: EventDispatcher<IAdaptableBlotter, AuditLogEventArgs>;
    constructor(blotter: IAdaptableBlotter);
    onAuditStateChanged(): IEvent<IAdaptableBlotter, AuditLogEventArgs>;
    onAuditCellEdited(): IEvent<IAdaptableBlotter, AuditLogEventArgs>;
    onAuditFunctionApplied(): IEvent<IAdaptableBlotter, AuditLogEventArgs>;
}
