import { IBlotterApi } from './Interface/IBlotterApi';
import { IAdvancedSearchApi } from './Interface/IAdvancedSearchApi';
import { IAlertApi } from './Interface/IAlertApi';
import { ICalendarApi } from './Interface/ICalendarApi';
import { ICalculatedColumnApi } from './Interface/ICalculatedColumnApi';
import { ICellValidationApi } from './Interface/ICellValidationApi';
import { IColumnCategoryApi } from './Interface/IColumnCategoryApi';
import { IColumnFilterApi } from './Interface/IColumnFilterApi';
import { IConfigApi } from './Interface/IConfigApi';
import { ICustomSortApi } from './Interface/ICustomSortApi';
import { IDashboardApi } from './Interface/IDashboardApi';
import { IDataSourceApi } from './Interface/IDataSourceApi';
import { IEntitlementApi } from './Interface/IEntitlementApi';
import { IEventApi } from './Interface/IEventApi';
import { IExportApi } from './Interface/IExportApi';
import { IFormatColumnApi } from './Interface/IFormatColumnApi';
import { IFreeTextColumnApi } from './Interface/IFreeTextColumnApi';
import { IGridApi } from './Interface/IGridApi';
import { ILayoutApi } from './Interface/ILayoutApi';
import { IPercentBarApi } from './Interface/IPercentBarApi';
import { IQuickSearchApi } from './Interface/IQuickSearchApi';
import { IShortcutApi } from './Interface/IShortcutApi';
import { ISmartEditApi } from './Interface/ISmartEditApi';
import { ISystemFilterApi } from './Interface/ISystemFilterApi';
import { ISystemStatusApi } from './Interface/ISystemStatusApi';
import { IThemeApi } from './Interface/IThemeApi';
import { IUserInterfaceApi } from './Interface/IUserInterfaceApi';
import { IAdaptableBlotter } from '../Utilities/Interface/IAdaptableBlotter';
import { IInternalApi } from './Interface/IInternalApi';
import { IConditionalStyleApi } from './Interface/IConditionalStyleApi';
import { IReminderApi } from './Interface/IReminderApi';
import { IFlashingCellApi } from './Interface/IFlashingCellApi';
import { IChartApi } from './Interface/IChartApi';
import { ICellSummaryApi } from './Interface/ICellSummaryApi';
import { IUserFilterApi } from './Interface/IUserFilterApi';
import { IPlusMinusApi } from './Interface/IPlusMinusApi';
import { IBulkUpdateApi } from './Interface/IBulkUpdateApi';
import { IAuditEventApi } from './Interface/IAuditEventApi';
import { IActionColumnApi } from './Interface/IActionColumnApi';
import { INamedFilterApi } from './Interface/INamedFilterApi';
export declare class BlotterApi implements IBlotterApi {
    protected blotter: IAdaptableBlotter;
    actionColumnApi: IActionColumnApi;
    advancedSearchApi: IAdvancedSearchApi;
    alertApi: IAlertApi;
    auditEventApi: IAuditEventApi;
    bulkUpdateApi: IBulkUpdateApi;
    calendarApi: ICalendarApi;
    calculatedColumnApi: ICalculatedColumnApi;
    cellSummaryApi: ICellSummaryApi;
    cellValidationApi: ICellValidationApi;
    chartApi: IChartApi;
    columnCategoryApi: IColumnCategoryApi;
    columnFilterApi: IColumnFilterApi;
    conditionalStyleApi: IConditionalStyleApi;
    configApi: IConfigApi;
    customSortApi: ICustomSortApi;
    dashboardApi: IDashboardApi;
    dataSourceApi: IDataSourceApi;
    entitlementApi: IEntitlementApi;
    eventApi: IEventApi;
    exportApi: IExportApi;
    flashingCellApi: IFlashingCellApi;
    formatColumnApi: IFormatColumnApi;
    freeTextColumnApi: IFreeTextColumnApi;
    gridApi: IGridApi;
    internalApi: IInternalApi;
    layoutApi: ILayoutApi;
    plusMinusApi: IPlusMinusApi;
    percentBarApi: IPercentBarApi;
    quickSearchApi: IQuickSearchApi;
    reminderApi: IReminderApi;
    shortcutApi: IShortcutApi;
    smartEditApi: ISmartEditApi;
    systemFilterApi: ISystemFilterApi;
    systemStatusApi: ISystemStatusApi;
    themeApi: IThemeApi;
    userInterfaceApi: IUserInterfaceApi;
    userFilterApi: IUserFilterApi;
    namedFilterApi: INamedFilterApi;
    constructor(blotter: IAdaptableBlotter);
}
