"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ColumnCategoryRedux = require("../Redux/ActionsReducers/ColumnCategoryRedux");
var ApiBase_1 = require("./ApiBase");
var ColumnCategoryApi = /** @class */ (function (_super) {
    tslib_1.__extends(ColumnCategoryApi, _super);
    function ColumnCategoryApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ColumnCategoryApi.prototype.getColumnCategoryState = function () {
        return this.getBlotterState().ColumnCategory;
    };
    ColumnCategoryApi.prototype.getAllColumnCategory = function () {
        return this.getColumnCategoryState().ColumnCategories;
    };
    ColumnCategoryApi.prototype.getColumnCategoryById = function (columnCategoryId) {
        return this.getAllColumnCategory().find(function (cc) { return cc.ColumnCategoryId == columnCategoryId; });
    };
    ColumnCategoryApi.prototype.addColumnCategory = function (columnCategory) {
        this.dispatchAction(ColumnCategoryRedux.ColumnCategoryAdd(columnCategory));
    };
    ColumnCategoryApi.prototype.createColumnCategory = function (columnCategoryId, columns) {
        var columnCategory = {
            ColumnCategoryId: columnCategoryId,
            ColumnIds: columns,
        };
        this.addColumnCategory(columnCategory);
    };
    ColumnCategoryApi.prototype.editColumnCategory = function (columnCategory) {
        this.dispatchAction(ColumnCategoryRedux.ColumnCategoryEdit(columnCategory));
    };
    ColumnCategoryApi.prototype.addColumnsToColumnCategory = function (columnCategoryId, columns) {
        var columnCategory = this.getColumnCategoryById(columnCategoryId);
        columns.forEach(function (c) {
            columnCategory.ColumnIds.push(c);
        });
        this.dispatchAction(ColumnCategoryRedux.ColumnCategoryEdit(columnCategory));
    };
    ColumnCategoryApi.prototype.removeColumnsFromColumnCategory = function (columnCategoryId, columns) {
        var columnCategory = this.getAllColumnCategory().find(function (cc) { return cc.ColumnCategoryId == columnCategoryId; });
        columns.forEach(function (c) {
            var ccIndex = columnCategory.ColumnIds.findIndex(function (cc) { return cc == c; });
            columnCategory.ColumnIds.splice(ccIndex, 1);
        });
        this.dispatchAction(ColumnCategoryRedux.ColumnCategoryEdit(columnCategory));
    };
    ColumnCategoryApi.prototype.deleteColumnCategory = function (columnCategoryId) {
        var columnCategory = this.getAllColumnCategory().find(function (cc) { return cc.ColumnCategoryId == columnCategoryId; });
        this.dispatchAction(ColumnCategoryRedux.ColumnCategoryDelete(columnCategory));
    };
    return ColumnCategoryApi;
}(ApiBase_1.ApiBase));
exports.ColumnCategoryApi = ColumnCategoryApi;
