"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ColumnFilterRedux = require("../Redux/ActionsReducers/ColumnFilterRedux");
var ApiBase_1 = require("./ApiBase");
var ColumnFilterApi = /** @class */ (function (_super) {
    tslib_1.__extends(ColumnFilterApi, _super);
    function ColumnFilterApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ColumnFilterApi.prototype.getColumnFilterState = function () {
        return this.getBlotterState().ColumnFilter;
    };
    ColumnFilterApi.prototype.setColumnFilter = function (columnFilters) {
        var _this = this;
        columnFilters.forEach(function (columnFilter) {
            if (_this.getAllColumnFilter().find(function (cf) { return cf.ColumnId == columnFilter.ColumnId; })) {
                _this.dispatchAction(ColumnFilterRedux.ColumnFilterEdit(columnFilter));
            }
            else {
                _this.dispatchAction(ColumnFilterRedux.ColumnFilterAdd(columnFilter));
            }
        });
    };
    ColumnFilterApi.prototype.clearColumnFilter = function (columnFilter) {
        this.dispatchAction(ColumnFilterRedux.ColumnFilterClear(columnFilter));
    };
    ColumnFilterApi.prototype.clearColumnFilterByColumns = function (columns) {
        var _this = this;
        columns.forEach(function (c) {
            _this.clearColumnFilterByColumn(c);
        });
    };
    ColumnFilterApi.prototype.clearColumnFilterByColumn = function (column) {
        var _this = this;
        var columnFiltersForColumn = this.getAllColumnFilter().filter(function (cf) { return cf.ColumnId == column; });
        columnFiltersForColumn.forEach(function (cf) {
            _this.dispatchAction(ColumnFilterRedux.ColumnFilterClear(cf));
        });
    };
    ColumnFilterApi.prototype.clearAllColumnFilter = function () {
        this.dispatchAction(ColumnFilterRedux.ColumnFilterClearAll());
    };
    ColumnFilterApi.prototype.getAllColumnFilter = function () {
        return this.getBlotterState().ColumnFilter.ColumnFilters;
    };
    return ColumnFilterApi;
}(ApiBase_1.ApiBase));
exports.ColumnFilterApi = ColumnFilterApi;
