"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var CustomSortRedux = require("../Redux/ActionsReducers/CustomSortRedux");
var ApiBase_1 = require("./ApiBase");
var CustomSortApi = /** @class */ (function (_super) {
    tslib_1.__extends(CustomSortApi, _super);
    function CustomSortApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CustomSortApi.prototype.getCustomSortState = function () {
        return this.getBlotterState().CustomSort;
    };
    CustomSortApi.prototype.getAllCustomSort = function () {
        return this.getBlotterState().CustomSort.CustomSorts;
    };
    CustomSortApi.prototype.getCustomSortByColumn = function (column) {
        return this.getBlotterState().CustomSort.CustomSorts.find(function (cs) { return cs.ColumnId == column; });
    };
    CustomSortApi.prototype.addCustomSort = function (customSort) {
        this.dispatchAction(CustomSortRedux.CustomSortAdd(customSort));
    };
    CustomSortApi.prototype.createCustomSort = function (columnId, values) {
        var customSort = { ColumnId: columnId, SortedValues: values };
        this.addCustomSort(customSort);
    };
    CustomSortApi.prototype.editCustomSort = function (columnId, values) {
        var customSort = { ColumnId: columnId, SortedValues: values };
        if (this.checkItemExists(customSort, columnId, StrategyConstants.CustomSortStrategyId)) {
            this.dispatchAction(CustomSortRedux.CustomSortEdit(customSort));
        }
    };
    CustomSortApi.prototype.deleteCustomSort = function (column) {
        var customSort = this.getCustomSortByColumn(column);
        this.dispatchAction(CustomSortRedux.CustomSortDelete(customSort));
    };
    return CustomSortApi;
}(ApiBase_1.ApiBase));
exports.CustomSortApi = CustomSortApi;
