"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var DashboardRedux = require("../Redux/ActionsReducers/DashboardRedux");
var ApiBase_1 = require("./ApiBase");
var Enums_1 = require("../PredefinedConfig/Common/Enums");
var DashboardApi = /** @class */ (function (_super) {
    tslib_1.__extends(DashboardApi, _super);
    function DashboardApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DashboardApi.prototype.GetState = function () {
        return this.getBlotterState().Dashboard;
    };
    DashboardApi.prototype.SetAvailableToolbars = function (availableToolbars) {
        this.dispatchAction(DashboardRedux.DashboardSetAvailableToolbars(availableToolbars));
    };
    DashboardApi.prototype.SetVisibleToolbars = function (visibleToolbars) {
        var _this = this;
        visibleToolbars.forEach(function (vt) {
            _this.ShowToolbar(vt);
        });
    };
    DashboardApi.prototype.ShowToolbar = function (visibleToolbar) {
        this.dispatchAction(DashboardRedux.DashboardShowToolbar(visibleToolbar));
    };
    DashboardApi.prototype.HideToolbar = function (visibleToolbar) {
        this.dispatchAction(DashboardRedux.DashboardHideToolbar(visibleToolbar));
    };
    DashboardApi.prototype.SetVisibleButtons = function (functionButtons) {
        this.dispatchAction(DashboardRedux.DashboardSetFunctionButtons(functionButtons));
    };
    DashboardApi.prototype.SetVisibility = function (dashboardVisibility) {
        this.dispatchAction(DashboardRedux.DashboardSetVisibility(dashboardVisibility));
    };
    DashboardApi.prototype.Show = function () {
        this.SetVisibility(Enums_1.Visibility.Visible);
    };
    DashboardApi.prototype.Hide = function () {
        this.SetVisibility(Enums_1.Visibility.Hidden);
    };
    DashboardApi.prototype.Minimise = function () {
        this.SetVisibility(Enums_1.Visibility.Minimised);
    };
    DashboardApi.prototype.ShowSystemStatusButton = function () {
        this.dispatchAction(DashboardRedux.DashboardShowSystemStatusButton());
    };
    DashboardApi.prototype.HideSystemStatusButton = function () {
        this.dispatchAction(DashboardRedux.DashboardHideSystemStatusButton());
    };
    DashboardApi.prototype.ShowGridInfoButton = function () {
        this.dispatchAction(DashboardRedux.DashboardShowGridInfoButton());
    };
    DashboardApi.prototype.HideGridInfoButton = function () {
        this.dispatchAction(DashboardRedux.DashboardHideGridInfoButton());
    };
    DashboardApi.prototype.ShowFunctionsDropdown = function () {
        this.dispatchAction(DashboardRedux.DashboardShowFunctionsDropdown());
    };
    DashboardApi.prototype.HideFunctionsDropdown = function () {
        this.dispatchAction(DashboardRedux.DashboardHideFunctionsDropdown());
    };
    DashboardApi.prototype.ShowColumnsDropdown = function () {
        this.dispatchAction(DashboardRedux.DashboardShowColumnsDropdown());
    };
    DashboardApi.prototype.HideColumnsDropdown = function () {
        this.dispatchAction(DashboardRedux.DashboardHideColumnsDropdown());
    };
    DashboardApi.prototype.SetHomeToolbarTitle = function (title) {
        this.dispatchAction(DashboardRedux.DashboardSetHomeToolbarTitle(title));
    };
    DashboardApi.prototype.SetApplicationToolbarTitle = function (title) {
        this.dispatchAction(DashboardRedux.DashboardSetApplicationToolbarTitle(title));
    };
    return DashboardApi;
}(ApiBase_1.ApiBase));
exports.DashboardApi = DashboardApi;
