"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var DataSourceRedux = require("../Redux/ActionsReducers/DataSourceRedux");
var ApiBase_1 = require("./ApiBase");
var DataSourceApi = /** @class */ (function (_super) {
    tslib_1.__extends(DataSourceApi, _super);
    function DataSourceApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DataSourceApi.prototype.getDataSourceState = function () {
        return this.getBlotterState().DataSource;
    };
    DataSourceApi.prototype.getAllDataSource = function () {
        return this.getDataSourceState().DataSources;
    };
    DataSourceApi.prototype.getCurrentDataSource = function () {
        var currentDataSourceName = this.getDataSourceState().CurrentDataSource;
        return this.getDataSourceByName(currentDataSourceName);
    };
    DataSourceApi.prototype.getDataSourceByName = function (dataSourceName) {
        return this.getAllDataSource().find(function (a) { return a.Name == dataSourceName; });
    };
    DataSourceApi.prototype.setDataSource = function (dataSourceName) {
        var dataSource = this.getBlotterState().DataSource.DataSources.find(function (a) { return a.Name == dataSourceName; });
        if (this.checkItemExists(dataSource, dataSourceName, StrategyConstants.DataSourceStrategyName)) {
            this.dispatchAction(DataSourceRedux.DataSourceSelect(dataSource.Name));
        }
    };
    DataSourceApi.prototype.createDataSource = function (dataSourceName, dataSourceDescription) {
        var dataSource = {
            Name: dataSourceName,
            Description: dataSourceDescription,
        };
        this.addDataSource(dataSource);
    };
    DataSourceApi.prototype.addDataSource = function (dataSource) {
        this.dispatchAction(DataSourceRedux.DataSourceAdd(dataSource));
    };
    DataSourceApi.prototype.clearDataSource = function () {
        this.dispatchAction(DataSourceRedux.DataSourceSelect(''));
    };
    return DataSourceApi;
}(ApiBase_1.ApiBase));
exports.DataSourceApi = DataSourceApi;
