"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var EntitlementsRedux = require("../Redux/ActionsReducers/EntitlementsRedux");
var ApiBase_1 = require("./ApiBase");
var EntitlementApi = /** @class */ (function (_super) {
    tslib_1.__extends(EntitlementApi, _super);
    function EntitlementApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EntitlementApi.prototype.getEntitlementState = function () {
        return this.getBlotterState().Entitlements;
    };
    EntitlementApi.prototype.getAllEntitlement = function () {
        return this.getBlotterState().Entitlements.FunctionEntitlements;
    };
    EntitlementApi.prototype.getEntitlementByFunction = function (functionName) {
        return this.getBlotterState().Entitlements.FunctionEntitlements.find(function (f) { return f.FunctionName == functionName; });
    };
    EntitlementApi.prototype.getEntitlementAccessLevelForFunction = function (functionName) {
        return this.getBlotterState().Entitlements.FunctionEntitlements.find(function (f) { return f.FunctionName == functionName; }).AccessLevel;
    };
    EntitlementApi.prototype.addEntitlement = function (functionName, accessLevel) {
        var entitlement = { FunctionName: functionName, AccessLevel: accessLevel };
        this.dispatchAction(EntitlementsRedux.EntitlementAdd(entitlement));
    };
    EntitlementApi.prototype.editEntitlement = function (functionName, accessLevel) {
        var entitlement = { FunctionName: functionName, AccessLevel: accessLevel };
        this.dispatchAction(EntitlementsRedux.EntitlementUpdate(entitlement));
    };
    EntitlementApi.prototype.deleteEntitlement = function (functionName) {
        this.dispatchAction(EntitlementsRedux.EntitlementDelete(functionName));
    };
    return EntitlementApi;
}(ApiBase_1.ApiBase));
exports.EntitlementApi = EntitlementApi;
