import { ApiBase } from './ApiBase';
import { IEvent } from '../Utilities/Interface/IEvent';
import { IAdaptableBlotter } from '../Utilities/Interface/IAdaptableBlotter';
import { EventDispatcher } from '../Utilities/EventDispatcher';
import { SearchChangedEventArgs } from './Events/SearchChanged/SearchChangedEventArgs';
import { ThemeChangedEventArgs, AlertFiredEventArgs, ColumnStateChangedEventArgs, ActionColumnClickedEventArgs, SelectionChangedEventArgs } from './Events/BlotterEvents';
import { IEventApi } from './Interface/IEventApi';
export declare class EventApi extends ApiBase implements IEventApi {
    _onSearchChanged: EventDispatcher<IAdaptableBlotter, SearchChangedEventArgs>;
    _onThemeChanged: EventDispatcher<IAdaptableBlotter, ThemeChangedEventArgs>;
    _onColumnStateChanged: EventDispatcher<IAdaptableBlotter, ColumnStateChangedEventArgs>;
    _onAlertFired: EventDispatcher<IAdaptableBlotter, AlertFiredEventArgs>;
    _onActionColumnClicked: EventDispatcher<IAdaptableBlotter, ActionColumnClickedEventArgs>;
    _onSelectionChanged: EventDispatcher<IAdaptableBlotter, SelectionChangedEventArgs>;
    constructor(blotter: IAdaptableBlotter);
    onSearchChanged(): IEvent<IAdaptableBlotter, SearchChangedEventArgs>;
    onThemeChanged(): IEvent<IAdaptableBlotter, ThemeChangedEventArgs>;
    onColumnStateChanged(): IEvent<IAdaptableBlotter, ColumnStateChangedEventArgs>;
    onAlertFired(): IEvent<IAdaptableBlotter, AlertFiredEventArgs>;
    onActionColumnClicked(): IEvent<IAdaptableBlotter, ActionColumnClickedEventArgs>;
    onSelectionChanged(): IEvent<IAdaptableBlotter, SelectionChangedEventArgs>;
}
