"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ApiBase_1 = require("./ApiBase");
var EventDispatcher_1 = require("../Utilities/EventDispatcher");
var EventApi = /** @class */ (function (_super) {
    tslib_1.__extends(EventApi, _super);
    function EventApi(blotter) {
        var _this = _super.call(this, blotter) || this;
        _this._onSearchChanged = new EventDispatcher_1.EventDispatcher();
        _this._onThemeChanged = new EventDispatcher_1.EventDispatcher();
        _this._onColumnStateChanged = new EventDispatcher_1.EventDispatcher();
        _this._onAlertFired = new EventDispatcher_1.EventDispatcher();
        _this._onActionColumnClicked = new EventDispatcher_1.EventDispatcher();
        _this._onSelectionChanged = new EventDispatcher_1.EventDispatcher();
        return _this;
    }
    EventApi.prototype.onSearchChanged = function () {
        return this._onSearchChanged;
    };
    EventApi.prototype.onThemeChanged = function () {
        return this._onThemeChanged;
    };
    EventApi.prototype.onColumnStateChanged = function () {
        return this._onColumnStateChanged;
    };
    EventApi.prototype.onAlertFired = function () {
        return this._onAlertFired;
    };
    EventApi.prototype.onActionColumnClicked = function () {
        return this._onActionColumnClicked;
    };
    EventApi.prototype.onSelectionChanged = function () {
        return this._onSelectionChanged;
    };
    return EventApi;
}(ApiBase_1.ApiBase));
exports.EventApi = EventApi;
