"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ExportRedux = require("../Redux/ActionsReducers/ExportRedux");
var ApiBase_1 = require("./ApiBase");
var ExportApi = /** @class */ (function (_super) {
    tslib_1.__extends(ExportApi, _super);
    function ExportApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ExportApi.prototype.getExportState = function () {
        return this.getBlotterState().Export;
    };
    ExportApi.prototype.getCurrentReportName = function () {
        return this.getExportState().CurrentReport;
    };
    ExportApi.prototype.getCurrentReport = function () {
        var reportName = this.getCurrentReportName();
        return this.getReportByName(reportName);
    };
    ExportApi.prototype.getReportByName = function (reportName) {
        var report = this.getAllReports().find(function (r) { return r.Name == reportName; });
        return report;
    };
    ExportApi.prototype.getAllReports = function () {
        return this.blotter.api.internalApi
            .getSystemReports()
            .concat(this.getBlotterState().Export.Reports);
    };
    ExportApi.prototype.sendReport = function (reportName, destination) {
        var report = this.getReportByName(reportName);
        if (this.checkItemExists(report, reportName, 'Report')) {
            this.dispatchAction(ExportRedux.ExportApply(report, destination));
        }
    };
    return ExportApi;
}(ApiBase_1.ApiBase));
exports.ExportApi = ExportApi;
