"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var FormatColumnRedux = require("../Redux/ActionsReducers/FormatColumnRedux");
var ApiBase_1 = require("./ApiBase");
var FormatColumnApi = /** @class */ (function (_super) {
    tslib_1.__extends(FormatColumnApi, _super);
    function FormatColumnApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormatColumnApi.prototype.getFormatColumnState = function () {
        return this.getBlotterState().FormatColumn;
    };
    FormatColumnApi.prototype.getAllFormatColumn = function () {
        return this.getBlotterState().FormatColumn.FormatColumns;
    };
    FormatColumnApi.prototype.addFormatColumn = function (column, style) {
        var formatColumn = { ColumnId: column, Style: style };
        this.dispatchAction(FormatColumnRedux.FormatColumnAdd(formatColumn));
    };
    FormatColumnApi.prototype.updateFormatColumn = function (column, style) {
        var formatColumn = { ColumnId: column, Style: style };
        this.dispatchAction(FormatColumnRedux.FormatColumnEdit(formatColumn));
    };
    FormatColumnApi.prototype.deleteFormatColumn = function (formatColumn) {
        this.dispatchAction(FormatColumnRedux.FormatColumnDelete(formatColumn));
    };
    FormatColumnApi.prototype.deleteAllFormatColumn = function () {
        var _this = this;
        this.getAllFormatColumn().forEach(function (fc) {
            _this.deleteFormatColumn(fc);
        });
    };
    return FormatColumnApi;
}(ApiBase_1.ApiBase));
exports.FormatColumnApi = FormatColumnApi;
