"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var FreeTextColumnRedux = require("../Redux/ActionsReducers/FreeTextColumnRedux");
var ApiBase_1 = require("./ApiBase");
var ObjectFactory_1 = require("../Utilities/ObjectFactory");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var FreeTextColumnApi = /** @class */ (function (_super) {
    tslib_1.__extends(FreeTextColumnApi, _super);
    function FreeTextColumnApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FreeTextColumnApi.prototype.getFreeTextColumnState = function () {
        return this.getBlotterState().FreeTextColumn;
    };
    FreeTextColumnApi.prototype.getAllFreeTextColumn = function () {
        return this.getBlotterState().FreeTextColumn.FreeTextColumns;
    };
    FreeTextColumnApi.prototype.addFreeTextColumn = function (freeTextColumn) {
        this.dispatchAction(FreeTextColumnRedux.FreeTextColumnAdd(freeTextColumn));
    };
    FreeTextColumnApi.prototype.addEditFreeTextColumnStoredValue = function (freeTextColumn, storedValue) {
        this.dispatchAction(FreeTextColumnRedux.FreeTextColumnAddEditStoredValue(freeTextColumn, storedValue));
    };
    FreeTextColumnApi.prototype.createFreeTextColumn = function (columnId, defaultValue) {
        if (defaultValue === void 0) { defaultValue = null; }
        var freeTextColumn = ObjectFactory_1.ObjectFactory.CreateEmptyFreeTextColumn();
        freeTextColumn.ColumnId = columnId;
        freeTextColumn.DefaultValue = defaultValue;
        this.addFreeTextColumn(freeTextColumn);
    };
    FreeTextColumnApi.prototype.deleteFreeTextColumn = function (columnId) {
        var freeTextColumn = this.getAllFreeTextColumn().find(function (ftc) { return ftc.ColumnId == columnId; });
        if (this.checkItemExists(freeTextColumn, columnId, StrategyConstants.FreeTextColumnStrategyId)) {
            this.dispatchAction(FreeTextColumnRedux.FreeTextColumnDelete(freeTextColumn));
        }
    };
    return FreeTextColumnApi;
}(ApiBase_1.ApiBase));
exports.FreeTextColumnApi = FreeTextColumnApi;
