import { ApiBase } from './ApiBase';
import { IGridApi } from './Interface/IGridApi';
import { IColumn } from '../Utilities/Interface/IColumn';
import { GridState } from '../PredefinedConfig/InternalState/GridState';
import { SelectedCellInfo } from '../Utilities/Interface/Selection/SelectedCellInfo';
import { ColumnSort } from '../PredefinedConfig/RunTimeState/LayoutState';
import { GridCell } from '../Utilities/Interface/Selection/GridCell';
import { SelectedRowInfo } from '../Utilities/Interface/Selection/SelectedRowInfo';
export declare class GridApi extends ApiBase implements IGridApi {
    getGridState(): GridState;
    setGridData(dataSource: any): void;
    getColumns(): IColumn[];
    getSelectedCellInfo(): SelectedCellInfo;
    getSelectedRowInfo(): SelectedRowInfo;
    getVisibleColumns(): IColumn[];
    getNumericColumns(): IColumn[];
    getDateColumns(): IColumn[];
    getColumnSorts(): ColumnSort[];
    setValue(id: any, columnId: string, newValue: any): void;
    setGridCell(gridCell: GridCell): void;
    setGridCellBatch(gridCells: GridCell[]): void;
}
