"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ApiBase_1 = require("./ApiBase");
var Enums_1 = require("../PredefinedConfig/Common/Enums");
var GridApi = /** @class */ (function (_super) {
    tslib_1.__extends(GridApi, _super);
    function GridApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GridApi.prototype.getGridState = function () {
        return this.getBlotterState().Grid;
    };
    GridApi.prototype.setGridData = function (dataSource) {
        this.blotter.setGridData(dataSource);
    };
    GridApi.prototype.getColumns = function () {
        return this.getGridState().Columns;
    };
    GridApi.prototype.getSelectedCellInfo = function () {
        return this.getGridState().SelectedCellInfo;
    };
    GridApi.prototype.getSelectedRowInfo = function () {
        return this.getGridState().SelectedRowInfo;
    };
    GridApi.prototype.getVisibleColumns = function () {
        return this.getColumns().filter(function (c) { return c.Visible; });
    };
    GridApi.prototype.getNumericColumns = function () {
        return this.getColumns().filter(function (c) { return c.DataType == Enums_1.DataType.Number; });
    };
    GridApi.prototype.getDateColumns = function () {
        return this.getColumns().filter(function (c) { return c.DataType == Enums_1.DataType.Date; });
    };
    GridApi.prototype.getColumnSorts = function () {
        return this.getGridState().ColumnSorts;
    };
    GridApi.prototype.setValue = function (id, columnId, newValue) {
        var gridCell = {
            primaryKeyValue: id,
            columnId: columnId,
            value: newValue,
        };
        this.setGridCell(gridCell);
    };
    GridApi.prototype.setGridCell = function (gridCell) {
        this.blotter.setValue(gridCell);
    };
    GridApi.prototype.setGridCellBatch = function (gridCells) {
        this.blotter.setValueBatch(gridCells);
    };
    return GridApi;
}(ApiBase_1.ApiBase));
exports.GridApi = GridApi;
