import { DashboardState } from '../../PredefinedConfig/RunTimeState/DashboardState';
export interface IDashboardApi {
    GetState(): DashboardState;
    SetAvailableToolbars(availableToolbars: string[]): void;
    SetVisibleToolbars(visibleToolbars: string[]): void;
    ShowToolbar(visibleToolbar: string): void;
    HideToolbar(visibleToolbar: string): void;
    SetVisibleButtons(functionButtons: string[]): void;
    SetVisibility(dashboardVisibility: 'Minimised' | 'Visible' | 'Hidden'): void;
    Show(): void;
    Hide(): void;
    ShowSystemStatusButton(): void;
    HideSystemStatusButton(): void;
    ShowGridInfoButton(): void;
    HideGridInfoButton(): void;
    ShowFunctionsDropdown(): void;
    HideFunctionsDropdown(): void;
    ShowColumnsDropdown(): void;
    HideColumnsDropdown(): void;
    SetHomeToolbarTitle(title: string): void;
    SetApplicationToolbarTitle(title: string): void;
    Minimise(): void;
}
