import { ApiBase } from './ApiBase';
import { IInternalApi } from './Interface/IInternalApi';
import { IUIConfirmation } from '../Utilities/Interface/IMessage';
import { AdaptableBlotterMenuItem } from '../Utilities/Interface/AdaptableBlotterMenu';
import { ExportDestination } from '../PredefinedConfig/Common/Enums';
import { ILiveReport } from '../Utilities/Interface/Reports/ILiveReport';
import { Report } from '../PredefinedConfig/RunTimeState/ExportState';
import { SystemState } from '../PredefinedConfig/InternalState/SystemState';
import { Calendar } from '../PredefinedConfig/RunTimeState/CalendarState';
import { ChartData } from '../PredefinedConfig/RunTimeState/ChartState';
import { ChartVisibility } from '../PredefinedConfig/Common/ChartEnums';
export declare class InternalApi extends ApiBase implements IInternalApi {
    startLiveReport(report: Report, workbookName: string, exportDestination: ExportDestination.OpenfinExcel | ExportDestination.iPushPull): void;
    getSystemState(): SystemState;
    getAvailableCalendars(): Calendar[];
    setChartData(chartData: ChartData): void;
    setChartVisibility(chartVisbility: ChartVisibility): void;
    getSystemReports(): Report[];
    getLiveReports(): ILiveReport[];
    clearColumnMenu(): void;
    addColumnMenuItem(menuItem: AdaptableBlotterMenuItem): void;
    showPopupConfirmation(confirmation: IUIConfirmation): void;
}
