"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var MenuRedux = require("../Redux/ActionsReducers/MenuRedux");
var PopupRedux = require("../Redux/ActionsReducers/PopupRedux");
var SystemRedux = require("../Redux/ActionsReducers/SystemRedux");
var ApiBase_1 = require("./ApiBase");
var InternalApi = /** @class */ (function (_super) {
    tslib_1.__extends(InternalApi, _super);
    function InternalApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // System Redux Actions
    InternalApi.prototype.startLiveReport = function (report, workbookName, exportDestination) {
        this.dispatchAction(SystemRedux.ReportStartLive(report, workbookName, exportDestination));
    };
    InternalApi.prototype.getSystemState = function () {
        return this.getBlotterState().System;
    };
    InternalApi.prototype.getAvailableCalendars = function () {
        return this.getSystemState().AvailableCalendars;
    };
    InternalApi.prototype.setChartData = function (chartData) {
        this.dispatchAction(SystemRedux.ChartSetChartData(chartData));
    };
    InternalApi.prototype.setChartVisibility = function (chartVisbility) {
        this.dispatchAction(SystemRedux.ChartSetChartVisibility(chartVisbility));
    };
    InternalApi.prototype.getSystemReports = function () {
        return this.getSystemState().SystemReports;
    };
    InternalApi.prototype.getLiveReports = function () {
        return this.getSystemState().CurrentLiveReports;
    };
    // Menu Redux Actions
    InternalApi.prototype.clearColumnMenu = function () {
        this.dispatchAction(MenuRedux.ClearColumntMenu());
    };
    InternalApi.prototype.addColumnMenuItem = function (menuItem) {
        this.dispatchAction(MenuRedux.AddItemColumntMenu(menuItem));
    };
    // Popup Redux Actions
    InternalApi.prototype.showPopupConfirmation = function (confirmation) {
        this.dispatchAction(PopupRedux.PopupShowConfirmation(confirmation));
    };
    return InternalApi;
}(ApiBase_1.ApiBase));
exports.InternalApi = InternalApi;
