"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var PercentBarRedux = require("../Redux/ActionsReducers/PercentBarRedux");
var ApiBase_1 = require("./ApiBase");
var PercentBarApi = /** @class */ (function (_super) {
    tslib_1.__extends(PercentBarApi, _super);
    function PercentBarApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentBarApi.prototype.getPercentBarState = function () {
        return this.getBlotterState().PercentBar;
    };
    PercentBarApi.prototype.getAllPercentBar = function () {
        return this.getPercentBarState().PercentBars;
    };
    PercentBarApi.prototype.getPercentBarByColumn = function (columnId) {
        var percentBar = this.getBlotterState().PercentBar.PercentBars.find(function (pcb) { return pcb.ColumnId == columnId; });
        return percentBar;
    };
    PercentBarApi.prototype.addPercentBar = function (percentBar) {
        this.dispatchAction(PercentBarRedux.PercentBarAdd(percentBar));
    };
    PercentBarApi.prototype.createPercentBar = function (columnId, minValue, maxValue, positiveColor, negativeColor, showValue) {
        var percentBar = {
            ColumnId: columnId,
            MinValue: minValue,
            MaxValue: maxValue,
            PositiveColor: positiveColor,
            NegativeColor: negativeColor,
            ShowValue: showValue,
        };
        this.addPercentBar(percentBar);
    };
    PercentBarApi.prototype.editPercentBar = function (percentBar) {
        var index = this.getAllPercentBar().findIndex(function (pcb) { return pcb.ColumnId == percentBar.ColumnId; });
        this.dispatchAction(PercentBarRedux.PercentBarEdit(percentBar));
    };
    PercentBarApi.prototype.editPercentBarMinValue = function (minValue, columnId) {
        var percentBar = this.getPercentBarByColumn(columnId);
        percentBar.MinValue = minValue;
        this.editPercentBar(percentBar);
    };
    PercentBarApi.prototype.editPercentBarMaxValue = function (maxValue, columnId) {
        var percentBar = this.getPercentBarByColumn(columnId);
        percentBar.MaxValue = maxValue;
        this.editPercentBar(percentBar);
    };
    PercentBarApi.prototype.editPercentBarPositiveColor = function (positiveColor, columnId) {
        var percentBar = this.getPercentBarByColumn(columnId);
        percentBar.PositiveColor = positiveColor;
        this.editPercentBar(percentBar);
    };
    PercentBarApi.prototype.editPercentBarNegativeColor = function (negativeColor, columnId) {
        var percentBar = this.getPercentBarByColumn(columnId);
        percentBar.NegativeColor = negativeColor;
        this.editPercentBar(percentBar);
    };
    PercentBarApi.prototype.editPercentBarShowValue = function (showValue, columnId) {
        var percentBar = this.getPercentBarByColumn(columnId);
        percentBar.ShowValue = showValue;
        this.editPercentBar(percentBar);
    };
    PercentBarApi.prototype.deletePercentBar = function (columnId) {
        var percentBar = this.getAllPercentBar().find(function (pcb) { return pcb.ColumnId == columnId; });
        this.dispatchAction(PercentBarRedux.PercentBarDelete(percentBar));
    };
    return PercentBarApi;
}(ApiBase_1.ApiBase));
exports.PercentBarApi = PercentBarApi;
