"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var QuickSearchRedux = require("../Redux/ActionsReducers/QuickSearchRedux");
var ApiBase_1 = require("./ApiBase");
var QuickSearchApi = /** @class */ (function (_super) {
    tslib_1.__extends(QuickSearchApi, _super);
    function QuickSearchApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    QuickSearchApi.prototype.getQuickSearchState = function () {
        return this.getBlotterState().QuickSearch;
    };
    QuickSearchApi.prototype.setQuickSearchState = function (quickSearchState) {
        var currentQuickSearchState = this.getQuickSearchState();
        // apply QuickSearch if different
        if (currentQuickSearchState.QuickSearchText != quickSearchState.QuickSearchText) {
            this.applyQuickSearch(quickSearchState.QuickSearchText);
        }
        if (currentQuickSearchState.DisplayAction != quickSearchState.DisplayAction) {
            this.setQuickSearchDisplayAction(quickSearchState.DisplayAction);
        }
        if (currentQuickSearchState.Style != quickSearchState.Style) {
            this.setQuickSearchStyle(quickSearchState.Style);
        }
    };
    QuickSearchApi.prototype.applyQuickSearch = function (quickSearchText) {
        this.dispatchAction(QuickSearchRedux.QuickSearchApply(quickSearchText));
    };
    QuickSearchApi.prototype.clearQuickSearch = function () {
        this.dispatchAction(QuickSearchRedux.QuickSearchApply(''));
    };
    QuickSearchApi.prototype.getQuickSearchValue = function () {
        return this.getQuickSearchState().QuickSearchText;
    };
    QuickSearchApi.prototype.getQuickSearchStyle = function () {
        return this.getQuickSearchState().Style;
    };
    QuickSearchApi.prototype.getQuickSearchDisplayAction = function () {
        return this.getQuickSearchState().DisplayAction;
    };
    QuickSearchApi.prototype.setQuickSearchDisplayAction = function (displayAction) {
        this.dispatchAction(QuickSearchRedux.QuickSearchSetDisplay(displayAction));
    };
    QuickSearchApi.prototype.setQuickSearchStyle = function (style) {
        this.dispatchAction(QuickSearchRedux.QuickSearchSetStyle(style));
    };
    return QuickSearchApi;
}(ApiBase_1.ApiBase));
exports.QuickSearchApi = QuickSearchApi;
