"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var SystemFilterRedux = require("../Redux/ActionsReducers/SystemFilterRedux");
var UserFilterRedux = require("../Redux/ActionsReducers/UserFilterRedux");
var ApiBase_1 = require("./ApiBase");
var FilterHelper_1 = require("../Utilities/Helpers/FilterHelper");
var SystemFilterApi = /** @class */ (function (_super) {
    tslib_1.__extends(SystemFilterApi, _super);
    function SystemFilterApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SystemFilterApi.prototype.getSystemFilterState = function () {
        return this.getBlotterState().SystemFilter;
    };
    SystemFilterApi.prototype.setSystemFilterByUserFilters = function (userFilters) {
        var _this = this;
        userFilters.forEach(function (uf) {
            _this.dispatchAction(UserFilterRedux.UserFilterAdd(uf));
        });
    };
    SystemFilterApi.prototype.setSystemFilter = function (systemFilters) {
        this.dispatchAction(SystemFilterRedux.SystemFilterSet(systemFilters));
    };
    SystemFilterApi.prototype.clearSystemFilter = function () {
        this.dispatchAction(SystemFilterRedux.SystemFilterSet([]));
    };
    SystemFilterApi.prototype.getCurrentSystemFilter = function () {
        return this.getBlotterState().SystemFilter.SystemFilters;
    };
    SystemFilterApi.prototype.getAllSystemFilter = function () {
        return FilterHelper_1.FilterHelper.GetAllSystemFilters();
    };
    return SystemFilterApi;
}(ApiBase_1.ApiBase));
exports.SystemFilterApi = SystemFilterApi;
