"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var SystemRedux = require("../Redux/ActionsReducers/SystemRedux");
var ApiBase_1 = require("./ApiBase");
var Enums_1 = require("../PredefinedConfig/Common/Enums");
var SystemStatusApi = /** @class */ (function (_super) {
    tslib_1.__extends(SystemStatusApi, _super);
    function SystemStatusApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SystemStatusApi.prototype.setSystemStatus = function (statusMessage, messageType) {
        var systemStatus = {
            StatusMessage: statusMessage,
            StatusType: messageType,
        };
        this.dispatchAction(SystemRedux.SystemSetHealthStatus(systemStatus));
    };
    SystemStatusApi.prototype.setErrorSystemStatus = function (statusMessage) {
        var systemStatus = {
            StatusMessage: statusMessage,
            StatusType: Enums_1.MessageType.Error,
        };
        this.dispatchAction(SystemRedux.SystemSetHealthStatus(systemStatus));
    };
    SystemStatusApi.prototype.setWarningSystemStatus = function (statusMessage) {
        var systemStatus = {
            StatusMessage: statusMessage,
            StatusType: Enums_1.MessageType.Warning,
        };
        this.dispatchAction(SystemRedux.SystemSetHealthStatus(systemStatus));
    };
    SystemStatusApi.prototype.setSuccessSystemStatus = function (statusMessage) {
        var systemStatus = {
            StatusMessage: statusMessage,
            StatusType: Enums_1.MessageType.Success,
        };
        this.dispatchAction(SystemRedux.SystemSetHealthStatus(systemStatus));
    };
    SystemStatusApi.prototype.setInfoSystemStatus = function (statusMessage) {
        var systemStatus = {
            StatusMessage: statusMessage,
            StatusType: Enums_1.MessageType.Info,
        };
        this.dispatchAction(SystemRedux.SystemSetHealthStatus(systemStatus));
    };
    SystemStatusApi.prototype.clearSystemStatus = function () {
        this.dispatchAction(SystemRedux.SystemClearHealthStatus());
    };
    return SystemStatusApi;
}(ApiBase_1.ApiBase));
exports.SystemStatusApi = SystemStatusApi;
