"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ThemeRedux = require("../Redux/ActionsReducers/ThemeRedux");
var ApiBase_1 = require("./ApiBase");
var ThemeApi = /** @class */ (function (_super) {
    tslib_1.__extends(ThemeApi, _super);
    function ThemeApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ThemeApi.prototype.getThemeState = function () {
        return this.getBlotterState().Theme;
    };
    ThemeApi.prototype.setTheme = function (theme) {
        this.dispatchAction(ThemeRedux.ThemeSelect(theme));
    };
    ThemeApi.prototype.setLightTheme = function () {
        this.setTheme('light');
    };
    ThemeApi.prototype.setDarkTheme = function () {
        this.setTheme('dark');
    };
    ThemeApi.prototype.getCurrentTheme = function () {
        return this.getBlotterState().Theme.CurrentTheme;
    };
    ThemeApi.prototype.setSystemThemes = function (systemThemes) {
        this.dispatchAction(ThemeRedux.ThemeSetSystemThemes(systemThemes));
    };
    ThemeApi.prototype.setUserThemes = function (userThemes) {
        this.dispatchAction(ThemeRedux.ThemeSetUserThemes(userThemes));
    };
    ThemeApi.prototype.getAllSystemTheme = function () {
        var themes = this.getBlotterState().Theme.SystemThemes;
        return themes.map(function (theme) {
            if (typeof theme === 'string') {
                return {
                    Name: theme,
                    Description: theme,
                };
            }
            return theme;
        });
    };
    ThemeApi.prototype.getAllUserTheme = function () {
        return this.getBlotterState().Theme.UserThemes;
    };
    ThemeApi.prototype.getAllTheme = function () {
        return tslib_1.__spread(this.getAllSystemTheme(), this.getAllUserTheme());
    };
    return ThemeApi;
}(ApiBase_1.ApiBase));
exports.ThemeApi = ThemeApi;
