import { ApiBase } from './ApiBase';
import { IUserInterfaceApi } from './Interface/IUserInterfaceApi';
import { UserInterfaceState, PermittedColumnValues, EditLookUpColumn } from '../PredefinedConfig/DesignTimeState/UserInterfaceState';
export declare class UserInterfaceApi extends ApiBase implements IUserInterfaceApi {
    getUserInterfaceState(): UserInterfaceState;
    setColorPalette(colorPalette: string[]): void;
    addColorsToPalette(colorPalette: string[]): void;
    addStyleClassNames(styleClassNames: string[]): void;
    getAllPermittedValues(): PermittedColumnValues[];
    getPermittedValuesForColumn(columnId: string): PermittedColumnValues;
    setColumnPermittedValues(column: string, permittedValues: string[]): void;
    clearColumnPermittedValues(column: string): void;
    getAllEditLookUpColumns(): EditLookUpColumn[];
    getEditLookUpColumnForColumn(columnId: string): EditLookUpColumn;
    isEditLookUpColumn(columnId: string): boolean;
}
