"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var FlashingCellsStrategy_1 = require("../../Strategy/FlashingCellsStrategy");
var IDataService_1 = require("../../Utilities/Services/Interface/IDataService");
var FlashingCellsStrategyHypergrid = /** @class */ (function (_super) {
    tslib_1.__extends(FlashingCellsStrategyHypergrid, _super);
    function FlashingCellsStrategyHypergrid(blotter) {
        return _super.call(this, blotter) || this;
    }
    FlashingCellsStrategyHypergrid.prototype.initStyles = function () {
        // no implemenation as we handle data source changed
    };
    FlashingCellsStrategyHypergrid.prototype.shouldHandleDataSourceChanged = function () {
        return true;
    };
    FlashingCellsStrategyHypergrid.prototype.FlashCell = function (dataChangedInfo, flashingCell) {
        var theBlotter = this.blotter;
        if (dataChangedInfo.OldValue == null) {
            // currently should never happen
            dataChangedInfo.OldValue = this.blotter.DataService.GetPreviousColumnValue(dataChangedInfo.ColumnId, dataChangedInfo.IdentifierValue, dataChangedInfo.NewValue, IDataService_1.ChangeDirection.Ignore);
        }
        if (dataChangedInfo.OldValue != dataChangedInfo.NewValue) {
            var oldvalueNumber = Number(dataChangedInfo.OldValue);
            var newValueNumber = Number(dataChangedInfo.NewValue);
            var cellStyle = oldvalueNumber > newValueNumber ? flashingCell.DownColor : flashingCell.UpColor;
            theBlotter.addCellStyleHypergrid(dataChangedInfo.IdentifierValue, dataChangedInfo.ColumnId, { flashBackColor: cellStyle }, flashingCell.FlashingCellDuration);
        }
    };
    return FlashingCellsStrategyHypergrid;
}(FlashingCellsStrategy_1.FlashingCellsStrategy));
exports.FlashingCellsStrategyHypergrid = FlashingCellsStrategyHypergrid;
