import { ExportState, Report, AutoExport } from '../../PredefinedConfig/RunTimeState/ExportState';
import { ExportDestination } from '../../PredefinedConfig/Common/Enums';
import * as Redux from 'redux';
export declare const EXPORT_APPLY = "EXPORT_APPLY";
export declare const REPORT_SELECT = "REPORT_SELECT";
export declare const REPORT_ADD = "REPORT_ADD";
export declare const REPORT_EDIT = "REPORT_EDIT";
export declare const REPORT_DELETE = "REPORT_DELETE";
export declare const IPP_LOGIN = "IPP_LOGIN";
export interface ExportApplyAction extends Redux.Action {
    Report: Report;
    ExportDestination: ExportDestination;
    Folder?: string;
    Page?: string;
}
export interface ReportAction extends Redux.Action {
    report: Report;
}
export interface ReportSelectAction extends Redux.Action {
    SelectedReport: string;
}
export interface ReportAddAction extends ReportAction {
}
export interface ReportEditAction extends ReportAction {
}
export interface ReportDeleteAction extends ReportAction {
}
export interface AutoExportAddUpdateAction extends Redux.Action {
    Index: number;
    AutoExport: AutoExport;
}
export interface AutoExportDeleteAction extends Redux.Action {
    Index: number;
}
export interface IPPLoginAction extends Redux.Action {
    Login: string;
    Password: string;
}
export declare const ReportSelect: (SelectedReport: string) => ReportSelectAction;
export declare const ReportAdd: (report: Report) => ReportAddAction;
export declare const ReportEdit: (report: Report) => ReportEditAction;
export declare const ReportDelete: (report: Report) => ReportDeleteAction;
export declare const ExportApply: (Report: Report, ExportDestination: ExportDestination, Folder?: string, Page?: string) => ExportApplyAction;
export declare const IPPLogin: (Login: string, Password: string) => IPPLoginAction;
export declare const ExportReducer: Redux.Reducer<ExportState>;
