"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var GeneralConstants_1 = require("../../Utilities/Constants/GeneralConstants");
var Uuid_1 = require("../../PredefinedConfig/Uuid");
exports.EXPORT_APPLY = 'EXPORT_APPLY';
exports.REPORT_SELECT = 'REPORT_SELECT';
exports.REPORT_ADD = 'REPORT_ADD';
exports.REPORT_EDIT = 'REPORT_EDIT';
exports.REPORT_DELETE = 'REPORT_DELETE';
exports.IPP_LOGIN = 'IPP_LOGIN';
exports.ReportSelect = function (SelectedReport) { return ({
    type: exports.REPORT_SELECT,
    SelectedReport: SelectedReport,
}); };
exports.ReportAdd = function (report) { return ({
    type: exports.REPORT_ADD,
    report: report,
}); };
exports.ReportEdit = function (report) { return ({
    type: exports.REPORT_EDIT,
    report: report,
}); };
exports.ReportDelete = function (report) { return ({
    type: exports.REPORT_DELETE,
    report: report,
}); };
exports.ExportApply = function (Report, ExportDestination, Folder, Page) { return ({
    type: exports.EXPORT_APPLY,
    Report: Report,
    ExportDestination: ExportDestination,
    Folder: Folder,
    Page: Page,
}); };
exports.IPPLogin = function (Login, Password) { return ({
    type: exports.IPP_LOGIN,
    Login: Login,
    Password: Password,
}); };
var initialExportState = {
    Reports: GeneralConstants_1.EMPTY_ARRAY,
    CurrentReport: GeneralConstants_1.EMPTY_STRING,
};
exports.ExportReducer = function (state, action) {
    if (state === void 0) { state = initialExportState; }
    var reports;
    switch (action.type) {
        case exports.REPORT_SELECT:
            return Object.assign({}, state, {
                CurrentReport: action.SelectedReport,
            });
        case exports.REPORT_ADD: {
            var actionReport_1 = action.report;
            if (!actionReport_1.Uuid) {
                actionReport_1.Uuid = Uuid_1.createUuid();
            }
            reports = [].concat(state.Reports);
            reports.push(actionReport_1);
            return tslib_1.__assign({}, state, { Reports: reports });
        }
        case exports.REPORT_EDIT:
            var actionReport_2 = action.report;
            return tslib_1.__assign({}, state, { Reports: state.Reports.map(function (abObject) {
                    return abObject.Uuid === actionReport_2.Uuid ? actionReport_2 : abObject;
                }) });
        case exports.REPORT_DELETE: {
            var actionReport_3 = action.report;
            return tslib_1.__assign({}, state, { Reports: state.Reports.filter(function (abObject) { return abObject.Uuid !== actionReport_3.Uuid; }) });
        }
        default:
            return state;
    }
};
