import * as Redux from 'redux';
import { GridState } from '../../PredefinedConfig/InternalState/GridState';
import { IColumn } from '../../Utilities/Interface/IColumn';
import { SelectedCellInfo } from '../../Utilities/Interface/Selection/SelectedCellInfo';
import { ICellSummmary } from '../../Utilities/Interface/Selection/ICellSummmary';
import { ColumnSort } from '../../PredefinedConfig/RunTimeState/LayoutState';
import { GridCell } from '../../Utilities/Interface/Selection/GridCell';
import { SelectedRowInfo } from '../../Utilities/Interface/Selection/SelectedRowInfo';
export declare const GRID_SET_COLUMNS = "GRID_SET_COLUMNS";
export declare const GRID_ADD_COLUMN = "GRID_ADD_COLUMN";
export declare const GRID_EDIT_COLUMN = "GRID_EDIT_COLUMN";
export declare const GRID_HIDE_COLUMN = "GRID_HIDE_COLUMN";
export declare const GRID_SET_VALUE_LIKE_EDIT = "GRID_SET_VALUE_LIKE_EDIT";
export declare const GRID_SELECT_COLUMN = "GRID_SELECT_COLUMN";
export declare const GRID_SET_SORT = "GRID_SET_SORT";
export declare const GRID_SET_SELECTED_CELLS = "GRID_SET_SELECTED_CELLS";
export declare const GRID_SET_SELECTED_ROWS = "GRID_SET_SELECTED_ROWS";
export declare const GRID_CREATE_CELLS_SUMMARY = "GRID_CREATE_CELLS_SUMMARY";
export declare const GRID_SET_CELLS_SUMMARY = "GRID_SET_CELLS_SUMMARY";
export declare const GRID_QUICK_FILTER_BAR_SHOW = "GRID_QUICK_FILTER_BAR_SHOW";
export declare const GRID_QUICK_FILTER_BAR_HIDE = "GRID_QUICK_FILTER_BAR_HIDE";
export declare const FILTER_FORM_HIDE = "FILTER_FORM_HIDE";
export interface GridSetColumnsAction extends Redux.Action {
    Columns: IColumn[];
}
export interface GridAddColumnAction extends Redux.Action {
    Column: IColumn;
}
export interface GridEditColumnAction extends Redux.Action {
    Column: IColumn;
}
export interface GridHideColumnAction extends Redux.Action {
    ColumnId: string;
}
export interface GridSetValueLikeEditAction extends Redux.Action {
    GridCell: GridCell;
    OldValue: any;
}
export interface GridSelectColumnAction extends Redux.Action {
    ColumnId: string;
}
export interface GridSetSortAction extends Redux.Action {
    ColumnSorts: ColumnSort[];
}
export interface GridSetBlotterRestrictionsAction extends Redux.Action {
    BlotterRestrictions: string[];
}
export interface GridSetSelectedCellsAction extends Redux.Action {
    SelectedCellInfo: SelectedCellInfo;
}
export interface GridSetSelectedRowsAction extends Redux.Action {
    SelectedRowInfo: SelectedRowInfo;
}
export interface GridCreateCellSummaryAction extends Redux.Action {
}
export interface GridSetCellSummaryAction extends Redux.Action {
    CellSummary: ICellSummmary;
}
export interface QuickFilterBarShowAction extends Redux.Action {
}
export interface QuickFilterBarHideAction extends Redux.Action {
}
export interface FilterFormHideAction extends Redux.Action {
}
export declare const GridSetColumns: (Columns: IColumn[]) => GridSetColumnsAction;
export declare const GridAddColumn: (Column: IColumn) => GridAddColumnAction;
export declare const GridEditColumn: (Column: IColumn) => GridEditColumnAction;
export declare const GridHideColumn: (ColumnId: string) => GridHideColumnAction;
export declare const GridSetValueLikeEdit: (GridCell: GridCell, OldValue: any) => GridSetValueLikeEditAction;
export declare const GridSelectColumn: (ColumnId: string) => GridSelectColumnAction;
export declare const GridSetSort: (ColumnSorts: ColumnSort[]) => GridSetSortAction;
export declare const GridSetSelectedCells: (SelectedCellInfo: SelectedCellInfo) => GridSetSelectedCellsAction;
export declare const GridSetSelectedRows: (SelectedRowInfo: SelectedRowInfo) => GridSetSelectedRowsAction;
export declare const GridCreateCellSummary: () => GridCreateCellSummaryAction;
export declare const GridSetCellSummary: (CellSummary: ICellSummmary) => GridSetCellSummaryAction;
export declare const QuickFilterBarShow: () => QuickFilterBarShowAction;
export declare const QuickFilterBarHide: () => QuickFilterBarHideAction;
export declare const FilterFormHide: () => FilterFormHideAction;
export declare const GridReducer: Redux.Reducer<GridState>;
