"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var GeneralConstants_1 = require("../../Utilities/Constants/GeneralConstants");
exports.SET_MAIN_MENUITEMS = 'SET_MAIN_MENUITEMS';
exports.BUILD_COLUMN_MENU = 'BUILD_COLUMN_MENU';
exports.ADD_ITEM_COLUMN_MENU = 'ADD_ITEM_COLUMN_MENU';
exports.CLEAR_COLUMN_MENU = 'CLEAR_COLUMN_MENU';
//we do not use Redux.ActionCreator as we want to be typed safe for the arguments..... Redux.ActionCreator doesnt really make any sense to me as a consequence!!!!
exports.SetMainMenuItems = function (MenuItems) { return ({
    type: exports.SET_MAIN_MENUITEMS,
    MenuItems: MenuItems,
}); };
exports.BuildColumnMenu = function (ColumnId) { return ({
    type: exports.BUILD_COLUMN_MENU,
    ColumnId: ColumnId,
}); };
exports.AddItemColumntMenu = function (Item) { return ({
    type: exports.ADD_ITEM_COLUMN_MENU,
    Item: Item,
}); };
exports.ClearColumntMenu = function () { return ({
    type: exports.CLEAR_COLUMN_MENU,
}); };
var initialMenuState = {
    MainMenuItems: GeneralConstants_1.EMPTY_ARRAY,
    ColumnMenu: {
        ColumnId: null,
        MenuItems: GeneralConstants_1.EMPTY_ARRAY,
    },
};
exports.MenuReducer = function (state, action) {
    if (state === void 0) { state = initialMenuState; }
    switch (action.type) {
        case exports.SET_MAIN_MENUITEMS: {
            //TODO: we need to merge with the existing set of menuitems instead of replacing it.
            //it will be important we we ever allow show/hide on menus
            var actionTyped = action;
            var menuItems = actionTyped.MenuItems.sort(function (a, b) {
                return a.Label < b.Label ? -1 : a.Label > b.Label ? 1 : 0;
            });
            return Object.assign({}, state, { MainMenuItems: menuItems });
        }
        case exports.BUILD_COLUMN_MENU: {
            var actionTyped = action;
            return Object.assign({}, state, {
                ColumnMenu: {
                    ColumnId: actionTyped.ColumnId,
                    MenuItems: [],
                },
            });
        }
        case exports.CLEAR_COLUMN_MENU: {
            return Object.assign({}, state, {
                ColumnMenu: {
                    ColumnId: '',
                    MenuItems: [],
                },
            });
        }
        case exports.ADD_ITEM_COLUMN_MENU: {
            var actionTyped = action;
            return Object.assign({}, state, {
                ColumnMenu: {
                    ColumnId: state.ColumnMenu.ColumnId,
                    MenuItems: []
                        .concat(state.ColumnMenu.MenuItems, actionTyped.Item)
                        .sort(function (a, b) {
                        return a.Label < b.Label ? -1 : a.Label > b.Label ? 1 : 0;
                    }),
                },
            });
        }
        default:
            return state;
    }
};
