"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var GeneralConstants_1 = require("../../Utilities/Constants/GeneralConstants");
var Uuid_1 = require("../../PredefinedConfig/Uuid");
exports.REMINDER_ADD = 'REMINDER_ADD';
exports.REMINDER_EDIT = 'REMINDER_EDIT';
exports.REMINDER_DELETE = 'REMINDER_DELETE';
exports.ReminderAdd = function (reminder) { return ({
    type: exports.REMINDER_ADD,
    reminder: reminder,
}); };
exports.ReminderEdit = function (reminder) { return ({
    type: exports.REMINDER_EDIT,
    reminder: reminder,
}); };
exports.ReminderDelete = function (reminder) { return ({
    type: exports.REMINDER_DELETE,
    reminder: reminder,
}); };
var initialReminderState = {
    Reminders: GeneralConstants_1.EMPTY_ARRAY,
};
exports.ReminderReducer = function (state, action) {
    if (state === void 0) { state = initialReminderState; }
    var reminders;
    switch (action.type) {
        case exports.REMINDER_ADD: {
            var actionReminder = action.reminder;
            if (!actionReminder.Uuid) {
                actionReminder.Uuid = Uuid_1.createUuid();
            }
            reminders = [].concat(state.Reminders);
            reminders.push(actionReminder);
            return tslib_1.__assign({}, state, { Reminders: reminders });
        }
        case exports.REMINDER_EDIT: {
            var actionReminder_1 = action.reminder;
            return tslib_1.__assign({}, state, { Reminders: state.Reminders.map(function (abObject) {
                    return abObject.Uuid === actionReminder_1.Uuid ? actionReminder_1 : abObject;
                }) });
        }
        case exports.REMINDER_DELETE: {
            var actionReminder_2 = action.reminder;
            return tslib_1.__assign({}, state, { Reminders: state.Reminders.filter(function (abObject) { return abObject.Uuid !== actionReminder_2.Uuid; }) });
        }
        default:
            return state;
    }
};
