"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CalendarHelper_1 = require("../../Utilities/Helpers/CalendarHelper");
var Enums_1 = require("../../PredefinedConfig/Common/Enums");
var GeneralConstants_1 = require("../../Utilities/Constants/GeneralConstants");
var ReportHelper_1 = require("../../Utilities/Helpers/ReportHelper");
var ExpressionHelper_1 = require("../../Utilities/Helpers/ExpressionHelper");
/*
Bit of a mixed bag of actions but essentially its those that are related to Strategies but where we DONT want to persist state
This allows us to keep the other reducers pure in terms of everything persists
Not sure if its a good idea or not and perhaps we need 2 stores but I think its better than it was...
*/
// Health Status
exports.SYSTEM_SET_HEALTH_STATUS = 'SYSTEM_SET_HEALTH_STATUS';
exports.SYSTEM_CLEAR_HEALTH_STATUS = 'SYSTEM_CLEAR_HEALTH_STATUS';
// Alerts
exports.SYSTEM_ALERT_ADD = 'SYSTEM_ALERT_ADD';
exports.SYSTEM_ALERT_DELETE = 'SYSTEM_ALERT_DELETE';
exports.SYSTEM_ALERT_DELETE_ALL = 'SYSTEM_ALERT_DELETE_ALL';
// Live Reports
exports.REPORT_START_LIVE = 'REPORT_START_LIVE';
exports.REPORT_STOP_LIVE = 'REPORT_STOP_LIVE';
exports.SET_IPP_DOMAIN_PAGES = 'SET_IPP_DOMAIN_PAGES';
exports.REPORT_SET_ERROR_MESSAGE = 'REPORT_SET_ERROR_MESSAGE';
// Smart Edit
exports.SMARTEDIT_CHECK_CELL_SELECTION = 'SMARTEDIT_CHECK_CELL_SELECTION';
exports.SMARTEDIT_FETCH_PREVIEW = 'SMARTEDIT_FETCH_PREVIEW';
exports.SMARTEDIT_SET_VALID_SELECTION = 'SMARTEDIT_SET_VALID_SELECTION';
exports.SMARTEDIT_SET_PREVIEW = 'SMARTEDIT_SET_PREVIEW';
// Bulk Update
exports.BULK_UPDATE_CHECK_CELL_SELECTION = 'BULK_UPDATE_CHECK_CELL_SELECTION';
exports.BULK_UPDATE_SET_VALID_SELECTION = 'BULK_UPDATE_SET_VALID_SELECTION';
exports.BULK_UPDATE_SET_PREVIEW = 'BULK_UPDATE_SET_PREVIEW';
// Chart Managemet
exports.CHART_SET_CHART_DATA = 'CHART_SET_CHART_DATA';
exports.CHART_SET_CHART_VISIBILITY = 'CHART_SET_CHART_VISIBILITY';
// Error Messages
exports.CALCULATEDCOLUMN_SET_ERROR_MESSAGE = 'CALCULATEDCOLUMN_SET_ERROR_MESSAGE';
exports.CALCULATEDCOLUMN_IS_EXPRESSION_VALID = 'CALCULATEDCOLUMN_IS_EXPRESSION_VALID';
// Quick Search
exports.QUICK_SEARCH_SET_RANGE = 'QUICK_SEARCH_SET_RANGE';
exports.QUICK_SEARCH_CLEAR_RANGE = 'QUICK_SEARCH_CLEAR_RANGE';
exports.QUICK_SEARCH_SET_VISIBLE_COLUMN_EXPRESSIONS = 'QUICK_SEARCH_SET_VISIBLE_COLUMN_EXPRESSIONS';
exports.QUICK_SEARCH_CLEAR_VISIBLE_COLUMN_EXPRESSIONS = 'QUICK_SEARCH_CLEAR_VISIBLE_COLUMN_EXPRESSIONS';
// Columns
exports.SET_NEW_COLUMN_LIST_ORDER = 'SET_NEW_COLUMN_LIST_ORDER';
exports.SystemSetHealthStatus = function (SystemStatus) { return ({
    type: exports.SYSTEM_SET_HEALTH_STATUS,
    SystemStatus: SystemStatus,
}); };
exports.SystemClearHealthStatus = function () { return ({
    type: exports.SYSTEM_CLEAR_HEALTH_STATUS,
}); };
exports.SystemAlertAdd = function (Alert, MaxAlerts) { return ({
    type: exports.SYSTEM_ALERT_ADD,
    Alert: Alert,
    MaxAlerts: MaxAlerts,
}); };
exports.SystemAlertDelete = function (Index) { return ({
    type: exports.SYSTEM_ALERT_DELETE,
    Index: Index,
}); };
exports.SystemAlertDeleteAll = function () { return ({
    type: exports.SYSTEM_ALERT_DELETE_ALL,
}); };
exports.ReportStartLive = function (Report, WorkbookName, ExportDestination) { return ({
    type: exports.REPORT_START_LIVE,
    Report: Report,
    ExportDestination: ExportDestination,
    WorkbookName: WorkbookName,
}); };
exports.ReportStopLive = function (Report, ExportDestination) { return ({
    type: exports.REPORT_STOP_LIVE,
    Report: Report,
    ExportDestination: ExportDestination,
}); };
exports.SmartEditCheckCellSelection = function () { return ({
    type: exports.SMARTEDIT_CHECK_CELL_SELECTION,
}); };
exports.SmartEditSetValidSelection = function (IsValidSmartEditSelection) { return ({
    type: exports.SMARTEDIT_SET_VALID_SELECTION,
    IsValidSmartEditSelection: IsValidSmartEditSelection,
}); };
exports.SmartEditSetPreview = function (SmartEditPreviewInfo) { return ({
    type: exports.SMARTEDIT_SET_PREVIEW,
    SmartEditPreviewInfo: SmartEditPreviewInfo,
}); };
exports.BulkUpdateCheckCellSelection = function () { return ({
    type: exports.BULK_UPDATE_CHECK_CELL_SELECTION,
}); };
exports.BulkUpdateSetValidSelection = function (bulkUpdateValidationResult) { return ({
    type: exports.BULK_UPDATE_SET_VALID_SELECTION,
    bulkUpdateValidationResult: bulkUpdateValidationResult,
}); };
exports.BulkUpdateSetPreview = function (BulkUpdatePreviewInfo) { return ({
    type: exports.BULK_UPDATE_SET_PREVIEW,
    BulkUpdatePreviewInfo: BulkUpdatePreviewInfo,
}); };
exports.ChartSetChartData = function (chartData) { return ({
    type: exports.CHART_SET_CHART_DATA,
    chartData: chartData,
}); };
exports.ChartSetChartVisibility = function (ChartVisibility) { return ({
    type: exports.CHART_SET_CHART_VISIBILITY,
    ChartVisibility: ChartVisibility,
}); };
exports.CalculatedColumnSetErrorMessage = function (ErrorMsg) { return ({
    type: exports.CALCULATEDCOLUMN_SET_ERROR_MESSAGE,
    ErrorMsg: ErrorMsg,
}); };
exports.CalculatedColumnIsExpressionValid = function (expression) { return ({
    type: exports.CALCULATEDCOLUMN_IS_EXPRESSION_VALID,
    expression: expression,
}); };
exports.SetIPPDomainPages = function (IPPDomainsPages) { return ({
    type: exports.SET_IPP_DOMAIN_PAGES,
    IPPDomainsPages: IPPDomainsPages,
}); };
exports.ReportSetErrorMessage = function (ErrorMessage) { return ({
    type: exports.REPORT_SET_ERROR_MESSAGE,
    ErrorMessage: ErrorMessage,
}); };
exports.QuickSearchSetRange = function (QueryRange) { return ({
    type: exports.QUICK_SEARCH_SET_RANGE,
    QueryRange: QueryRange,
}); };
exports.QuickSearchClearRange = function () { return ({
    type: exports.QUICK_SEARCH_CLEAR_RANGE,
}); };
exports.QuickSearchSetVisibleColumnExpressions = function (Expressions) { return ({
    type: exports.QUICK_SEARCH_SET_VISIBLE_COLUMN_EXPRESSIONS,
    Expressions: Expressions,
}); };
exports.QuickSearchClearVisibleColumnExpressions = function () { return ({
    type: exports.QUICK_SEARCH_CLEAR_VISIBLE_COLUMN_EXPRESSIONS,
}); };
exports.SetNewColumnListOrder = function (VisibleColumnList) { return ({
    type: exports.SET_NEW_COLUMN_LIST_ORDER,
    VisibleColumnList: VisibleColumnList,
}); };
var initialSystemState = {
    SystemStatus: { StatusMessage: 'All good', StatusType: Enums_1.MessageType.Success },
    Alerts: GeneralConstants_1.EMPTY_ARRAY,
    AvailableCalendars: CalendarHelper_1.CalendarHelper.getSystemCalendars(),
    CurrentLiveReports: GeneralConstants_1.EMPTY_ARRAY,
    IsValidSmartEditSelection: false,
    SmartEditPreviewInfo: null,
    BulkUpdateValidationResult: { IsValid: false, Column: null },
    BulkUpdatePreviewInfo: null,
    ChartData: null,
    ChartVisibility: GeneralConstants_1.SYSTEM_DEFAULT_CHART_VISIBILITY,
    CalculatedColumnErrorMessage: GeneralConstants_1.EMPTY_STRING,
    IPPDomainsPages: GeneralConstants_1.EMPTY_ARRAY,
    SystemReports: ReportHelper_1.ReportHelper.CreateSystemReports(),
    ReportErrorMessage: GeneralConstants_1.EMPTY_STRING,
    QuickSearchRange: ExpressionHelper_1.ExpressionHelper.CreateEmptyRange(),
    QuickSearchVisibleColumnExpressions: GeneralConstants_1.EMPTY_ARRAY,
};
exports.SystemReducer = function (state, action) {
    if (state === void 0) { state = initialSystemState; }
    var alerts;
    switch (action.type) {
        case exports.SYSTEM_SET_HEALTH_STATUS:
            return Object.assign({}, state, {
                SystemStatus: action.SystemStatus,
            });
        case exports.SYSTEM_CLEAR_HEALTH_STATUS:
            return Object.assign({}, state, {
                SystemStatus: { StatusMessage: '', StatusType: 'Success' },
            });
        case exports.SYSTEM_ALERT_ADD: {
            var actionTypedAdd = action;
            alerts = [].concat(state.Alerts);
            if (alerts.length == actionTypedAdd.MaxAlerts) {
                // we have hit the maximum so remove first item (oldest)
                alerts.splice(0, 1);
            }
            alerts.push(actionTypedAdd.Alert);
            return Object.assign({}, state, { Alerts: alerts });
        }
        case exports.SYSTEM_ALERT_DELETE: {
            var actionTypedDelete = action;
            alerts = [].concat(state.Alerts);
            alerts.splice(actionTypedDelete.Index, 1);
            return Object.assign({}, state, { Alerts: alerts });
        }
        case exports.SYSTEM_ALERT_DELETE_ALL: {
            return Object.assign({}, state, { Alerts: [] });
        }
        case exports.REPORT_START_LIVE: {
            var actionTyped = action;
            var currentLiveReports = [].concat(state.CurrentLiveReports);
            currentLiveReports.push({
                ExportDestination: actionTyped.ExportDestination,
                Report: actionTyped.Report,
                WorkbookName: actionTyped.WorkbookName,
            });
            return Object.assign({}, state, { CurrentLiveReports: currentLiveReports });
        }
        case exports.REPORT_STOP_LIVE: {
            var actionTyped_1 = action;
            var currentLiveReports = [].concat(state.CurrentLiveReports);
            var index = currentLiveReports.findIndex(function (x) { return x.Report == actionTyped_1.Report && x.ExportDestination == actionTyped_1.ExportDestination; });
            currentLiveReports.splice(index, 1);
            return Object.assign({}, state, { CurrentLiveReports: currentLiveReports });
        }
        case exports.SMARTEDIT_SET_VALID_SELECTION:
            return Object.assign({}, state, {
                IsValidSmartEditSelection: action
                    .IsValidSmartEditSelection,
            });
        case exports.SMARTEDIT_SET_PREVIEW:
            return Object.assign({}, state, {
                SmartEditPreviewInfo: action.SmartEditPreviewInfo,
            });
        case exports.BULK_UPDATE_SET_VALID_SELECTION:
            return Object.assign({}, state, {
                BulkUpdateValidationResult: action
                    .bulkUpdateValidationResult,
            });
        case exports.BULK_UPDATE_SET_PREVIEW:
            return Object.assign({}, state, {
                BulkUpdatePreviewInfo: action.BulkUpdatePreviewInfo,
            });
        // Chart Actions
        case exports.CHART_SET_CHART_DATA:
            return Object.assign({}, state, { ChartData: action.chartData });
        case exports.CHART_SET_CHART_VISIBILITY:
            return Object.assign({}, state, {
                ChartVisibility: action.ChartVisibility,
            });
        case exports.CALCULATEDCOLUMN_SET_ERROR_MESSAGE: {
            return Object.assign({}, state, {
                CalculatedColumnErrorMessage: action.ErrorMsg,
            });
        }
        case exports.SET_IPP_DOMAIN_PAGES: {
            return Object.assign({}, state, {
                IPPDomainsPages: action.IPPDomainsPages,
            });
        }
        case exports.REPORT_SET_ERROR_MESSAGE: {
            return Object.assign({}, state, {
                ReportErrorMessage: action.ErrorMessage,
            });
        }
        case exports.QUICK_SEARCH_SET_RANGE: {
            return Object.assign({}, state, {
                QuickSearchRange: action.QueryRange,
            });
        }
        case exports.QUICK_SEARCH_CLEAR_RANGE: {
            return Object.assign({}, state, { QuickSearchRange: ExpressionHelper_1.ExpressionHelper.CreateEmptyRange() });
        }
        case exports.QUICK_SEARCH_SET_VISIBLE_COLUMN_EXPRESSIONS: {
            return Object.assign({}, state, {
                QuickSearchVisibleColumnExpressions: action
                    .Expressions,
            });
        }
        case exports.QUICK_SEARCH_CLEAR_VISIBLE_COLUMN_EXPRESSIONS: {
            return Object.assign({}, state, { QuickSearchVisibleColumnExpressions: GeneralConstants_1.EMPTY_ARRAY });
        }
        default:
            return state;
    }
};
