import * as Redux from 'redux';
import { IAdaptableBlotter } from '../../Utilities/Interface/IAdaptableBlotter';
import { AdaptableBlotterState, IAdaptableBlotterStore } from './Interface/IAdaptableStore';
import { ConfigState } from '../../PredefinedConfig/ConfigState';
declare type EmitterCallback = (data?: any) => any;
export declare const RESET_STATE = "RESET_STATE";
export declare const INIT_STATE = "INIT_STATE";
export declare const LOAD_STATE = "LOAD_STATE";
export interface ResetUserDataAction extends Redux.Action {
}
export interface InitStateAction extends Redux.Action {
}
export interface LoadStateAction extends Redux.Action {
    State: {
        [s: string]: ConfigState;
    };
}
export declare const ResetUserData: () => ResetUserDataAction;
export declare const InitState: () => ResetUserDataAction;
export declare const LoadState: (State: {
    [s: string]: ConfigState;
}) => LoadStateAction;
export declare class AdaptableBlotterStore implements IAdaptableBlotterStore {
    TheStore: Redux.Store<AdaptableBlotterState>;
    Load: PromiseLike<any>;
    private emitter;
    private loadStartOnStartup;
    on: (eventName: string, callback: EmitterCallback) => () => void;
    onAny: (callback: EmitterCallback) => () => void;
    emit: (eventName: string, data: any) => Promise<any>;
    constructor(blotter: IAdaptableBlotter);
}
export declare function getNonPersistedReduxActions(): string[];
export declare function getFunctionAppliedReduxActions(): string[];
export declare function getPrimaryStateReduxActions(): string[];
export {};
