"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var CalculatedColumnStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(CalculatedColumnStrategy, _super);
    function CalculatedColumnStrategy(blotter) {
        return _super.call(this, StrategyConstants.CalculatedColumnStrategyId, blotter) || this;
    }
    CalculatedColumnStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.CalculatedColumnStrategyName, ScreenPopups.CalculatedColumnPopup, StrategyConstants.CalculatedColumnGlyph);
    };
    CalculatedColumnStrategy.prototype.addColumnMenuItem = function (column) {
        if (this.canCreateColumnMenuItem(column, this.blotter)) {
            if (this.blotter.api.calculatedColumnApi
                .getAllCalculatedColumn()
                .find(function (cc) { return cc.ColumnId == column.ColumnId; })) {
                this.createColumnMenuItemShowPopup('Edit ' + StrategyConstants.CalculatedColumnStrategyName, ScreenPopups.CalculatedColumnPopup, StrategyConstants.CalculatedColumnGlyph, 'Edit|' + column.ColumnId);
            }
        }
    };
    return CalculatedColumnStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.CalculatedColumnStrategy = CalculatedColumnStrategy;
