"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var CellValidationStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(CellValidationStrategy, _super);
    function CellValidationStrategy(blotter) {
        return _super.call(this, StrategyConstants.CellValidationStrategyId, blotter) || this;
    }
    CellValidationStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.CellValidationStrategyName, ScreenPopups.CellValidationPopup, StrategyConstants.CellValidationGlyph);
    };
    CellValidationStrategy.prototype.addColumnMenuItem = function (column) {
        if (this.canCreateColumnMenuItem(column, this.blotter)) {
            this.createColumnMenuItemShowPopup('Create Cell Validation Rule', ScreenPopups.CellValidationPopup, StrategyConstants.CellValidationGlyph, 'New|' + column.ColumnId);
        }
    };
    return CellValidationStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.CellValidationStrategy = CellValidationStrategy;
