"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var ColumnFilterRedux = require("../Redux/ActionsReducers/ColumnFilterRedux");
var ColumnFilterStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(ColumnFilterStrategy, _super);
    function ColumnFilterStrategy(blotter) {
        return _super.call(this, StrategyConstants.ColumnFilterStrategyId, blotter) || this;
    }
    ColumnFilterStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.ColumnFilterStrategyName, ScreenPopups.ColumnFilterPopup, StrategyConstants.ColumnFilterGlyph);
    };
    ColumnFilterStrategy.prototype.addColumnMenuItem = function (column) {
        if (this.canCreateColumnMenuItem(column, this.blotter, 'columnfilter')) {
            var existingColumnFilter = this.blotter.api.columnFilterApi
                .getAllColumnFilter()
                .find(function (x) { return x.ColumnId == column.ColumnId; });
            if (existingColumnFilter) {
                this.createColumnMenuItemReduxAction('Clear Column Filter', StrategyConstants.ColumnFilterGlyph, ColumnFilterRedux.ColumnFilterClear(existingColumnFilter));
            }
        }
    };
    return ColumnFilterStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.ColumnFilterStrategy = ColumnFilterStrategy;
