"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var ColumnInfoStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(ColumnInfoStrategy, _super);
    function ColumnInfoStrategy(blotter) {
        return _super.call(this, StrategyConstants.ColumnInfoStrategyId, blotter) || this;
    }
    ColumnInfoStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.ColumnInfoStrategyName, ScreenPopups.ColumnInfoPopup, StrategyConstants.ColumnInfoGlyph);
    };
    ColumnInfoStrategy.prototype.addColumnMenuItem = function (column) {
        if (this.canCreateColumnMenuItem(column, this.blotter)) {
            this.createColumnMenuItemShowPopup(StrategyConstants.ColumnInfoStrategyName, ScreenPopups.ColumnInfoPopup, StrategyConstants.ColumnInfoGlyph, column.ColumnId);
        }
    };
    return ColumnInfoStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.ColumnInfoStrategy = ColumnInfoStrategy;
