"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var ConditionalStyleStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(ConditionalStyleStrategy, _super);
    function ConditionalStyleStrategy(blotter) {
        var _this = _super.call(this, StrategyConstants.ConditionalStyleStrategyId, blotter) || this;
        _this.blotter.DataService.OnDataSourceChanged().Subscribe(function (sender, eventText) {
            return _this.handleDataSourceChanged(eventText);
        });
        return _this;
    }
    ConditionalStyleStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.ConditionalStyleStrategyName, ScreenPopups.ConditionalStylePopup, StrategyConstants.ConditionalStyleGlyph);
    };
    ConditionalStyleStrategy.prototype.addColumnMenuItem = function (column) {
        if (this.canCreateColumnMenuItem(column, this.blotter)) {
            this.createColumnMenuItemShowPopup('Create ' + StrategyConstants.ConditionalStyleStrategyName, ScreenPopups.ConditionalStylePopup, StrategyConstants.ConditionalStyleGlyph, 'New|' + column.ColumnId);
        }
    };
    return ConditionalStyleStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.ConditionalStyleStrategy = ConditionalStyleStrategy;
