"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var Enums_1 = require("../PredefinedConfig/Common/Enums");
var DashboardRedux = require("../Redux/ActionsReducers/DashboardRedux");
var DashboardStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(DashboardStrategy, _super);
    function DashboardStrategy(blotter) {
        return _super.call(this, StrategyConstants.DashboardStrategyId, blotter) || this;
    }
    DashboardStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.DashboardStrategyName, ScreenPopups.DashboardPopup, StrategyConstants.DashboardGlyph);
    };
    DashboardStrategy.prototype.addColumnMenuItem = function () {
        // for now just show / hide = lets worry about minimise later..
        if (this.blotter.api.dashboardApi.GetState().DashboardVisibility == Enums_1.Visibility.Hidden) {
            this.createColumnMenuItemReduxAction('Show Dashboard', StrategyConstants.DashboardGlyph, DashboardRedux.DashboardSetVisibility(Enums_1.Visibility.Visible));
        }
        else {
            this.createColumnMenuItemReduxAction('Hide Dashboard', StrategyConstants.DashboardGlyph, DashboardRedux.DashboardSetVisibility(Enums_1.Visibility.Hidden));
        }
    };
    return DashboardStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.DashboardStrategy = DashboardStrategy;
