import { AdaptableStrategyBase } from './AdaptableStrategyBase';
import { IAdaptableBlotter } from '../Utilities/Interface/IAdaptableBlotter';
import { IFlashingCellsStrategy } from './Interface/IFlashingCellsStrategy';
import { FlashingCell } from '../PredefinedConfig/RunTimeState/FlashingCellState';
import { IColumn } from '../Utilities/Interface/IColumn';
import { DataChangedInfo } from '../Utilities/Interface/DataChangedInfo';
export declare abstract class FlashingCellsStrategy extends AdaptableStrategyBase implements IFlashingCellsStrategy {
    constructor(blotter: IAdaptableBlotter);
    protected addPopupMenuItem(): void;
    addColumnMenuItem(column: IColumn): void;
    abstract initStyles(): void;
    protected handleDataSourceChanged(dataChangedInfo: DataChangedInfo): void;
    protected abstract shouldHandleDataSourceChanged(): boolean;
    protected abstract FlashCell(dataChangedInfo: DataChangedInfo, flashingCell: FlashingCell): void;
}
