"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var ArrayExtensions_1 = require("../Utilities/Extensions/ArrayExtensions");
var FormatColumnStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(FormatColumnStrategy, _super);
    function FormatColumnStrategy(blotter) {
        return _super.call(this, StrategyConstants.FormatColumnStrategyId, blotter) || this;
    }
    FormatColumnStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.FormatColumnStrategyName, ScreenPopups.FormatColumnPopup, StrategyConstants.FormatColumnGlyph);
    };
    FormatColumnStrategy.prototype.addColumnMenuItem = function (column) {
        if (this.canCreateColumnMenuItem(column, this.blotter)) {
            var formatExists = ArrayExtensions_1.ArrayExtensions.ContainsItem(this.blotter.api.formatColumnApi.getAllFormatColumn().map(function (f) { return f.ColumnId; }), column.ColumnId);
            var label = formatExists ? 'Edit ' : 'Create ';
            var popupParam = formatExists ? 'Edit|' : 'New|';
            this.createColumnMenuItemShowPopup(label + StrategyConstants.FormatColumnStrategyName, ScreenPopups.FormatColumnPopup, StrategyConstants.FormatColumnGlyph, popupParam + column.ColumnId);
        }
    };
    return FormatColumnStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.FormatColumnStrategy = FormatColumnStrategy;
