"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var FreeTextColumnStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(FreeTextColumnStrategy, _super);
    function FreeTextColumnStrategy(blotter) {
        return _super.call(this, StrategyConstants.FreeTextColumnStrategyId, blotter) || this;
    }
    FreeTextColumnStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.FreeTextColumnStrategyName, ScreenPopups.FreeTextColumnPopup, StrategyConstants.FreeTextColumnGlyph);
    };
    FreeTextColumnStrategy.prototype.addColumnMenuItem = function (column) {
        if (this.canCreateColumnMenuItem(column, this.blotter)) {
            if (this.blotter.api.freeTextColumnApi
                .getAllFreeTextColumn()
                .find(function (ftc) { return ftc.ColumnId == column.ColumnId; })) {
                this.createColumnMenuItemShowPopup('Edit ' + StrategyConstants.FreeTextColumnStrategyName, ScreenPopups.FreeTextColumnPopup, StrategyConstants.FreeTextColumnGlyph, 'Edit|' + column.ColumnId);
            }
        }
    };
    return FreeTextColumnStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.FreeTextColumnStrategy = FreeTextColumnStrategy;
