"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var PieChartStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(PieChartStrategy, _super);
    function PieChartStrategy(blotter) {
        return _super.call(this, StrategyConstants.PieChartStrategyId, blotter) || this;
    }
    PieChartStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.PieChartStrategyName, ScreenPopups.PieChartPopup, StrategyConstants.PieChartGlyph);
    };
    PieChartStrategy.prototype.addColumnMenuItem = function (column) {
        if (this.canCreateColumnMenuItem(column, this.blotter)) {
            this.createColumnMenuItemShowPopup('See as Pie Chart', ScreenPopups.PieChartPopup, StrategyConstants.PieChartGlyph, column.ColumnId);
        }
    };
    return PieChartStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.PieChartStrategy = PieChartStrategy;
