"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var GeneralConstants_1 = require("../Utilities/Constants/GeneralConstants");
var ReminderStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(ReminderStrategy, _super);
    function ReminderStrategy(blotter) {
        var _this = _super.call(this, StrategyConstants.ReminderStrategyId, blotter) || this;
        //this.blotter.onGridReloaded().Subscribe(() => this.handleGridReloaded());
        _this.blotter.on(GeneralConstants_1.GRID_RELOADED_EVENT, function () {
            _this.scheduleReminders();
        });
        return _this;
    }
    ReminderStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.ReminderStrategyName, ScreenPopups.ReminderPopup, StrategyConstants.ReminderGlyph);
    };
    ReminderStrategy.prototype.scheduleReminders = function () {
        var _this = this;
        // just clear all jobs and recreate - simplest thing to do...
        this.blotter.ScheduleService.ClearAllAlertJobs();
        this.blotter.api.reminderApi.getAllReminder().forEach(function (r) {
            _this.blotter.ScheduleService.AddReminderSchedule(r);
        });
    };
    return ReminderStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.ReminderStrategy = ReminderStrategy;
