"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var BlotterHelper_1 = require("../Utilities/Helpers/BlotterHelper");
var TeamSharingStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(TeamSharingStrategy, _super);
    function TeamSharingStrategy(blotter) {
        return _super.call(this, StrategyConstants.TeamSharingStrategyId, blotter) || this;
    }
    TeamSharingStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.TeamSharingStrategyName, ScreenPopups.TeamSharingPopup, StrategyConstants.TeamSharingGlyph);
    };
    TeamSharingStrategy.prototype.hasPopupMenu = function () {
        return BlotterHelper_1.BlotterHelper.isConfigServerEnabled(this.blotter.blotterOptions);
    };
    return TeamSharingStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.TeamSharingStrategy = TeamSharingStrategy;
