"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var ThemeStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(ThemeStrategy, _super);
    function ThemeStrategy(blotter) {
        return _super.call(this, StrategyConstants.ThemeStrategyId, blotter) || this;
    }
    ThemeStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.ThemeStrategyName, ScreenPopups.ThemePopup, StrategyConstants.ThemeGlyph);
    };
    ThemeStrategy.prototype.publishThemeChanged = function (themeState) {
        var themeName = themeState.CurrentTheme;
        var themeChangedInfo = {
            themeName: themeName,
        };
        this.blotter.api.eventApi._onThemeChanged.Dispatch(this.blotter, themeChangedInfo);
    };
    ThemeStrategy.prototype.InitState = function () {
        var _this = this;
        if (this.ThemeState != this.blotter.api.themeApi.getThemeState()) {
            this.ThemeState = this.blotter.api.themeApi.getThemeState();
            // publish the theme changed event even on initialization
            this.publishThemeChanged(this.ThemeState);
            var allThemeNames = tslib_1.__spread((this.ThemeState.SystemThemes || []), (this.ThemeState.UserThemes || []));
            var currentTheme = allThemeNames.filter(function (theme) {
                return typeof theme === 'string'
                    ? theme === _this.ThemeState.CurrentTheme
                    : theme.Name === _this.ThemeState.CurrentTheme;
            })[0];
            if (!currentTheme) {
                return;
            }
            this.blotter.applyBlotterTheme(currentTheme);
        }
    };
    return ThemeStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.ThemeStrategy = ThemeStrategy;
