"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var AdaptableStrategyBase_1 = require("./AdaptableStrategyBase");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../Utilities/Constants/ScreenPopups");
var UserFilterStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(UserFilterStrategy, _super);
    function UserFilterStrategy(blotter) {
        return _super.call(this, StrategyConstants.UserFilterStrategyId, blotter) || this;
    }
    UserFilterStrategy.prototype.addPopupMenuItem = function () {
        this.createMenuItemShowPopup(StrategyConstants.UserFilterStrategyName, ScreenPopups.UserFilterPopup, StrategyConstants.UserFilterGlyph);
    };
    UserFilterStrategy.prototype.addColumnMenuItem = function (column) {
        if (this.canCreateColumnMenuItem(column, this.blotter, 'columnfilter')) {
            this.createColumnMenuItemShowPopup('Create User Filter', ScreenPopups.UserFilterPopup, StrategyConstants.UserFilterGlyph, 'New|' + column.ColumnId);
        }
    };
    return UserFilterStrategy;
}(AdaptableStrategyBase_1.AdaptableStrategyBase));
exports.UserFilterStrategy = UserFilterStrategy;
