"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Enums_1 = require("../../PredefinedConfig/Common/Enums");
var ChartEnums_1 = require("../../PredefinedConfig/Common/ChartEnums");
exports.MISSING_COLUMN = ' [MISSING]';
exports.DEFAULT_LAYOUT = 'Ab_Default_Layout';
exports.LIGHT_THEME = 'light';
exports.DARK_THEME = 'dark';
exports.USER_NAME = 'anonymous';
exports.BLOTTER_ID = 'adaptable_blotter_id';
exports.MENU_PREFIX = 'ab_';
exports.READ_ONLY_STYLE = 'ab_readonly';
exports.ALL_COLUMN_VALUES = 'ALL_COLUMN_VALUES';
exports.FILTER_ALWAYS = 'Always';
exports.FILTER_NEVER = 'Never';
exports.EMPTY_STRING = '';
exports.EMPTY_ARRAY = [];
exports.HALF_SECOND = 500;
exports.DEFAULT_DARK_GREEN_COLOR = '#008000';
exports.DEFAULT_DARK_RED_COLOR = '#FF0000';
exports.YEAR_ADD = 1985;
exports.MONTH_ADD = 47;
/*
Redux / State Defaults
Try to put all our Redux / State defaults here and ONLY reference from here - avoid magic numbers / strings.
Please!!!
*/
// Alert
exports.ALERT_DEFAULT_MAX_ALERTS_IN_STORE = 20;
// Calendar
exports.CALENDAR_DEFAULT_CURRENT_CALENDER = 'United States';
// Charts
exports.CHART_DEFAULT_REFRESH_RATE = 3; // refresh the chart every 3 seconds if stuff chnanges
// Quick Search
exports.QUICK_SEARCH_DEFAULT_DISPLAY_ACTION = Enums_1.DisplayAction.HighlightCell;
exports.QUICK_SEARCH_DEFAULT_BACK_COLOR = '#FFFFCC';
exports.QUICK_SEARCH_DEFAULT_FORE_COLOR = '#000000';
// Flashing Cells
exports.FLASHING_CELLS_DEFAULT_DURATION = 500;
// Selected Cells
exports.SMART_EDIT_DEFAULT_VALUE = 1;
exports.SMART_EDIT_DEFAULT_OPERATION = Enums_1.MathOperation.Multiply;
// Cells Summary
exports.CELL_SUMMARY_DEFAULT_OPERATION = Enums_1.CellSummaryOperation.Sum;
// system
exports.SYSTEM_DEFAULT_CHART_VISIBILITY = ChartEnums_1.ChartVisibility.Hidden;
// export const SYSTEM_DEFAULT_SYSTEM_STATUS_COLOUR: 'Red' | 'Amber' | 'Green' | 'Blue' =
//  StatusColour.Green;
exports.SYSTEM_DEFAULT_SYSTEM_STATUS_TYPE = Enums_1.MessageType.Info;
// theme
exports.THEME_DEFAULT_CURRENT_THEME = exports.LIGHT_THEME;
/**
 * Object Factory
 */
exports.CHART_DEFAULT_YAXIS_TOTAL = ChartEnums_1.AxisTotal.Sum;
exports.PLUS_MINUS_DEFAULT_NUDGE_VALUE = 1;
exports.ALERT_DEFAULT_OPERATOR = Enums_1.LeafExpressionOperator.AnyChange;
exports.ALERT_DEFAULT_RANGE_OPERAND_TYPE = 'Column';
exports.ALERT_DEFAULT_MESSAGE_TYPE = 'Error';
exports.ALERT_DEFAULT_SHOW_AS_POPUP = true;
/**
 * Constants for State (primarily for audit property events) - good idea?
 */
exports.CURRENT_ADVANCED_SEARCH_STATE_PROPERTY = 'CurrentAdvancedSearch';
exports.CURRENT_CHART_NAME_STATE_PROPERTY = 'CurrentChartName';
exports.BULK_UPDATE_VALUE_STATE_PROPERTY = 'BulkUpdateValue';
exports.CURRENT_CALENDAR_STATE_PROPERTY = 'CurrentCalendar';
exports.SUMMARY_OPERATION_STATE_PROPERTY = 'SummaryOperation';
exports.CURRENT_LAYOUT_STATE_PROPERTY = 'CurrentLayout';
exports.CURRENT_DATA_SOURCE_STATE_PROPERTY = 'CurrentDataSource';
exports.CURRENT_REPORT_STATE_PROPERTY = 'CurrentReport';
exports.FLASHING_CELL_DEFAULT_UP_COLOR_STATE_PROPERTY = 'DefaultUpColor';
exports.FLASHING_CELL_DEFAULT_DOWN_COLOR_STATE_PROPERTY = 'DefautDownColor';
exports.FLASHING_CELL_DEFAULT_DURATION_STATE_PROPERTY = 'DefaultDuration';
exports.CURRENT_THEME_STATE_PROPERTY = 'CurrentTheme';
exports.QUICK_SEARCH_TEXT_STATE_PROPERTY = 'QuickSearchText';
exports.QUICK_SEARCH_DISPLAY_ACTION_STATE_PROPERTY = 'DisplayAction';
exports.QUICK_SEARCH_STYLE_STATE_PROPERTY = 'Style';
exports.SMART_EDIT_VALUE_STATE_PROPERTY = 'SmartEditValue';
exports.SMART_EDIT_MATH_OPERATION_STATE_PROPERTY = 'MathOperationz';
// consts for Themes
exports.SYSTEM_THEMES = [
    {
        Name: exports.LIGHT_THEME,
        Description: 'Light Theme',
    },
    {
        Name: exports.DARK_THEME,
        Description: 'Dark Theme',
    },
];
// these are the internal events that the AB fires that other strategies and classes listen to
// put in another file?
exports.BLOTTER_READY_EVENT = 'BlotterReady';
exports.CELLS_SELECTED_EVENT = 'CellsSelected';
exports.ROWS_SELECTED_EVENT = 'RowsSelected';
exports.SEARCH_APPLIED_EVENT = 'SearchApplied';
exports.GRID_REFRESHED_EVENT = 'GridRefreshed';
exports.GRID_RELOADED_EVENT = 'GridReloaded';
exports.KEY_DOWN_EVENT = 'KeyDown';
