import { SortOrder } from '../../PredefinedConfig/Common/Enums';
export declare function GetLength(arrayToCheck: any[]): number;
export declare function CorrectLength(arrayToCheck: any[], requiredLength: number): boolean;
export declare function NotCorrectLength(arrayToCheck: any[], requiredLength: number): boolean;
export declare function AddItem(array: any[], itemToAdd: any): void;
export declare function ContainsItem(array: any[], itemToCheck: any): boolean;
export declare function NotContainsItem(array: any[], itemToCheck: any): boolean;
export declare function RetrieveDistinct(array: any[]): any[];
export declare function IsNull(arrayToCheck: any[] | undefined | null): boolean;
export declare function IsNotNull(arrayToCheck: any[] | undefined | null): boolean;
export declare function IsEmpty(arrayToCheck: any[]): boolean;
export declare function IsNotEmpty(arrayToCheck: any[]): boolean;
export declare function IsNullOrEmpty(arrayToCheck: any[]): boolean;
export declare function IsNotNullOrEmpty(arrayToCheck: any[] | undefined | null): boolean;
export declare function hasOneItem(arrayToCheck: any[]): boolean;
export declare function hasItemsOfCount(arrayToCheck: any[], numberOfItems: number): boolean;
export declare function moveArray(array: any[], from: number, to: number): void;
export declare function areArraysEqual(arr1: any[], arr2: any[]): boolean;
export declare function areArraysNotEqual(arr1: any[], arr2: any[]): boolean;
export declare function areArraysEqualWithOrder(arr1: any[], arr2: any[]): boolean;
export declare function areArraysEqualWithOrderandProperties(value: any[], other: any[]): boolean;
export declare function sortArrayWithProperty(sortOrder: SortOrder, values: any[], sortProperty?: string): any[];
export declare function sortArray(values: any[], sortOrder?: SortOrder): any[];
export declare function groupArrayBy(array: Array<any>, prop: string): Array<any>;
export declare function createCommaSeparatedString(values: any[]): string;
export declare const ArrayExtensions: {
    GetLength: typeof GetLength;
    CorrectLength: typeof CorrectLength;
    NotCorrectLength: typeof NotCorrectLength;
    groupArrayBy: typeof groupArrayBy;
    AddItem: typeof AddItem;
    ContainsItem: typeof ContainsItem;
    NotContainsItem: typeof NotContainsItem;
    RetrieveDistinct: typeof RetrieveDistinct;
    IsNull: typeof IsNull;
    IsNotNull: typeof IsNotNull;
    IsEmpty: typeof IsEmpty;
    IsNotEmpty: typeof IsNotEmpty;
    IsNullOrEmpty: typeof IsNullOrEmpty;
    IsNotNullOrEmpty: typeof IsNotNullOrEmpty;
    hasOneItem: typeof hasOneItem;
    hasItemsOfCount: typeof hasItemsOfCount;
    moveArray: typeof moveArray;
    areArraysEqual: typeof areArraysEqual;
    areArraysNotEqual: typeof areArraysNotEqual;
    areArraysEqualWithOrder: typeof areArraysEqualWithOrder;
    areArraysEqualWithOrderandProperties: typeof areArraysEqualWithOrderandProperties;
    sortArray: typeof sortArray;
    sortArrayWithProperty: typeof sortArrayWithProperty;
    createCommaSeparatedString: typeof createCommaSeparatedString;
};
export default ArrayExtensions;
