"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ExpressionHelper_1 = require("./ExpressionHelper");
var ColumnHelper_1 = require("./ColumnHelper");
var Enums_1 = require("../../PredefinedConfig/Common/Enums");
var StringExtensions_1 = require("../Extensions/StringExtensions");
function createAlertDescription(alertDefinition, columns) {
    var dataType = ColumnHelper_1.ColumnHelper.getColumnDataTypeFromColumnId(alertDefinition.ColumnId, columns);
    var valueDescription = ExpressionHelper_1.ExpressionHelper.OperatorToLongFriendlyString(alertDefinition.Range.Operator, dataType);
    if (!ExpressionHelper_1.ExpressionHelper.OperatorRequiresValue(alertDefinition.Range
        .Operator)) {
        return valueDescription;
    }
    var operand1Text = dataType == Enums_1.DataType.Boolean || dataType == Enums_1.DataType.Number
        ? alertDefinition.Range.Operand1
        : "'" + alertDefinition.Range.Operand1 + "'";
    valueDescription = valueDescription + operand1Text;
    if (alertDefinition.Range.Operator == Enums_1.LeafExpressionOperator.PercentChange) {
        valueDescription = valueDescription + '%';
    }
    if (StringExtensions_1.StringExtensions.IsNotNullOrEmpty(alertDefinition.Range.Operand2)) {
        var operand2Text = dataType == Enums_1.DataType.Number
            ? ' and ' + alertDefinition.Range.Operand2
            : " and '" + alertDefinition.Range.Operand2 + "'";
        valueDescription = valueDescription + operand2Text;
    }
    return valueDescription;
}
exports.createAlertDescription = createAlertDescription;
exports.AlertHelper = {
    createAlertDescription: createAlertDescription,
};
exports.default = exports.AlertHelper;
