"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ExpressionHelper_1 = require("./ExpressionHelper");
var ColumnHelper_1 = require("./ColumnHelper");
var ArrayExtensions_1 = require("../Extensions/ArrayExtensions");
function convertColumnFiltersToKVPArray(columnFilters, columns) {
    var infoBody = [];
    columnFilters.forEach(function (x) {
        var column = ColumnHelper_1.ColumnHelper.getColumnFromId(x.ColumnId, columns);
        if (column) {
            var expression = ExpressionHelper_1.ExpressionHelper.ConvertExpressionToString(x.Filter, columns, false);
            infoBody.push({
                Key: ColumnHelper_1.ColumnHelper.getFriendlyNameFromColumnId(x.ColumnId, columns),
                Value: expression,
            });
        }
    });
    return infoBody;
}
exports.convertColumnFiltersToKVPArray = convertColumnFiltersToKVPArray;
function getColumnFiltersDescription(columnFilters, columns, blotter) {
    if (ArrayExtensions_1.ArrayExtensions.IsNullOrEmpty(columnFilters)) {
        return 'No Column Filter Active';
    }
    var stringarr = exports.ColumnFilterHelper.convertColumnFiltersToKVPArray(columnFilters, columns).map(function (kvp) {
        return kvp.Key + ': ' + kvp.Value;
    });
    return stringarr.join('; ');
}
exports.getColumnFiltersDescription = getColumnFiltersDescription;
exports.ColumnFilterHelper = {
    convertColumnFiltersToKVPArray: convertColumnFiltersToKVPArray,
    getColumnFiltersDescription: getColumnFiltersDescription,
};
exports.default = exports.ColumnFilterHelper;
