import { IColumn } from '../Interface/IColumn';
import { DataType } from '../../PredefinedConfig/Common/Enums';
import { ColumnCategory } from '../../PredefinedConfig/RunTimeState/ColumnCategoryState';
export declare function isSpecialColumn(columnId: string): boolean;
export declare function isNumericColumn(column: IColumn): boolean;
export declare function getColumnDataTypeFromColumnId(columnId: string, columns: IColumn[]): DataType;
export declare function getFriendlyNameFromColumn(columnId: string, column: IColumn): string;
export declare function getFriendlyNameFromColumnId(columnId: string, columns: IColumn[]): string;
export declare function getFriendlyNamesFromColumnIds(columnIds: string[], columns: IColumn[]): string[];
export declare function getColumnIdFromFriendlyName(friendlyName: string, columns: IColumn[]): string;
export declare function getColumnIdsFromFriendlyNames(friendlyNames: string[], columns: IColumn[]): string[];
export declare function getColumnsFromFriendlyNames(friendlyNames: string[], columns: IColumn[]): IColumn[];
export declare function getColumnFromId(columnId: string, columns: IColumn[], logWarning?: boolean): IColumn;
export declare function getColumnFromFriendlyName(columnName: string, columns: IColumn[], logWarning?: boolean): IColumn;
export declare function getColumnsOfType(columns: IColumn[], dataType: DataType): IColumn[];
export declare function getNumericColumns(columns: IColumn[]): IColumn[];
export declare function getStringColumns(columns: IColumn[]): IColumn[];
export declare function getDateColumns(columns: IColumn[]): IColumn[];
export declare function getBooleanColumns(columns: IColumn[]): IColumn[];
export declare function getColumnCategoryFromColumnCategories(columnId: string, ColumnCategoryns: ColumnCategory[]): string;
export declare function getSortableColumns(columns: IColumn[]): IColumn[];
export declare const ColumnHelper: {
    isSpecialColumn: typeof isSpecialColumn;
    isNumericColumn: typeof isNumericColumn;
    getColumnDataTypeFromColumnId: typeof getColumnDataTypeFromColumnId;
    getFriendlyNameFromColumn: typeof getFriendlyNameFromColumn;
    getFriendlyNameFromColumnId: typeof getFriendlyNameFromColumnId;
    getFriendlyNamesFromColumnIds: typeof getFriendlyNamesFromColumnIds;
    getColumnsFromFriendlyNames: typeof getColumnsFromFriendlyNames;
    getColumnFromId: typeof getColumnFromId;
    getColumnFromFriendlyName: typeof getColumnFromFriendlyName;
    getColumnsOfType: typeof getColumnsOfType;
    getNumericColumns: typeof getNumericColumns;
    getStringColumns: typeof getStringColumns;
    getDateColumns: typeof getDateColumns;
    getBooleanColumns: typeof getBooleanColumns;
    getColumnCategoryFromColumnCategories: typeof getColumnCategoryFromColumnCategories;
    getSortableColumns: typeof getSortableColumns;
    getColumnIdFromFriendlyName: typeof getColumnIdFromFriendlyName;
    getColumnIdsFromFriendlyNames: typeof getColumnIdsFromFriendlyNames;
};
export default ColumnHelper;
