import { IColumn } from '../Interface/IColumn';
import { DataType } from '../../PredefinedConfig/Common/Enums';
import { UserFilter } from '../../PredefinedConfig/RunTimeState/UserFilterState';
import { NamedFilter } from '../../PredefinedConfig/RunTimeState/NamedFilterState';
import { ColumnCategory } from '../../PredefinedConfig/RunTimeState/ColumnCategoryState';
export declare const BLANKS_SYSTEM_FILTER = "Blanks";
export declare const NON_BLANKS_SYSTEM_FILTER = "Non Blanks";
export declare const TODAY_SYSTEM_FILTER = "Today";
export declare const IN_PAST_SYSTEM_FILTER = "In Past";
export declare const IN_FUTURE_SYSTEM_FILTER = "In Future";
export declare const YESTERDAY_SYSTEM_FILTER = "Yesterday";
export declare const TOMORROW_SYSTEM_FILTER = "Tomorrow";
export declare const NEXT_WORKING_DAY_SYSTEM_FILTER = "Next Working Day";
export declare const PREVIOUS_WORKING_DAY_SYSTEM_FILTER = "Previous Working Day";
export declare const THIS_YEAR_SYSTEM_FILTER = "This Year";
export declare const POSITIVE_SYSTEM_FILTER = "Positive";
export declare const NEGATIVE_SYSTEM_FILTER = "Negative";
export declare const ZERO_SYSTEM_FILTER = "Zero";
export declare const TRUE_SYSTEM_FILTER = "True";
export declare const FALSE_SYSTEM_FILTER = "False";
export declare function GetAllSystemFilters(): string[];
export declare function GetUserFilters(userFilters: UserFilter[], userFilterNames: string[]): UserFilter[];
export declare function GetSystemFiltersForColumn(column: IColumn, systemFilters: string[]): string[];
export declare function GetUserFiltersForColumn(column: IColumn, userFilters: UserFilter[]): UserFilter[];
export declare function GetNamedFiltersForColumn(column: IColumn, namedFilters: NamedFilter[], columnCategories: ColumnCategory[]): NamedFilter[];
export declare function ShowUserFilterForColumn(UserFilters: UserFilter[], name: string, column: IColumn): boolean;
export declare function GetColumnIdForUserFilter(userFilter: UserFilter): string;
export declare function GetFunctionForSystemFilter(systemFilterName: string): any;
export declare function GetDatatypeForSystemFilter(systemFilterName: string): DataType;
export declare const FilterHelper: {
    BLANKS_SYSTEM_FILTER: string;
    NON_BLANKS_SYSTEM_FILTER: string;
    TODAY_SYSTEM_FILTER: string;
    IN_PAST_SYSTEM_FILTER: string;
    IN_FUTURE_SYSTEM_FILTER: string;
    YESTERDAY_SYSTEM_FILTER: string;
    TOMORROW_SYSTEM_FILTER: string;
    NEXT_WORKING_DAY_SYSTEM_FILTER: string;
    PREVIOUS_WORKING_DAY_SYSTEM_FILTER: string;
    THIS_YEAR_SYSTEM_FILTER: string;
    POSITIVE_SYSTEM_FILTER: string;
    NEGATIVE_SYSTEM_FILTER: string;
    ZERO_SYSTEM_FILTER: string;
    TRUE_SYSTEM_FILTER: string;
    FALSE_SYSTEM_FILTER: string;
    GetAllSystemFilters: typeof GetAllSystemFilters;
    GetUserFilters: typeof GetUserFilters;
    GetSystemFiltersForColumn: typeof GetSystemFiltersForColumn;
    GetUserFiltersForColumn: typeof GetUserFiltersForColumn;
    GetNamedFiltersForColumn: typeof GetNamedFiltersForColumn;
    ShowUserFilterForColumn: typeof ShowUserFilterForColumn;
    GetColumnIdForUserFilter: typeof GetColumnIdForUserFilter;
    GetFunctionForSystemFilter: typeof GetFunctionForSystemFilter;
    GetDatatypeForSystemFilter: typeof GetDatatypeForSystemFilter;
};
export default FilterHelper;
