import { IAdaptableBlotter } from '../Interface/IAdaptableBlotter';
import { IColumn } from '../Interface/IColumn';
export interface IGlue42ExportError {
    row: number;
    column: number;
    description: string;
    foregroundColor: string;
    backgroundColor: string;
}
export interface IGlue42ColumnInfo {
    header: string;
    fieldName: string;
}
export declare function init(): Promise<void>;
export declare function isRunningGlue42(): boolean;
export declare function exportData(data: any[], gridColumns: IColumn[], blotter: IAdaptableBlotter): Promise<void>;
export declare function createColumns(data: any[]): IGlue42ColumnInfo[];
export declare function createData(data: any[], headers: any[]): any;
export declare const Glue42Helper: {
    init: typeof init;
    isRunningGlue42: typeof isRunningGlue42;
    exportData: typeof exportData;
    createColumns: typeof createColumns;
    createData: typeof createData;
};
export default Glue42Helper;
