"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ArrayExtensions_1 = require("../Extensions/ArrayExtensions");
var Enums_1 = require("../../PredefinedConfig/Common/Enums");
function LogAlert(message, messageType) {
    var optionalParams = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        optionalParams[_i - 2] = arguments[_i];
    }
    switch (messageType) {
        case Enums_1.MessageType.Info:
            LogAdaptableBlotterInfo(message, optionalParams);
            break;
        case Enums_1.MessageType.Success:
            LogAdaptableBlotterSuccess(message, optionalParams);
            break;
        case Enums_1.MessageType.Warning:
            LogAdaptableBlotterWarning(message, optionalParams);
            break;
        case Enums_1.MessageType.Error:
            LogAdaptableBlotterError(message, optionalParams);
            break;
    }
}
exports.LogAlert = LogAlert;
function LogAdaptableBlotterInfo(message) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(optionalParams)) {
        console.info('Adaptable Blotter Info: ' + message, optionalParams);
    }
    else {
        console.info('Adaptable Blotter Info: ' + message);
    }
}
exports.LogAdaptableBlotterInfo = LogAdaptableBlotterInfo;
function LogAdaptableBlotterSuccess(message) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(optionalParams)) {
        console.log('Adaptable Blotter Success: ' + message, optionalParams);
    }
    else {
        console.log('Adaptable Blotter Success: ' + message);
    }
}
exports.LogAdaptableBlotterSuccess = LogAdaptableBlotterSuccess;
function LogAdaptableBlotterWarning(message) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(optionalParams)) {
        console.warn('Adaptable Blotter Warning: ' + message, optionalParams);
    }
    else {
        console.warn('Adaptable Blotter Warning: ' + message);
    }
}
exports.LogAdaptableBlotterWarning = LogAdaptableBlotterWarning;
function LogAdaptableBlotterError(message) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(optionalParams)) {
        console.error('Adaptable Blotter Error: ' + message, optionalParams);
    }
    else {
        console.error('Adaptable Blotter Error: ' + message);
    }
}
exports.LogAdaptableBlotterError = LogAdaptableBlotterError;
function LogWarning(message) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(optionalParams)) {
        console.warn(message, optionalParams);
    }
    else {
        console.warn(message);
    }
}
exports.LogWarning = LogWarning;
function LogError(message) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(optionalParams)) {
        console.error(message, optionalParams);
    }
    else {
        console.error(message);
    }
}
exports.LogError = LogError;
function LogInfo(message) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(optionalParams)) {
        console.info(message, optionalParams);
    }
    else {
        console.info(message);
    }
}
exports.LogInfo = LogInfo;
function LogObject(objectToLog) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(optionalParams)) {
        console.log(objectToLog, optionalParams);
    }
    else {
        console.log(objectToLog);
    }
}
exports.LogObject = LogObject;
exports.LoggingHelper = {
    LogAlert: LogAlert,
    LogAdaptableBlotterInfo: LogAdaptableBlotterInfo,
    LogAdaptableBlotterSuccess: LogAdaptableBlotterSuccess,
    LogAdaptableBlotterWarning: LogAdaptableBlotterWarning,
    LogAdaptableBlotterError: LogAdaptableBlotterError,
    LogWarning: LogWarning,
    LogError: LogError,
    LogInfo: LogInfo,
    LogObject: LogObject,
};
exports.default = exports.LoggingHelper;
