import { ExcelWorkbook } from '../Services/OpenfinLiveExcel/ExcelWorkbook';
import { IEvent } from '../Interface/IEvent';
export declare function OnExcelDisconnected(): IEvent<any, any>;
export declare function OnWorkbookDisconnected(): IEvent<any, ExcelWorkbook>;
export declare function OnWorkbookSaved(): IEvent<any, {
    OldName: string;
    NewName: string;
}>;
export declare function isRunningInOpenfin(): boolean;
export declare function isExcelOpenfinLoaded(): boolean;
export declare function pushData(workBookName: string, data: any[]): Promise<any>;
export declare function initOpenFinExcel(): Promise<string>;
export declare const OpenfinHelper: {
    OnExcelDisconnected: typeof OnExcelDisconnected;
    OnWorkbookDisconnected: typeof OnWorkbookDisconnected;
    OnWorkbookSaved: typeof OnWorkbookSaved;
    isRunningInOpenfin: typeof isRunningInOpenfin;
    isExcelOpenfinLoaded: typeof isExcelOpenfinLoaded;
    pushData: typeof pushData;
    initOpenFinExcel: typeof initOpenFinExcel;
};
export default OpenfinHelper;
