import { IKeyValuePair } from '../Interface/IKeyValuePair';
import { LeafExpressionOperator } from '../../PredefinedConfig/Common/Enums';
import { IColumn } from '../Interface/IColumn';
import { QueryRange } from '../../PredefinedConfig/Common/Expression/QueryRange';
export declare function CreateValueRange(operator: LeafExpressionOperator, operand1: any, operand2: any): QueryRange;
export declare function GetNumberOperatorPairs(): IKeyValuePair[];
export declare function GetStringOperatorPairs(): IKeyValuePair[];
export declare function GetDateOperatorPairs(): IKeyValuePair[];
export declare function CreateValueRangeFromOperand(rangeText: string): QueryRange;
export declare function IsColumnAppropriateForRange(operator: LeafExpressionOperator, column: IColumn): boolean;
export declare const RangeHelper: {
    CreateValueRange: typeof CreateValueRange;
    GetNumberOperatorPairs: typeof GetNumberOperatorPairs;
    GetStringOperatorPairs: typeof GetStringOperatorPairs;
    GetDateOperatorPairs: typeof GetDateOperatorPairs;
    CreateValueRangeFromOperand: typeof CreateValueRangeFromOperand;
    IsColumnAppropriateForRange: typeof IsColumnAppropriateForRange;
};
export default RangeHelper;
