import { IStrategyActionReturn } from '../../Strategy/Interface/IStrategyActionReturn';
import { IColumn } from '../Interface/IColumn';
import { ExportDestination } from '../../PredefinedConfig/Common/Enums';
import { IAdaptableBlotter } from '../Interface/IAdaptableBlotter';
import { Report } from '../../PredefinedConfig/RunTimeState/ExportState';
export declare const ALL_DATA_REPORT = "All Data";
export declare const VISIBLE_DATA_REPORT = "Visible Data";
export declare const SELECTED_CELLS_REPORT = "Selected Cells";
export declare const SELECTED_ROWS_REPORT = "Selected Rows";
export declare function IsSystemReport(Report: Report): boolean;
export declare function GetReportColumnsDescription(report: Report, cols: IColumn[]): string;
export declare function GetReportExpressionDescription(Report: Report, cols: IColumn[]): string;
export declare function IsReportDestinationActive(exportDestination: ExportDestination): boolean;
export declare function ConvertReportToArray(blotter: IAdaptableBlotter, Report: Report): IStrategyActionReturn<any[]>;
export declare function CreateSystemReports(): Array<Report>;
export declare const ReportHelper: {
    ALL_DATA_REPORT: string;
    VISIBLE_DATA_REPORT: string;
    SELECTED_CELLS_REPORT: string;
    SELECTED_ROWS_REPORT: string;
    IsSystemReport: typeof IsSystemReport;
    IsReportDestinationActive: typeof IsReportDestinationActive;
    GetReportColumnsDescription: typeof GetReportColumnsDescription;
    GetReportExpressionDescription: typeof GetReportExpressionDescription;
    ConvertReportToArray: typeof ConvertReportToArray;
    CreateSystemReports: typeof CreateSystemReports;
};
export default ReportHelper;
