"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var StrategyConstants = require("../Constants/StrategyConstants");
var ArrayExtensions_1 = require("../Extensions/ArrayExtensions");
var Enums_1 = require("../../PredefinedConfig/Common/Enums");
function IsEditStrategy(strategyId) {
    return strategyId != StrategyConstants.SmartEditStrategyId;
}
exports.IsEditStrategy = IsEditStrategy;
function IsFilterStrategy(strategyId) {
    return strategyId != StrategyConstants.SmartEditStrategyId;
}
exports.IsFilterStrategy = IsFilterStrategy;
function IsSortStrategy(strategyId) {
    return strategyId != StrategyConstants.SmartEditStrategyId;
}
exports.IsSortStrategy = IsSortStrategy;
function getEntitlementAccessLevelForStrategy(entitlements, strategyId) {
    if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(entitlements)) {
        var entitlement = entitlements.find(function (e) { return e.FunctionName == strategyId; });
        if (entitlement) {
            return entitlement.AccessLevel;
        }
    }
    return Enums_1.AccessLevel.Full;
}
exports.getEntitlementAccessLevelForStrategy = getEntitlementAccessLevelForStrategy;
exports.StrategyHelper = {
    IsEditStrategy: IsEditStrategy,
    IsFilterStrategy: IsFilterStrategy,
    IsSortStrategy: IsSortStrategy,
    getEntitlementAccessLevelForStrategy: getEntitlementAccessLevelForStrategy,
};
exports.default = exports.StrategyHelper;
