import { IPPDomain } from '../Interface/Reports/IPPDomain';
import { IPPStyle } from '../Interface/Reports/IPPStyle';
export declare enum ServiceStatus {
    Unknown = "Unknown",
    Disconnected = "Disconnected",
    Connected = "Connected",
    Error = "Error"
}
export declare function init(iPPConfig?: any): void;
export declare function isIPushPullLoaded(): boolean;
export declare function Login(login: string, password: string): Promise<any>;
export declare function GetDomainPages(clientId: string): Promise<IPPDomain[]>;
export declare function LoadPage(folderIPP: string, pageIPP: string): Promise<any>;
export declare function UnloadPage(page: string): void;
export declare function pushData(page: string, data: any[], style: IPPStyle): Promise<any>;
export declare const iPushPullHelper: {
    ServiceStatus: typeof ServiceStatus;
    getIPPStatus: () => ServiceStatus;
    init: typeof init;
    isIPushPullLoaded: typeof isIPushPullLoaded;
    Login: typeof Login;
    GetDomainPages: typeof GetDomainPages;
    LoadPage: typeof LoadPage;
    UnloadPage: typeof UnloadPage;
    pushData: typeof pushData;
};
export default iPushPullHelper;
