import { LeafExpressionOperator, RangeOperandType, ActionMode } from '../PredefinedConfig/Common/Enums';
import { CustomSort } from '../PredefinedConfig/RunTimeState/CustomSortState';
import { DataSource } from '../PredefinedConfig/RunTimeState/DataSourceState';
import { PieChartDefinition, CategoryChartDefinition } from '../PredefinedConfig/RunTimeState/ChartState';
import { CalculatedColumn } from '../PredefinedConfig/RunTimeState/CalculatedColumnState';
import { PlusMinusRule } from '../PredefinedConfig/RunTimeState/PlusMinusState';
import { IAdaptableAlert } from './Interface/IMessage';
import { AlertDefinition } from '../PredefinedConfig/RunTimeState/AlertState';
import { AdvancedSearch } from '../PredefinedConfig/RunTimeState/AdvancedSearchState';
import { IRangeEvaluation } from './Helpers/ExpressionHelper';
import { ColumnCategory } from '../PredefinedConfig/RunTimeState/ColumnCategoryState';
import { ColumnSort, VendorGridInfo, Layout } from '../PredefinedConfig/RunTimeState/LayoutState';
import { CellValidationRule } from '../PredefinedConfig/RunTimeState/CellValidationState';
import { PercentBar } from '../PredefinedConfig/RunTimeState/PercentBarState';
import { UserFilter } from '../PredefinedConfig/RunTimeState/UserFilterState';
import { Report, AutoExport } from '../PredefinedConfig/RunTimeState/ExportState';
import { IColumn } from './Interface/IColumn';
import { FlashingCell } from '../PredefinedConfig/RunTimeState/FlashingCellState';
import { Reminder } from '../PredefinedConfig/RunTimeState/ReminderState';
import { Schedule } from '../PredefinedConfig/Common/Schedule';
import { Shortcut } from '../PredefinedConfig/RunTimeState/ShortcutState';
import { IAdaptableBlotter } from '../types';
import { ConditionalStyle } from '../PredefinedConfig/RunTimeState/ConditionalStyleState';
import { FormatColumn } from '../PredefinedConfig/RunTimeState/FormatColumnState';
import { FreeTextColumn } from '../PredefinedConfig/RunTimeState/FreeTextColumnState';
import { Expression } from '../PredefinedConfig/Common/Expression/Expression';
import { ColumnFilter } from '../PredefinedConfig/RunTimeState/ColumnFilterState';
import { IStyle } from '../PredefinedConfig/Common/IStyle';
import { ICellSummmary } from './Interface/Selection/ICellSummmary';
import { QueryRange } from '../PredefinedConfig/Common/Expression/QueryRange';
export declare function CreateEmptyCustomSort(): CustomSort;
export declare function CreateEmptyDataSource(): DataSource;
export declare function CreateEmptyPieChartDefinition(): PieChartDefinition;
export declare function CreateEmptyCategoryChartDefinition(): CategoryChartDefinition;
export declare function CreateEmptyCalculatedColumn(): CalculatedColumn;
export declare function CreateEmptyPlusMinusRule(): PlusMinusRule;
export declare function CreateEmptyAlert(): IAdaptableAlert;
export declare function CreateEmptyAlertDefinition(): AlertDefinition;
export declare function CreateEmptyAdvancedSearch(): AdvancedSearch;
export declare function CreateEmptyColumnCategory(): ColumnCategory;
export declare function CreateEmptyRange(): QueryRange;
export declare function CreateEmptyColumnSort(): ColumnSort;
export declare function CreateEmptyCellValidation(): CellValidationRule;
export declare function CreateEmptyPercentBar(): PercentBar;
export declare function CreateEmptyUserFilter(): UserFilter;
export declare function CreateEmptyReport(): Report;
export declare function CreateDefaultFlashingCell(column: IColumn, upColor: string, downColor: string, duration: 250 | 500 | 750 | 1000): FlashingCell;
export declare function CreateEmptyReminder(): Reminder;
export declare function CreateEmptyAutoExport(): AutoExport;
export declare function CreateEmptySchedule(): Schedule;
export declare function CreateEmptyShortcut(): Shortcut;
export declare function CreateCellValidationMessage(CellValidation: CellValidationRule, blotter: IAdaptableBlotter): string;
export declare function CreateEmptyConditionalStyle(): ConditionalStyle;
export declare function CreateEmptyFormatColumn(): FormatColumn;
export declare function CreateEmptyFreeTextColumn(): FreeTextColumn;
export declare function CreateLayout(columns: IColumn[], columnSorts: ColumnSort[], vendorGridInfo: VendorGridInfo, name: string): Layout;
export declare function CreateColumnFilter(columnId: string, expression: Expression): ColumnFilter;
export declare function CreateUserFilterFromColumnFilter(columnFilter: ColumnFilter, name: string): UserFilter;
export declare function CreateRange(operator: LeafExpressionOperator, operand1: any, operand2: any, rangeOperandType: RangeOperandType, rangeOperandType2: RangeOperandType): QueryRange;
export declare function CreateRangeEvaluation(operator: LeafExpressionOperator, operand1: any, operand2: any, newValue: any, initialValue: any, columnId: string): IRangeEvaluation;
export declare function CreateCellValidationRule(columnId: string, range: QueryRange, actionMode: ActionMode, expression: Expression): CellValidationRule;
export declare function CreateEmptyStyle(): IStyle;
export declare function CreateEmptyCellSummmary(): ICellSummmary;
export declare const ObjectFactory: {
    CreateEmptyCustomSort: typeof CreateEmptyCustomSort;
    CreateEmptyDataSource: typeof CreateEmptyDataSource;
    CreateEmptyPieChartDefinition: typeof CreateEmptyPieChartDefinition;
    CreateEmptyCategoryChartDefinition: typeof CreateEmptyCategoryChartDefinition;
    CreateEmptyCalculatedColumn: typeof CreateEmptyCalculatedColumn;
    CreateEmptyPlusMinusRule: typeof CreateEmptyPlusMinusRule;
    CreateEmptyAlert: typeof CreateEmptyAlert;
    CreateEmptyAlertDefinition: typeof CreateEmptyAlertDefinition;
    CreateEmptyAdvancedSearch: typeof CreateEmptyAdvancedSearch;
    CreateEmptyColumnCategory: typeof CreateEmptyColumnCategory;
    CreateEmptyRange: typeof CreateEmptyRange;
    CreateEmptyColumnSort: typeof CreateEmptyColumnSort;
    CreateEmptyCellValidation: typeof CreateEmptyCellValidation;
    CreateEmptyPercentBar: typeof CreateEmptyPercentBar;
    CreateEmptyUserFilter: typeof CreateEmptyUserFilter;
    CreateEmptyReport: typeof CreateEmptyReport;
    CreateDefaultFlashingCell: typeof CreateDefaultFlashingCell;
    CreateEmptyReminder: typeof CreateEmptyReminder;
    CreateEmptyAutoExport: typeof CreateEmptyAutoExport;
    CreateEmptySchedule: typeof CreateEmptySchedule;
    CreateEmptyShortcut: typeof CreateEmptyShortcut;
    CreateCellValidationMessage: typeof CreateCellValidationMessage;
    CreateEmptyConditionalStyle: typeof CreateEmptyConditionalStyle;
    CreateEmptyFormatColumn: typeof CreateEmptyFormatColumn;
    CreateEmptyFreeTextColumn: typeof CreateEmptyFreeTextColumn;
    CreateLayout: typeof CreateLayout;
    CreateColumnFilter: typeof CreateColumnFilter;
    CreateUserFilterFromColumnFilter: typeof CreateUserFilterFromColumnFilter;
    CreateRange: typeof CreateRange;
    CreateRangeEvaluation: typeof CreateRangeEvaluation;
    CreateCellValidationRule: typeof CreateCellValidationRule;
    CreateEmptyStyle: typeof CreateEmptyStyle;
    CreateEmptyCellSummmary: typeof CreateEmptyCellSummmary;
};
export default ObjectFactory;
