"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Enums_1 = require("../PredefinedConfig/Common/Enums");
var GeneralConstants_1 = require("./Constants/GeneralConstants");
var ChartEnums_1 = require("../PredefinedConfig/Common/ChartEnums");
var DefaultPieChartProperties_1 = require("./Defaults/DefaultPieChartProperties");
var DefaultCategoryChartProperties_1 = require("./Defaults/DefaultCategoryChartProperties");
var ExpressionHelper_1 = require("./Helpers/ExpressionHelper");
var ColumnHelper_1 = require("./Helpers/ColumnHelper");
var CellValidationHelper_1 = require("./Helpers/CellValidationHelper");
var Uuid_1 = require("../PredefinedConfig/Uuid");
function CreateEmptyCustomSort() {
    return { Uuid: Uuid_1.createUuid(), ColumnId: GeneralConstants_1.EMPTY_STRING, SortedValues: [] };
}
exports.CreateEmptyCustomSort = CreateEmptyCustomSort;
function CreateEmptyDataSource() {
    return { Uuid: Uuid_1.createUuid(), Name: GeneralConstants_1.EMPTY_STRING, Description: GeneralConstants_1.EMPTY_STRING };
}
exports.CreateEmptyDataSource = CreateEmptyDataSource;
function CreateEmptyPieChartDefinition() {
    return {
        Uuid: Uuid_1.createUuid(),
        Name: GeneralConstants_1.EMPTY_STRING,
        Description: GeneralConstants_1.EMPTY_STRING,
        PrimaryColumnId: GeneralConstants_1.EMPTY_STRING,
        SecondaryColumnId: undefined,
        SecondaryColumnOperation: ChartEnums_1.SecondaryColumnOperation.Count,
        ChartProperties: DefaultPieChartProperties_1.DefaultPieChartProperties,
        ChartType: ChartEnums_1.ChartType.PieChart,
        VisibleRowsOnly: true,
    };
}
exports.CreateEmptyPieChartDefinition = CreateEmptyPieChartDefinition;
function CreateEmptyCategoryChartDefinition() {
    return {
        Uuid: Uuid_1.createUuid(),
        Name: GeneralConstants_1.EMPTY_STRING,
        Description: GeneralConstants_1.EMPTY_STRING,
        YAxisColumnIds: [],
        YAxisTotal: GeneralConstants_1.CHART_DEFAULT_YAXIS_TOTAL,
        XAxisColumnId: GeneralConstants_1.EMPTY_STRING,
        XAxisExpression: undefined,
        ChartProperties: DefaultCategoryChartProperties_1.DefaultCategoryChartProperties,
        ChartType: ChartEnums_1.ChartType.CategoryChart,
        VisibleRowsOnly: true,
    };
}
exports.CreateEmptyCategoryChartDefinition = CreateEmptyCategoryChartDefinition;
function CreateEmptyCalculatedColumn() {
    return { Uuid: Uuid_1.createUuid(), ColumnId: GeneralConstants_1.EMPTY_STRING, ColumnExpression: GeneralConstants_1.EMPTY_STRING };
}
exports.CreateEmptyCalculatedColumn = CreateEmptyCalculatedColumn;
function CreateEmptyPlusMinusRule() {
    return {
        Uuid: Uuid_1.createUuid(),
        ColumnId: GeneralConstants_1.EMPTY_STRING,
        IsDefaultNudge: false,
        NudgeValue: GeneralConstants_1.PLUS_MINUS_DEFAULT_NUDGE_VALUE,
        Expression: null,
    };
}
exports.CreateEmptyPlusMinusRule = CreateEmptyPlusMinusRule;
function CreateEmptyAlert() {
    return {
        Header: GeneralConstants_1.EMPTY_STRING,
        Msg: GeneralConstants_1.EMPTY_STRING,
        MessageType: Enums_1.MessageType.Info,
        ShowAsPopup: GeneralConstants_1.ALERT_DEFAULT_SHOW_AS_POPUP,
    };
}
exports.CreateEmptyAlert = CreateEmptyAlert;
function CreateEmptyAlertDefinition() {
    return {
        Uuid: Uuid_1.createUuid(),
        ColumnId: GeneralConstants_1.EMPTY_STRING,
        Range: {
            Operator: GeneralConstants_1.ALERT_DEFAULT_OPERATOR,
            Operand1: GeneralConstants_1.EMPTY_STRING,
            Operand2: GeneralConstants_1.EMPTY_STRING,
            Operand1Type: GeneralConstants_1.ALERT_DEFAULT_RANGE_OPERAND_TYPE,
            Operand2Type: GeneralConstants_1.ALERT_DEFAULT_RANGE_OPERAND_TYPE,
        },
        Expression: null,
        MessageType: GeneralConstants_1.ALERT_DEFAULT_MESSAGE_TYPE,
        ShowAsPopup: GeneralConstants_1.ALERT_DEFAULT_SHOW_AS_POPUP,
    };
}
exports.CreateEmptyAlertDefinition = CreateEmptyAlertDefinition;
function CreateEmptyAdvancedSearch() {
    return {
        Uuid: Uuid_1.createUuid(),
        Name: GeneralConstants_1.EMPTY_STRING,
        Expression: ExpressionHelper_1.default.CreateEmptyExpression(),
    };
}
exports.CreateEmptyAdvancedSearch = CreateEmptyAdvancedSearch;
function CreateEmptyColumnCategory() {
    return {
        Uuid: Uuid_1.createUuid(),
        ColumnCategoryId: GeneralConstants_1.EMPTY_STRING,
        ColumnIds: [],
    };
}
exports.CreateEmptyColumnCategory = CreateEmptyColumnCategory;
function CreateEmptyRange() {
    return {
        Operator: Enums_1.LeafExpressionOperator.None,
        Operand1: GeneralConstants_1.EMPTY_STRING,
        Operand2: GeneralConstants_1.EMPTY_STRING,
        Operand1Type: Enums_1.RangeOperandType.Value,
        Operand2Type: Enums_1.RangeOperandType.Value,
    };
}
exports.CreateEmptyRange = CreateEmptyRange;
function CreateEmptyColumnSort() {
    return {
        Column: GeneralConstants_1.EMPTY_STRING,
        SortOrder: Enums_1.SortOrder.Ascending,
    };
}
exports.CreateEmptyColumnSort = CreateEmptyColumnSort;
function CreateEmptyCellValidation() {
    return {
        Uuid: Uuid_1.createUuid(),
        ActionMode: 'Stop Edit',
        ColumnId: GeneralConstants_1.EMPTY_STRING,
        Range: {
            Operator: Enums_1.LeafExpressionOperator.AnyChange,
            Operand1: GeneralConstants_1.EMPTY_STRING,
            Operand2: GeneralConstants_1.EMPTY_STRING,
            Operand1Type: Enums_1.RangeOperandType.Column,
            Operand2Type: Enums_1.RangeOperandType.Column,
        },
        Expression: null,
    };
}
exports.CreateEmptyCellValidation = CreateEmptyCellValidation;
function CreateEmptyPercentBar() {
    return {
        Uuid: Uuid_1.createUuid(),
        ColumnId: GeneralConstants_1.EMPTY_STRING,
        MaxValue: 100,
        MinValue: 0,
        PositiveColor: GeneralConstants_1.DEFAULT_DARK_GREEN_COLOR,
        NegativeColor: GeneralConstants_1.DEFAULT_DARK_RED_COLOR,
        ShowValue: false,
        ShowToolTip: true,
        MaxValueColumnId: undefined,
        MinValueColumnId: undefined,
    };
}
exports.CreateEmptyPercentBar = CreateEmptyPercentBar;
function CreateEmptyUserFilter() {
    return {
        Uuid: Uuid_1.createUuid(),
        Name: GeneralConstants_1.EMPTY_STRING,
        Expression: ExpressionHelper_1.default.CreateEmptyExpression(),
        ColumnId: GeneralConstants_1.EMPTY_STRING,
    };
}
exports.CreateEmptyUserFilter = CreateEmptyUserFilter;
function CreateEmptyReport() {
    return {
        Uuid: Uuid_1.createUuid(),
        Name: GeneralConstants_1.EMPTY_STRING,
        Expression: null,
        ColumnIds: null,
        ReportColumnScope: Enums_1.ReportColumnScope.AllColumns,
        ReportRowScope: Enums_1.ReportRowScope.AllRows,
        AutoExport: null,
    };
}
exports.CreateEmptyReport = CreateEmptyReport;
function CreateDefaultFlashingCell(column, upColor, downColor, duration) {
    return {
        Uuid: Uuid_1.createUuid(),
        IsLive: false,
        ColumnId: column.ColumnId,
        FlashingCellDuration: duration,
        UpColor: upColor,
        DownColor: downColor,
    };
}
exports.CreateDefaultFlashingCell = CreateDefaultFlashingCell;
function CreateEmptyReminder() {
    return {
        Uuid: Uuid_1.createUuid(),
        Alert: CreateEmptyAlert(),
        Schedule: CreateEmptySchedule(),
    };
}
exports.CreateEmptyReminder = CreateEmptyReminder;
function CreateEmptyAutoExport() {
    return {
        Uuid: Uuid_1.createUuid(),
        ExportDestination: Enums_1.ExportDestination.CSV,
        Schedule: CreateEmptySchedule(),
    };
}
exports.CreateEmptyAutoExport = CreateEmptyAutoExport;
function CreateEmptySchedule() {
    return {
        // todo: base of tommorrow?
        Uuid: Uuid_1.createUuid(),
        OneOffDate: undefined,
        DaysOfWeek: [],
        Hour: 17,
        Minute: 0,
    };
}
exports.CreateEmptySchedule = CreateEmptySchedule;
function CreateEmptyShortcut() {
    return {
        Uuid: Uuid_1.createUuid(),
        ShortcutKey: GeneralConstants_1.EMPTY_STRING,
        ShortcutResult: undefined,
        ColumnType: Enums_1.DataType.Number,
        ShortcutOperation: Enums_1.MathOperation.Multiply,
        IsDynamic: false,
    };
}
exports.CreateEmptyShortcut = CreateEmptyShortcut;
function CreateCellValidationMessage(CellValidation, blotter) {
    var columns = blotter.api.gridApi.getColumns();
    var columnFriendlyName = ColumnHelper_1.default.getFriendlyNameFromColumnId(CellValidation.ColumnId, columns);
    var expressionDescription = ExpressionHelper_1.default.IsNotNullOrEmptyExpression(CellValidation.Expression)
        ? ' when ' + ExpressionHelper_1.default.ConvertExpressionToString(CellValidation.Expression, columns)
        : GeneralConstants_1.EMPTY_STRING;
    return (columnFriendlyName +
        ': ' +
        CellValidationHelper_1.default.createCellValidationDescription(CellValidation, columns) +
        expressionDescription);
}
exports.CreateCellValidationMessage = CreateCellValidationMessage;
function CreateEmptyConditionalStyle() {
    return {
        Uuid: Uuid_1.createUuid(),
        ColumnId: undefined,
        ColumnCategoryId: undefined,
        Style: CreateEmptyStyle(),
        ConditionalStyleScope: Enums_1.ConditionalStyleScope.Row,
        Expression: ExpressionHelper_1.default.CreateEmptyExpression(),
    };
}
exports.CreateEmptyConditionalStyle = CreateEmptyConditionalStyle;
function CreateEmptyFormatColumn() {
    return {
        Uuid: Uuid_1.createUuid(),
        ColumnId: GeneralConstants_1.EMPTY_STRING,
        Style: CreateEmptyStyle(),
    };
}
exports.CreateEmptyFormatColumn = CreateEmptyFormatColumn;
function CreateEmptyFreeTextColumn() {
    return {
        Uuid: Uuid_1.createUuid(),
        ColumnId: GeneralConstants_1.EMPTY_STRING,
        DefaultValue: GeneralConstants_1.EMPTY_STRING,
        FreeTextStoredValues: [],
    };
}
exports.CreateEmptyFreeTextColumn = CreateEmptyFreeTextColumn;
function CreateLayout(columns, columnSorts, vendorGridInfo, name) {
    return {
        Uuid: Uuid_1.createUuid(),
        Columns: columns ? columns.map(function (x) { return x.ColumnId; }) : [],
        ColumnSorts: columnSorts,
        Name: name,
        VendorGridInfo: vendorGridInfo,
    };
}
exports.CreateLayout = CreateLayout;
function CreateColumnFilter(columnId, expression) {
    return {
        Uuid: Uuid_1.createUuid(),
        ColumnId: columnId,
        Filter: expression,
    };
}
exports.CreateColumnFilter = CreateColumnFilter;
function CreateUserFilterFromColumnFilter(columnFilter, name) {
    return {
        Uuid: Uuid_1.createUuid(),
        Name: name,
        ColumnId: columnFilter.ColumnId,
        Expression: columnFilter.Filter,
    };
}
exports.CreateUserFilterFromColumnFilter = CreateUserFilterFromColumnFilter;
function CreateRange(operator, operand1, operand2, rangeOperandType, rangeOperandType2) {
    return {
        Operator: operator,
        Operand1: operand1,
        Operand2: operand2,
        Operand1Type: rangeOperandType,
        Operand2Type: rangeOperandType2,
    };
}
exports.CreateRange = CreateRange;
function CreateRangeEvaluation(operator, operand1, operand2, newValue, initialValue, columnId) {
    return {
        operand1: operand1,
        operand2: operand2,
        newValue: newValue,
        operator: operator,
        initialValue: initialValue,
        columnId: columnId,
    };
}
exports.CreateRangeEvaluation = CreateRangeEvaluation;
function CreateCellValidationRule(columnId, range, actionMode, expression) {
    return {
        Uuid: Uuid_1.createUuid(),
        ColumnId: columnId,
        Range: range,
        ActionMode: actionMode,
        Expression: expression,
    };
}
exports.CreateCellValidationRule = CreateCellValidationRule;
function CreateEmptyStyle() {
    return {
        BackColor: undefined,
        ForeColor: undefined,
        FontWeight: Enums_1.FontWeight.Normal,
        FontStyle: Enums_1.FontStyle.Normal,
        FontSize: undefined,
        ClassName: GeneralConstants_1.EMPTY_STRING,
    };
}
exports.CreateEmptyStyle = CreateEmptyStyle;
function CreateEmptyCellSummmary() {
    return {
        Sum: null,
        Average: null,
        Median: null,
        Distinct: null,
        Max: null,
        Min: null,
        Count: null,
        Only: null,
        VWAP: null,
    };
}
exports.CreateEmptyCellSummmary = CreateEmptyCellSummmary;
exports.ObjectFactory = {
    CreateEmptyCustomSort: CreateEmptyCustomSort,
    CreateEmptyDataSource: CreateEmptyDataSource,
    CreateEmptyPieChartDefinition: CreateEmptyPieChartDefinition,
    CreateEmptyCategoryChartDefinition: CreateEmptyCategoryChartDefinition,
    CreateEmptyCalculatedColumn: CreateEmptyCalculatedColumn,
    CreateEmptyPlusMinusRule: CreateEmptyPlusMinusRule,
    CreateEmptyAlert: CreateEmptyAlert,
    CreateEmptyAlertDefinition: CreateEmptyAlertDefinition,
    CreateEmptyAdvancedSearch: CreateEmptyAdvancedSearch,
    CreateEmptyColumnCategory: CreateEmptyColumnCategory,
    CreateEmptyRange: CreateEmptyRange,
    CreateEmptyColumnSort: CreateEmptyColumnSort,
    CreateEmptyCellValidation: CreateEmptyCellValidation,
    CreateEmptyPercentBar: CreateEmptyPercentBar,
    CreateEmptyUserFilter: CreateEmptyUserFilter,
    CreateEmptyReport: CreateEmptyReport,
    CreateDefaultFlashingCell: CreateDefaultFlashingCell,
    CreateEmptyReminder: CreateEmptyReminder,
    CreateEmptyAutoExport: CreateEmptyAutoExport,
    CreateEmptySchedule: CreateEmptySchedule,
    CreateEmptyShortcut: CreateEmptyShortcut,
    CreateCellValidationMessage: CreateCellValidationMessage,
    CreateEmptyConditionalStyle: CreateEmptyConditionalStyle,
    CreateEmptyFormatColumn: CreateEmptyFormatColumn,
    CreateEmptyFreeTextColumn: CreateEmptyFreeTextColumn,
    CreateLayout: CreateLayout,
    CreateColumnFilter: CreateColumnFilter,
    CreateUserFilterFromColumnFilter: CreateUserFilterFromColumnFilter,
    CreateRange: CreateRange,
    CreateRangeEvaluation: CreateRangeEvaluation,
    CreateCellValidationRule: CreateCellValidationRule,
    CreateEmptyStyle: CreateEmptyStyle,
    CreateEmptyCellSummmary: CreateEmptyCellSummmary,
};
exports.default = exports.ObjectFactory;
