import { DataChangedInfo } from '../Interface/DataChangedInfo';
import { AuditLogEntry, AuditLogType } from '../Interface/AuditLogEntry';
import { IAuditLogService } from './Interface/IAuditLogService';
import { IAdaptableBlotter } from '../../types';
import { StateChangedDetails, FunctionAppliedDetails } from '../../Api/Events/AuditEvents';
export declare class AuditLogService implements IAuditLogService {
    private auditLogQueue;
    private canSendLog;
    private numberOfMissedPing;
    private blotter;
    isAuditEnabled: boolean;
    isAuditStateChangesEnabled: boolean;
    isAuditCellEditsEnabled: boolean;
    isAuditFunctionEventsEnabled: boolean;
    isAuditUserStateChangesEnabled: boolean;
    isAuditInternalStateChangesEnabled: boolean;
    isAuditTickingDataChangesEnabled: boolean;
    constructor(blotter: IAdaptableBlotter);
    addEditCellAuditLogBatch(dataChangedEvents: DataChangedInfo[]): void;
    addEditCellAuditLog(dataChangedInfo: DataChangedInfo): void;
    addUserStateChangeAuditLog(stateChangeDetails: StateChangedDetails): void;
    addInternalStateChangeAuditLog(stateChangeDetails: StateChangedDetails): void;
    addFunctionAppliedAuditLog(functionAppliedDetails: FunctionAppliedDetails): void;
    private handleDataSourceChanged;
    private createAuditLogEntryFromDataChangedInfo;
    private ping;
    private SetCanSendLog;
    private flushAuditQueue;
    convertAuditMessageToText(obj: any): string;
    private isAuditOptionEnabled;
    private shouldAuditToHttpChannel;
    showAlert(header: string, message: string): void;
    publishStateChanged(auditLogEntry: AuditLogEntry, auditLogType: AuditLogType): void;
}
