"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var LoggingHelper_1 = require("../Helpers/LoggingHelper");
var ArrayExtensions_1 = require("../Extensions/ArrayExtensions");
var FreeTextColumnService = /** @class */ (function () {
    function FreeTextColumnService(blotter) {
        this.blotter = blotter;
        this.blotter = blotter;
    }
    FreeTextColumnService.prototype.GetFreeTextValue = function (freeTextColumn, record) {
        try {
            if (this.blotter.isGroupRecord(record)) {
                return null;
            }
            if (ArrayExtensions_1.default.IsNotNullOrEmpty(freeTextColumn.FreeTextStoredValues)) {
                var pkValue_1 = this.blotter.getPrimaryKeyValueFromRecord(record);
                var freeTextStoredValue = freeTextColumn.FreeTextStoredValues.find(function (fdx) { return fdx.PrimaryKey == pkValue_1; });
                if (freeTextStoredValue) {
                    return freeTextStoredValue.FreeText;
                }
            }
            return freeTextColumn.DefaultValue;
        }
        catch (e) {
            LoggingHelper_1.LoggingHelper.LogAdaptableBlotterError(e);
            return null;
        }
    };
    FreeTextColumnService.prototype.CheckIfDataChangingColumnIsFreeText = function (dataChangedEvent) {
        var freeTextColumn = this.blotter.api.freeTextColumnApi
            .getAllFreeTextColumn()
            .find(function (fc) { return fc.ColumnId == dataChangedEvent.ColumnId; });
        if (freeTextColumn) {
            var freeTextStoredValue = {
                PrimaryKey: dataChangedEvent.IdentifierValue,
                FreeText: dataChangedEvent.NewValue,
            };
            this.blotter.api.freeTextColumnApi.addEditFreeTextColumnStoredValue(freeTextColumn, freeTextStoredValue);
        }
    };
    FreeTextColumnService.prototype.CheckIfDataChangingColumnIsFreeTextBatch = function (dataChangedEvents) {
        var _this = this;
        if (ArrayExtensions_1.default.IsNotNullOrEmpty(this.blotter.api.freeTextColumnApi.getAllFreeTextColumn())) {
            dataChangedEvents.forEach(function (dc) {
                _this.CheckIfDataChangingColumnIsFreeText(dc);
            });
        }
    };
    return FreeTextColumnService;
}());
exports.FreeTextColumnService = FreeTextColumnService;
