import { IScheduleService } from './Interface/IScheduleService';
import { IAdaptableBlotter } from '../Interface/IAdaptableBlotter';
import { Reminder } from '../../PredefinedConfig/RunTimeState/ReminderState';
import { Report } from '../../PredefinedConfig/RunTimeState/ExportState';
/**
 * This class is used for managing scheduling of Reports and Reminders
 * It uses node-schedule (via a strongly typed NodeSchedule) and creates standard jobs
 * It also createsa daily job to run at midnight that will refresh the Blotter - this is so that date-based schedules can jump to the new day
 */
export declare class ScheduleService implements IScheduleService {
    private blotter;
    private alertJobs;
    private exportJobs;
    private reminderState;
    private exportState;
    constructor(blotter: IAdaptableBlotter);
    protected listenToScheduleStoreChanges(): void;
    AddReminderSchedule(reminder: Reminder): void;
    AddReportSchedule(report: Report): void;
    private getDateFromSchedule;
    ClearAllAlertJobs(): void;
    ClearAllExportJobs(): void;
    private getReminderState;
    private getExportState;
}
