import { ISearchService } from './Interface/ISearchService';
import { SearchChangedTrigger } from '../../PredefinedConfig/Common/Enums';
import { IAdaptableBlotter } from '../Interface/IAdaptableBlotter';
export declare class SearchService implements ISearchService {
    private blotter;
    private advancedSearchState;
    private columnFilterState;
    private dataSourceState;
    private quickSearchState;
    private userFilterState;
    private columnSorts;
    private columns;
    constructor(blotter: IAdaptableBlotter);
    protected listenToSearchStoreChanges(): void;
    private getAdvancedSearchState;
    private getColumnFilterState;
    private getDataSourceState;
    private getQuickSearchState;
    private getUserFilterState;
    private getGridColumns;
    private getGridColumnSorts;
    /**
     * Each time any of the objects that make up search are changed (e.g. filters, quick search, advanced search, data sources etc.) we fire an event
     * This is primarily to help users who want to run search on the server and so need to know what has changed
     * @param searchChangedTrigger function that triggered the event
     */
    publishSearchChanged(searchChangedTrigger: SearchChangedTrigger): void;
}
