"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_redux_1 = require("react-redux");
var styled_components_1 = require("styled-components");
var theme_1 = require("../theme");
var PopupRedux = require("../Redux/ActionsReducers/PopupRedux");
var SystemRedux = require("../Redux/ActionsReducers/SystemRedux");
var AdaptableBlotterPopup_1 = require("./Components/Popups/AdaptableBlotterPopup");
var AdaptableBlotterPopupPrompt_1 = require("./Components/Popups/AdaptableBlotterPopupPrompt");
var Dashboard_1 = require("./Dashboard/Dashboard");
var AdaptableBlotterPopupConfirmation_1 = require("./Components/Popups/AdaptableBlotterPopupConfirmation");
var AdaptableBlotterPopupAlert_1 = require("./Components/Popups/AdaptableBlotterPopupAlert");
var AdaptableBlotterChart_1 = require("./Components/Popups/AdaptableBlotterChart");
var AdaptableBlotterLoadingScreen_1 = require("./Components/Popups/AdaptableBlotterLoadingScreen");
var AdaptableBlotterGridInfo_1 = require("./Components/Popups/AdaptableBlotterGridInfo");
var ChartEnums_1 = require("../PredefinedConfig/Common/ChartEnums");
//PLEASE NO LOGIC HERE!!! I keep removing stuf... Search , filter, quick search and now layouts.......
var AdaptableBlotterView = /** @class */ (function (_super) {
    tslib_1.__extends(AdaptableBlotterView, _super);
    function AdaptableBlotterView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AdaptableBlotterView.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", null,
            React.createElement(Dashboard_1.Dashboard, { Blotter: this.props.Blotter }),
            this.props.SystemState.ChartVisibility != ChartEnums_1.ChartVisibility.Hidden && (React.createElement(AdaptableBlotterChart_1.AdaptableBlotterChart, { AdaptableBlotter: this.props.Blotter, onClose: this.props.onCloseChartPopup, showChart: this.props.SystemState.ChartVisibility == ChartEnums_1.ChartVisibility.Maximised, showModal: this.props.Blotter.blotterOptions.chartOptions.showModal })),
            React.createElement(AdaptableBlotterGridInfo_1.AdaptableBlotterGridInfo, { AdaptableBlotter: this.props.Blotter, onClose: this.props.onCloseGridInfoPopup, showAbout: this.props.PopupState.GridInfoPopup.ShowGridInfoPopup }),
            React.createElement(AdaptableBlotterLoadingScreen_1.AdaptableBlotterLoadingScreen, { AdaptableBlotter: this.props.Blotter, onClose: this.props.onCloseLoadingPopup, showLoadingScreen: this.props.PopupState.LoadingPopup.ShowLoadingPopup }),
            React.createElement(AdaptableBlotterPopupAlert_1.AdaptableBlotterPopupAlert, { Header: this.props.PopupState.AlertPopup.Header, Msg: this.props.PopupState.AlertPopup.Msg, onClose: this.props.onCloseAlertPopup, ShowPopup: this.props.PopupState.AlertPopup.ShowAlertPopup, MessageType: this.props.PopupState.AlertPopup.MessageType, AdaptableBlotter: this.props.Blotter }),
            React.createElement(AdaptableBlotterPopupPrompt_1.AdaptableBlotterPopupPrompt, { Msg: this.props.PopupState.PromptPopup.Msg, Header: this.props.PopupState.PromptPopup.Header, onClose: this.props.onClosePromptPopup, onConfirm: this.props.onConfirmPromptPopup, ShowPopup: this.props.PopupState.PromptPopup.ShowPromptPopup, AdaptableBlotter: this.props.Blotter }),
            React.createElement(AdaptableBlotterPopupConfirmation_1.AdaptableBlotterPopupConfirmation, { Header: this.props.PopupState.ConfirmationPopup.Header, Msg: this.props.PopupState.ConfirmationPopup.Msg, ShowPopup: this.props.PopupState.ConfirmationPopup.ShowConfirmationPopup, CancelButtonText: this.props.PopupState.ConfirmationPopup.CancelButtonText, ConfirmButtonText: this.props.PopupState.ConfirmationPopup.ConfirmButtonText, onCancel: this.props.onCancelConfirmationPopup, onConfirm: this.props.onConfirmConfirmationPopup, ShowInputBox: this.props.PopupState.ConfirmationPopup.ShowInputBox, MessageType: this.props.PopupState.ConfirmationPopup.MessageType, AdaptableBlotter: this.props.Blotter }),
            React.createElement(AdaptableBlotterPopup_1.AdaptableBlotterPopup, { showModal: this.props.PopupState.ScreenPopup.ShowScreenPopup, ComponentName: this.props.PopupState.ScreenPopup.ComponentName, ComponentStrategy: this.props.PopupState.ScreenPopup.ComponentStrategy, onHide: this.props.onCloseScreenPopup, Blotter: this.props.Blotter, onClearPopupParams: function () { return _this.props.onClearPopupParams(); }, PopupParams: this.props.PopupState.ScreenPopup.Params })));
    };
    return AdaptableBlotterView;
}(React.Component));
function mapStateToProps(state, ownProps) {
    return {
        PopupState: state.Popup,
        SystemState: state.System,
        ChartState: state.Chart,
        AdaptableBlotter: ownProps.Blotter,
    };
}
function mapDispatchToProps(dispatch) {
    return {
        onCloseScreenPopup: function () { return dispatch(PopupRedux.PopupHideScreen()); },
        onCloseAlertPopup: function () { return dispatch(PopupRedux.PopupHideAlert()); },
        onCloseGridInfoPopup: function () { return dispatch(PopupRedux.PopupHideGridInfo()); },
        onCloseChartPopup: function () { return dispatch(SystemRedux.ChartSetChartVisibility(ChartEnums_1.ChartVisibility.Hidden)); },
        onClosePromptPopup: function () { return dispatch(PopupRedux.PopupHidePrompt()); },
        onConfirmPromptPopup: function (inputText) { return dispatch(PopupRedux.PopupConfirmPrompt(inputText)); },
        onConfirmConfirmationPopup: function (comment) {
            return dispatch(PopupRedux.PopupConfirmConfirmation(comment));
        },
        onCancelConfirmationPopup: function () { return dispatch(PopupRedux.PopupCancelConfirmation()); },
        showPopup: function (componentStrategy, componentName, params) {
            return dispatch(PopupRedux.PopupShowScreen(componentStrategy, componentName, params));
        },
        onClearPopupParams: function () { return dispatch(PopupRedux.PopupClearParam()); },
    };
}
var AdaptableBlotterWrapper = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(AdaptableBlotterView);
exports.AdaptableBlotterApp = function (_a) {
    var AdaptableBlotter = _a.AdaptableBlotter;
    return (React.createElement(react_redux_1.Provider, { store: AdaptableBlotter.adaptableBlotterStore.TheStore },
        React.createElement(styled_components_1.ThemeProvider, { theme: theme_1.default },
            React.createElement(AdaptableBlotterWrapper, { Blotter: AdaptableBlotter }))));
};
