"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CustomSortPopup_1 = require("./CustomSort/CustomSortPopup");
var SmartEditPopup_1 = require("./SmartEdit/SmartEditPopup");
var ShortcutPopup_1 = require("./Shortcut/ShortcutPopup");
var PlusMinusPopup_1 = require("./PlusMinus/PlusMinusPopup");
var ColumnChooserPopup_1 = require("./ColumnChooser/ColumnChooserPopup");
var ColumnInfoPopup_1 = require("./ColumnInfo/ColumnInfoPopup");
var ExportPopup_1 = require("./Export/ExportPopup");
var FlashingCellsPopup_1 = require("./FlashingCells/FlashingCellsPopup");
var CalendarsPopup_1 = require("./Calendars/CalendarsPopup");
var ConditionalStylePopup_1 = require("./ConditionalStyle/ConditionalStylePopup");
var QuickSearchPopup_1 = require("./QuickSearch/QuickSearchPopup");
var QuickSearchToolbarControl_1 = require("./QuickSearch/QuickSearchToolbarControl");
var ColumnFilterToolbarControl_1 = require("./ColumnFilter/ColumnFilterToolbarControl");
var ThemeToolbarControl_1 = require("./Theme/ThemeToolbarControl");
var ApplicationToolbarControl_1 = require("./Application/ApplicationToolbarControl");
var AdvancedSearchPopup_1 = require("./AdvancedSearch/AdvancedSearchPopup");
var AdvancedSearchToolbarControl_1 = require("./AdvancedSearch/AdvancedSearchToolbarControl");
var BulkUpdateToolbarControl_1 = require("./BulkUpdate/BulkUpdateToolbarControl");
var SmartEditToolbarControl_1 = require("./SmartEdit/SmartEditToolbarControl");
var UserFilterPopup_1 = require("./UserFilter/UserFilterPopup");
var FormatColumnPopup_1 = require("./FormatColumn/FormatColumnPopup");
var ThemePopup_1 = require("./Theme/ThemePopup");
var CellValidationPopup_1 = require("./CellValidation/CellValidationPopup");
var LayoutPopup_1 = require("./Layout/LayoutPopup");
var ColumnCategoryPopup_1 = require("./ColumnCategory/ColumnCategoryPopup");
var LayoutToolbarControl_1 = require("./Layout/LayoutToolbarControl");
var ExportToolbarControl_1 = require("./Export/ExportToolbarControl");
var TeamSharingPopup_1 = require("./TeamSharing/TeamSharingPopup");
var IPushPullLogin_1 = require("./Export/IPushPullLogin");
var HomeToolbarControl_1 = require("./Home/HomeToolbarControl");
var ApplicationPopup_1 = require("./Application/ApplicationPopup");
var DashboardPopup_1 = require("./Dashboard/DashboardPopup");
var DataManagementPopup_1 = require("./DataManagement/DataManagementPopup");
var ColumnFilterPopup_1 = require("./ColumnFilter/ColumnFilterPopup");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var CalculatedColumnPopup_1 = require("./CalculatedColumn/CalculatedColumnPopup");
var IPushPullDomainPageSelector_1 = require("./Export/IPushPullDomainPageSelector");
var BulkUpdatePopup_1 = require("./BulkUpdate/BulkUpdatePopup");
var DataSourcePopup_1 = require("./DataSource/DataSourcePopup");
var DataSourceToolbarControl_1 = require("./DataSource/DataSourceToolbarControl");
var AlertPopup_1 = require("./Alert/AlertPopup");
var AlertToolbarControl_1 = require("./Alert/AlertToolbarControl");
var ChartPopup_1 = require("./Chart/ChartPopup");
var ChartToolbarControl_1 = require("./Chart/ChartToolbarControl");
var FreeTextColumnPopup_1 = require("./FreeTextColumn/FreeTextColumnPopup");
var PercentBarPopup_1 = require("./PercentBar/PercentBarPopup");
var PieChartPopup_1 = require("./PieChart/PieChartPopup");
var CellSummaryPopup_1 = require("./CellSummary/CellSummaryPopup");
var CellSummaryToolbarControl_1 = require("./CellSummary/CellSummaryToolbarControl");
var ChartDisplayPopup_1 = require("./Chart/ChartDisplayPopup");
var ReminderPopup_1 = require("./Reminder/ReminderPopup");
exports.AdaptableViewFactory = {
    AdvancedSearchPopup: AdvancedSearchPopup_1.AdvancedSearchPopup,
    AlertPopup: AlertPopup_1.AlertPopup,
    ApplicationPopup: ApplicationPopup_1.ApplicationPopup,
    BulkUpdatePopup: BulkUpdatePopup_1.BulkUpdatePopup,
    CalculatedColumnPopup: CalculatedColumnPopup_1.CalculatedColumnPopup,
    CalendarsPopup: CalendarsPopup_1.CalendarsPopup,
    CellValidationPopup: CellValidationPopup_1.CellValidationPopup,
    ChartPopup: ChartPopup_1.ChartPopup,
    ColumnChooserPopup: ColumnChooserPopup_1.ColumnChooserPopup,
    ColumnFilterPopup: ColumnFilterPopup_1.ColumnFilterPopup,
    ColumnInfoPopup: ColumnInfoPopup_1.ColumnInfoPopup,
    ConditionalStylePopup: ConditionalStylePopup_1.ConditionalStylePopup,
    CustomSortPopup: CustomSortPopup_1.CustomSortPopup,
    DashboardPopup: DashboardPopup_1.DashboardPopup,
    DataManagementPopup: DataManagementPopup_1.DataManagementPopup,
    DataSourcePopup: DataSourcePopup_1.DataSourcePopup,
    ExportPopup: ExportPopup_1.ExportPopup,
    FlashingCellsPopup: FlashingCellsPopup_1.FlashingCellsPopup,
    FormatColumnPopup: FormatColumnPopup_1.FormatColumnPopup,
    FreeTextColumnPopup: FreeTextColumnPopup_1.FreeTextColumnPopup,
    IPushPullLogin: IPushPullLogin_1.IPushPullLogin,
    IPushPullDomainPageSelector: IPushPullDomainPageSelector_1.IPushPullDomainPageSelector,
    LayoutPopup: LayoutPopup_1.LayoutPopup,
    ColumnCategoryPopup: ColumnCategoryPopup_1.ColumnCategoryPopup,
    PercentBarPopup: PercentBarPopup_1.PercentBarPopup,
    PieChartPopup: PieChartPopup_1.PieChartPopup,
    PlusMinusPopup: PlusMinusPopup_1.PlusMinusPopup,
    QuickSearchPopup: QuickSearchPopup_1.QuickSearchPopup,
    ReminderPopup: ReminderPopup_1.ReminderPopup,
    CellSummaryPopup: CellSummaryPopup_1.CellSummaryPopup,
    SmartEditPopup: SmartEditPopup_1.SmartEditPopup,
    ShortcutPopup: ShortcutPopup_1.ShortcutPopup,
    ThemePopup: ThemePopup_1.ThemePopup,
    TeamSharingPopup: TeamSharingPopup_1.TeamSharingPopup,
    UserFilterPopup: UserFilterPopup_1.UserFilterPopup,
    ChartDisplayPopup: ChartDisplayPopup_1.ChartDisplayPopup,
};
//here we put the dashboard control for each strategy
exports.AdaptableDashboardViewFactory = new Map([
    [StrategyConstants.AdvancedSearchStrategyId, AdvancedSearchToolbarControl_1.AdvancedSearchToolbarControl],
    [StrategyConstants.DataSourceStrategyId, DataSourceToolbarControl_1.DataSourceToolbarControl],
    [StrategyConstants.QuickSearchStrategyId, QuickSearchToolbarControl_1.QuickSearchToolbarControl],
    [StrategyConstants.LayoutStrategyId, LayoutToolbarControl_1.LayoutToolbarControl],
    [StrategyConstants.ColumnFilterStrategyId, ColumnFilterToolbarControl_1.ColumnFilterToolbarControl],
    [StrategyConstants.ApplicationStrategyId, ApplicationToolbarControl_1.ApplicationToolbarControl],
    [StrategyConstants.ExportStrategyId, ExportToolbarControl_1.ExportToolbarControl],
    [StrategyConstants.BulkUpdateStrategyId, BulkUpdateToolbarControl_1.BulkUpdateToolbarControl],
    [StrategyConstants.SmartEditStrategyId, SmartEditToolbarControl_1.SmartEditToolbarControl],
    [StrategyConstants.CellSummaryStrategyId, CellSummaryToolbarControl_1.CellSummaryToolbarControl],
    [StrategyConstants.AlertStrategyId, AlertToolbarControl_1.AlertToolbarControl],
    [StrategyConstants.ChartStrategyId, ChartToolbarControl_1.ChartToolbarControl],
    [StrategyConstants.ThemeStrategyId, ThemeToolbarControl_1.ThemeToolbarControl],
]);
exports.AdaptableDashboardPermanentToolbarFactory = new Map([[StrategyConstants.HomeStrategyId, HomeToolbarControl_1.HomeToolbarControl]]);
