import * as React from 'react';
import { StrategySummaryProps } from '../Components/SharedProps/StrategySummaryProps';
import { EditableConfigEntityState } from '../Components/SharedProps/EditableConfigEntityState';
import * as AlertRedux from '../../Redux/ActionsReducers/AlertRedux';
import * as TeamSharingRedux from '../../Redux/ActionsReducers/TeamSharingRedux';
import { AlertDefinition } from '../../PredefinedConfig/RunTimeState/AlertState';
import { AdaptableBlotterObject } from '../../PredefinedConfig/AdaptableBlotterObject';
export interface AlertSummaryProps extends StrategySummaryProps<AlertSummaryComponent> {
    Alerts: AlertDefinition[];
    onAddAlert: (Alert: AlertDefinition) => AlertRedux.AlertDefinitionAddAction;
    onEditAlert: (Alert: AlertDefinition) => AlertRedux.AlertDefinitionEditAction;
    onShare: (entity: AdaptableBlotterObject) => TeamSharingRedux.TeamSharingShareAction;
}
export declare class AlertSummaryComponent extends React.Component<AlertSummaryProps, EditableConfigEntityState> {
    constructor(props: AlertSummaryProps);
    render(): any;
    onNew(): void;
    onEdit(Alert: AlertDefinition): void;
    onCloseWizard(): void;
    onFinishWizard(): void;
    canFinishWizard(): boolean;
}
export declare let AlertSummary: React.ComponentClass<any, any>;
