"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_redux_1 = require("react-redux");
var PopupRedux = require("../../Redux/ActionsReducers/PopupRedux");
var DashboardRedux = require("../../Redux/ActionsReducers/DashboardRedux");
var PanelDashboard_1 = require("../Components/Panels/PanelDashboard");
var StrategyConstants = require("../../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../../Utilities/Constants/ScreenPopups");
var StringExtensions_1 = require("../../Utilities/Extensions/StringExtensions");
var ApplicationToolbarControlComponent = /** @class */ (function (_super) {
    tslib_1.__extends(ApplicationToolbarControlComponent, _super);
    function ApplicationToolbarControlComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ApplicationToolbarControlComponent.prototype.render = function () {
        var _this = this;
        var headerText = StringExtensions_1.StringExtensions.IsNotNullOrEmpty(this.props.ApplicationToolbarTitle)
            ? this.props.ApplicationToolbarTitle
            : StrategyConstants.ApplicationStrategyName;
        var minHeight = '22px';
        return (React.createElement(PanelDashboard_1.PanelDashboard, { headerText: headerText, glyphicon: StrategyConstants.ApplicationGlyph, onClose: function () { return _this.props.onClose(StrategyConstants.ApplicationStrategyId); }, onConfigure: function () { return _this.props.onConfigure(); } },
            React.createElement("div", { className: "ApplicationToolBarContents", style: { minHeight: minHeight } })));
    };
    return ApplicationToolbarControlComponent;
}(React.Component));
function mapStateToProps(state, ownProps) {
    return {
        ApplicationToolbarTitle: state.Dashboard.ApplicationToolbarTitle,
    };
}
function mapDispatchToProps(dispatch) {
    return {
        onClose: function (dashboardControl) {
            return dispatch(DashboardRedux.DashboardHideToolbar(dashboardControl));
        },
        onConfigure: function () {
            return dispatch(PopupRedux.PopupShowScreen(StrategyConstants.ApplicationStrategyId, ScreenPopups.ApplicationPopup));
        },
    };
}
exports.ApplicationToolbarControl = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(ApplicationToolbarControlComponent);
