"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var PanelWithRow_1 = require("../Components/Panels/PanelWithRow");
var Helper_1 = require("../../Utilities/Helpers/Helper");
var AdaptableObjectRow_1 = require("../Components/AdaptableObjectRow");
var Enums_1 = require("../../PredefinedConfig/Common/Enums");
var EmptyContent_1 = require("../../components/EmptyContent");
var CellSummaryDetails = /** @class */ (function (_super) {
    tslib_1.__extends(CellSummaryDetails, _super);
    function CellSummaryDetails() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CellSummaryDetails.prototype.render = function () {
        var colItems = [{ Content: 'Operation', Size: 4 }, { Content: 'Value', Size: 8 }];
        var rowElements = [];
        if (this.props.CellSummary != null) {
            rowElements.push(this.createRow(colItems, Enums_1.CellSummaryOperation.Sum, this.props.CellSummary.Sum));
            rowElements.push(this.createRow(colItems, Enums_1.CellSummaryOperation.Average, this.props.CellSummary.Average));
            rowElements.push(this.createRow(colItems, Enums_1.CellSummaryOperation.Median, this.props.CellSummary.Median));
            rowElements.push(this.createRow(colItems, Enums_1.CellSummaryOperation.Distinct, this.props.CellSummary.Distinct));
            rowElements.push(this.createRow(colItems, Enums_1.CellSummaryOperation.Max, this.props.CellSummary.Max));
            rowElements.push(this.createRow(colItems, Enums_1.CellSummaryOperation.Min, this.props.CellSummary.Min));
            rowElements.push(this.createRow(colItems, Enums_1.CellSummaryOperation.Count, this.props.CellSummary.Count));
            if (this.props.CellSummary.Only != null) {
                rowElements.push(this.createRow(colItems, Enums_1.CellSummaryOptionalOperation.Only, this.props.CellSummary.Only));
            }
            if (this.props.CellSummary.VWAP != null) {
                rowElements.push(this.createRow(colItems, Enums_1.CellSummaryOptionalOperation.VWAP, this.props.CellSummary.VWAP));
            }
        }
        return (React.createElement("div", null,
            React.createElement(PanelWithRow_1.PanelWithRow, { colItems: colItems }),
            this.props.CellSummary != null ? (React.createElement("div", null, rowElements)) : (React.createElement(EmptyContent_1.default, null,
                React.createElement("p", null, "No cells are selected - please select some cells.")))));
    };
    CellSummaryDetails.prototype.createRow = function (colItems, key, value) {
        var rowColItems = Helper_1.Helper.cloneObject(colItems);
        rowColItems[0].Content = key;
        rowColItems[1].Content = value;
        var rowElement = React.createElement(AdaptableObjectRow_1.AdaptableObjectRow, { key: key, colItems: rowColItems });
        return rowElement;
    };
    return CellSummaryDetails;
}(React.Component));
exports.CellSummaryDetails = CellSummaryDetails;
