import * as React from 'react';
import { CategoryChartType, CrosshairDisplayMode, HorizontalAlignment, ToolTipType } from '../../../PredefinedConfig/Common/ChartEnums';
import { CategoryChartDefinition, ChartProperties, ChartData } from '../../../PredefinedConfig/RunTimeState/ChartState';
import { CategoryChartComponentState } from './CategoryChartComponentState';
import { IColumn } from '../../../Utilities/Interface/IColumn';
interface CategoryChartComponentProps {
    CurrentChartDefinition: CategoryChartDefinition;
    ChartData: ChartData;
    Columns: IColumn[];
    ColorPalette: string[];
    onUpdateChartProperties: (chartUuid: string, chartProperties: ChartProperties) => void;
}
export declare class CategoryChartComponent extends React.Component<CategoryChartComponentProps, CategoryChartComponentState> {
    seriesColors: Map<string, string>;
    constructor(props: CategoryChartComponentProps);
    UNSAFE_componentWillReceiveProps(nextProps: CategoryChartComponentProps, nextContext: any): void;
    render(): JSX.Element;
    calloutStyleUpdating(args: any): void;
    seriesAdded(args: any): void;
    onSetPropertyDefaults(): void;
    onShowGeneralProperties(): void;
    onShowYAxisProperties(): void;
    onShowXAxisProperties(): void;
    onShowHighlightsProperties(): void;
    onShowMiscProperties(): void;
    onHidePropertiesGroup(): void;
    onShowChartSettings(): void;
    onHideChartSettings(): void;
    onChartTypeChange(value: CategoryChartType): void;
    onMarkerTypeChange(value: string): void;
    onYAxisLabelLocationChange(value: string): void;
    onXAxisLabelLocationChange(event: React.FormEvent<any>): void;
    private onYAxisLabelColorChange;
    private onXAxisLabelColorChange;
    private onYAxisTitleColorChange;
    private onXAxisTitleColorChange;
    onToolTipTypeChange(value: ToolTipType): void;
    onChangedCalloutsType(value: any): void;
    private onChangedCalloutsInterval;
    onCrosshairsModeChange(value: CrosshairDisplayMode): void;
    private onCrosshairSnapToDataOptionChanged;
    private onCrosshairAnnotationEnabledOptionChanged;
    private onEnableFinalValueAnnotationsOptionChanged;
    private onEnableSeriesHighlightingOptionChanged;
    private onEnableCategoryHighlightingOptionChanged;
    private onEnableItemHighlightingOptionChanged;
    private onEnableTransitionsOptionChanged;
    private onYAxisInvertedChanged;
    private onXAxisInvertedChanged;
    private onSetYAxisMinValueOptionChanged;
    private onSetYAxisMaxValueOptionChanged;
    private onSetYAxisIntervalValueOptionChanged;
    private onSetXAxisIntervalValueOptionChanged;
    private onSetYAxisLabelColorOptionChanged;
    private onSetXAxisLabelColorOptionChanged;
    private onSetYAxisTitleColorOptionChanged;
    private onSetXAxisTitleColorOptionChanged;
    onTitleAlignmentChange(value: HorizontalAlignment): void;
    onSubTitleAlignmentChange(value: HorizontalAlignment): void;
    private onYAxisMinValueChanged;
    private onYAxisMaxValueChanged;
    private onYAxisIntervalValueChanged;
    private onXAxisIntervalValueChanged;
    private onTransitionDurationChanged;
    private updateChartProperties;
    private onXAxisVisibilityOptionChanged;
    private onYAxisVisibilityOptionChanged;
    private onYAxisTitleChanged;
    private onXAxisGapChanged;
    private onXAxisOverlapChanged;
    private onXAxisTitleChanged;
    private onXAxisAngleChanged;
    private onYAxisLabelScaleChanged;
    private onUseDefaultYAxisTitleOptionChanged;
    private onUseDefaultXAxisTitleOptionChanged;
    private getYAxisTitle;
    private getXAxisTitle;
    private getYAxisIsLogarithmic;
}
export {};
