"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var ReactDOM = require("react-dom");
var AdaptableViewFactory_1 = require("../../AdaptableViewFactory");
var UIHelper_1 = require("../../UIHelper");
var StrategyConstants = require("../../../Utilities/Constants/StrategyConstants");
var ScreenPopups = require("../../../Utilities/Constants/ScreenPopups");
var StrategyHelper_1 = require("../../../Utilities/Helpers/StrategyHelper");
var AdaptableBlotterPopup_1 = require("./AdaptableBlotterPopup");
var AdaptableBlotterChart = /** @class */ (function (_super) {
    tslib_1.__extends(AdaptableBlotterChart, _super);
    function AdaptableBlotterChart(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            chartContainer: UIHelper_1.UIHelper.getChartContainer(_this.props.AdaptableBlotter.blotterOptions, document, _this.props.showModal),
            accessLevel: StrategyHelper_1.StrategyHelper.getEntitlementAccessLevelForStrategy(_this.props.AdaptableBlotter.adaptableBlotterStore.TheStore.getState().Entitlements
                .FunctionEntitlements, StrategyConstants.ChartStrategyId),
            isValidUserChartContainer: UIHelper_1.UIHelper.isValidUserChartContainer(_this.props.AdaptableBlotter.blotterOptions, document),
        };
        return _this;
    }
    AdaptableBlotterChart.prototype.render = function () {
        var commonProps = {
            Columns: this.props.AdaptableBlotter.api.gridApi.getColumns(),
            ModalContainer: this.state.chartContainer,
            onClose: this.props.onClose,
            ShowModal: this.props.showModal,
            Blotter: this.props.AdaptableBlotter,
            UserFilters: this.props.AdaptableBlotter.adaptableBlotterStore.TheStore.getState().UserFilter
                .UserFilters,
            SystemFilters: this.props.AdaptableBlotter.adaptableBlotterStore.TheStore.getState()
                .SystemFilter.SystemFilters,
            NamedFilters: this.props.AdaptableBlotter.adaptableBlotterStore.TheStore.getState()
                .NamedFilter.NamedFilters,
            ColumnCategories: this.props.AdaptableBlotter.adaptableBlotterStore.TheStore.getState()
                .ColumnCategory.ColumnCategories,
            ColumnFilters: this.props.AdaptableBlotter.api.columnFilterApi.getAllColumnFilter(),
            ColorPalette: this.props.AdaptableBlotter.adaptableBlotterStore.TheStore.getState()
                .UserInterface.ColorPalette,
            AccessLevel: this.state.accessLevel,
        };
        var ChartCmp = AdaptableViewFactory_1.AdaptableViewFactory[ScreenPopups.ChartDisplayPopup];
        var body = React.createElement(ChartCmp, tslib_1.__assign({}, commonProps));
        // var body: any = React.createElement(bodyElement, commonProps);
        return this.props.showModal ? (React.createElement(AdaptableBlotterPopup_1.AdaptableBlotterPopup, { Blotter: this.props.AdaptableBlotter, onHide: this.props.onClose, showModal: true, PopupParams: "", ComponentName: ScreenPopups.ChartDisplayPopup, ComponentStrategy: StrategyConstants.ChartStrategyId }, body)) : this.state.isValidUserChartContainer ? (ReactDOM.createPortal(body, this.state.chartContainer)) : (body);
    };
    return AdaptableBlotterChart;
}(React.Component));
exports.AdaptableBlotterChart = AdaptableBlotterChart;
