import * as React from 'react';
import { IColItem } from '../../UIInterfaces';
import { IAdaptableBlotter } from '../../../Utilities/Interface/IAdaptableBlotter';
interface AdaptableBlotterGridInfoProps extends React.ClassAttributes<AdaptableBlotterGridInfo> {
    AdaptableBlotter: IAdaptableBlotter;
    onClose?: () => void;
    showAbout: boolean;
}
export interface GridInfoBlotterState {
    ShowGridProperties: boolean;
    IsBaseOptionsMinimised: boolean;
    IsContainerOptionsMinimised: boolean;
    IsAuditOptionsMinimised: boolean;
    IsConfigServerOptionsMinimised: boolean;
    IsQueryOptionsMinimised: boolean;
    IsLayoutOptionsMinimised: boolean;
    IsFilterOptionsMinimised: boolean;
    IsGeneralOptionsMinimised: boolean;
}
export declare class AdaptableBlotterGridInfo extends React.Component<AdaptableBlotterGridInfoProps, GridInfoBlotterState> {
    constructor(props: AdaptableBlotterGridInfoProps);
    render(): JSX.Element;
    private CreateGridInfo;
    private CreateBaseOptionsInfo;
    private CreateContainerOptionsInfo;
    private CreateAuditOptionsInfo;
    private CreateConfigServerOptionsInfo;
    private CreateQueryOptionsInfo;
    private CreateLayoutOptionsInfo;
    private CreateFilterOptionsInfo;
    private CreateGeneralOptionsInfo;
    createMaximiseButton(optionType: string, onClickFunction: any): any;
    createMinimiseButton(optionType: string, onClickFunction: any): any;
    createColItem(colItems: IColItem[], item1: any, item2: any, item3?: any): IColItem[];
    onShowGridPropertiesChanged(event: React.FormEvent<any>): void;
}
export {};
