"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var Enums_1 = require("../../../PredefinedConfig/Common/Enums");
var AdaptableViewFactory_1 = require("../../AdaptableViewFactory");
var GeneralConstants = require("../../../Utilities/Constants/GeneralConstants");
var StrategyHelper_1 = require("../../../Utilities/Helpers/StrategyHelper");
var BlotterHelper_1 = require("../../../Utilities/Helpers/BlotterHelper");
var UIHelper_1 = require("../../UIHelper");
var Dialog_1 = require("../../../components/Dialog");
var SimpleButton_1 = require("../../../components/SimpleButton");
var rebass_1 = require("rebass");
var AdaptableBlotterPopup = /** @class */ (function (_super) {
    tslib_1.__extends(AdaptableBlotterPopup, _super);
    function AdaptableBlotterPopup() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AdaptableBlotterPopup.prototype.render = function () {
        var _this = this;
        var modalContainer = UIHelper_1.UIHelper.getModalContainer(this.props.Blotter.blotterOptions, document);
        var accessLevel = StrategyHelper_1.StrategyHelper.getEntitlementAccessLevelForStrategy(this.props.Blotter.adaptableBlotterStore.TheStore.getState().Entitlements
            .FunctionEntitlements, this.props.ComponentStrategy);
        if (this.props.ComponentName) {
            var bodyElement = AdaptableViewFactory_1.AdaptableViewFactory[this.props.ComponentName];
            //Warning : FilterForm needs to be changed if we add properties since it uses the same interface
            var commonProps = {
                PopupParams: this.props.PopupParams,
                onClearPopupParams: function () {
                    return _this.props.onClearPopupParams ? _this.props.onClearPopupParams() : null;
                },
                TeamSharingActivated: BlotterHelper_1.BlotterHelper.isConfigServerEnabled(this.props.Blotter.blotterOptions),
                Columns: this.props.Blotter.adaptableBlotterStore.TheStore.getState().Grid.Columns,
                UserFilters: this.props.Blotter.adaptableBlotterStore.TheStore.getState().UserFilter
                    .UserFilters,
                SystemFilters: this.props.Blotter.adaptableBlotterStore.TheStore.getState().SystemFilter
                    .SystemFilters,
                NamedFilters: this.props.Blotter.adaptableBlotterStore.TheStore.getState().NamedFilter
                    .NamedFilters,
                ColumnFilters: this.props.Blotter.adaptableBlotterStore.TheStore.getState().ColumnFilter
                    .ColumnFilters,
                ModalContainer: modalContainer,
                ColumnCategories: this.props.Blotter.adaptableBlotterStore.TheStore.getState()
                    .ColumnCategory.ColumnCategories,
                ColorPalette: this.props.Blotter.adaptableBlotterStore.TheStore.getState().UserInterface
                    .ColorPalette,
                ColumnSorts: this.props.Blotter.adaptableBlotterStore.TheStore.getState().Grid.ColumnSorts,
                AccessLevel: accessLevel,
                Blotter: this.props.Blotter,
            };
            var body = React.createElement(bodyElement, commonProps);
        }
        return (React.createElement(Dialog_1.default, { isOpen: this.props.showModal, onDismiss: this.props.onHide, showCloseButton: false, modal: true, padding: 0 },
            React.createElement(rebass_1.Flex, { flexDirection: "column", style: {
                    height: '100%',
                    maxHeight: '90vh',
                    width: '70vw',
                    maxWidth: 800,
                } },
                React.createElement(rebass_1.Flex, { flexDirection: "column", padding: 0, flex: 1 },
                    React.createElement(rebass_1.Flex, { flexDirection: "column", flex: 1 },
                        React.createElement(rebass_1.Flex, { flexDirection: "column", flex: 1, className: accessLevel == Enums_1.AccessLevel.ReadOnly ? GeneralConstants.READ_ONLY_STYLE : '' }, body))),
                React.createElement(rebass_1.Flex, { padding: 2, backgroundColor: "primary" },
                    React.createElement(SimpleButton_1.default, { onClick: function () { return _this.props.onHide(); }, variant: "text" }, "CLOSE")))));
    };
    return AdaptableBlotterPopup;
}(React.Component));
exports.AdaptableBlotterPopup = AdaptableBlotterPopup;
