import * as React from 'react';
import * as Redux from 'redux';
import { IColumn } from '../../../Utilities/Interface/IColumn';
import { AdaptableBlotterObject } from '../../../PredefinedConfig/AdaptableBlotterObject';
import { UserFilter } from '../../../PredefinedConfig/RunTimeState/UserFilterState';
import { IColItem } from '../../UIInterfaces';
import { AccessLevel } from '../../../PredefinedConfig/Common/Enums';
export interface BaseRowProps<View> extends React.ClassAttributes<View> {
    colItems: IColItem[];
}
export interface BaseEntityRowProps<View> extends BaseRowProps<View> {
    AdaptableBlotterObject: AdaptableBlotterObject;
    onDeleteConfirm: Redux.Action;
    onEdit: (adaptableBlotterObject: AdaptableBlotterObject) => void;
}
export interface SharedEntityRowProps<View> extends BaseEntityRowProps<View> {
    onShare: () => void;
    TeamSharingActivated: boolean;
    AccessLevel: AccessLevel;
}
export interface ExpressionEntityRowProps<View> extends BaseEntityRowProps<View> {
    Columns: IColumn[];
    UserFilters: UserFilter[];
}
export interface SharedEntityExpressionRowProps<View> extends SharedEntityRowProps<View> {
    Columns: IColumn[];
    UserFilters: UserFilter[];
}
