"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var _ = require("lodash");
var QuickSearchRedux = require("../../../Redux/ActionsReducers/QuickSearchRedux");
var react_redux_1 = require("react-redux");
var react_dom_1 = require("react-dom");
var AdaptableBlotterToolPanelComponent = /** @class */ (function (_super) {
    tslib_1.__extends(AdaptableBlotterToolPanelComponent, _super);
    function AdaptableBlotterToolPanelComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.debouncedRunQuickSearch = _.debounce(function () { return _this.props.onRunQuickSearch(_this.state.EditedQuickSearchText); }, 0);
        _this.state = {
            EditedQuickSearchText: _this.props.QuickSearchText,
            QuickSearchShowPanel: false,
            QuickSearchShowSettings: false,
        };
        return _this;
        // we got agGrid api from props
        // console.log(this.props.api);
        // console.log(this.props);
    }
    AdaptableBlotterToolPanelComponent.prototype.render = function () {
        return null;
    };
    AdaptableBlotterToolPanelComponent.prototype.onUpdateQuickSearchText = function (searchText) {
        this.setState({ EditedQuickSearchText: searchText });
        this.debouncedRunQuickSearch();
    };
    AdaptableBlotterToolPanelComponent.prototype.onMinimiseQuickSearch = function () {
        this.setState({ QuickSearchShowPanel: false });
    };
    AdaptableBlotterToolPanelComponent.prototype.onMaximiseQuickSearch = function () {
        this.setState({ QuickSearchShowPanel: true });
    };
    AdaptableBlotterToolPanelComponent.prototype.onShowQuickSearchSettings = function () {
        this.setState({ QuickSearchShowSettings: true });
    };
    AdaptableBlotterToolPanelComponent.prototype.onHideQuickSearchSettings = function () {
        this.setState({ QuickSearchShowSettings: false });
    };
    return AdaptableBlotterToolPanelComponent;
}(React.Component));
function mapStateToProps(state, ownProps) {
    return {
        QuickSearchText: state.QuickSearch.QuickSearchText,
    };
}
function mapDispatchToProps(dispatch) {
    return {
        onRunQuickSearch: function (newQuickSearchText) {
            return dispatch(QuickSearchRedux.QuickSearchApply(newQuickSearchText));
        },
    };
}
exports.ConnectedAdaptableBlotterToolPanel = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(AdaptableBlotterToolPanelComponent);
exports.AdaptableBlotterToolPanelBuilder = function (ctx) {
    return /** @class */ (function () {
        function AdaptableBlotterToolPanel() {
            this.ctx = ctx;
        }
        AdaptableBlotterToolPanel.prototype.init = function (params) {
            this.gui = document.createElement('div');
            this.gui.id = 'adaptable-blotter-tool-panel_' + this.ctx.Blotter.blotterOptions.blotterId;
            react_dom_1.render(React.createElement(react_redux_1.Provider, { store: this.ctx.Blotter.adaptableBlotterStore.TheStore },
                React.createElement(exports.ConnectedAdaptableBlotterToolPanel, { Blotter: this.ctx.Blotter, TeamSharingActivated: false })), this.gui);
            if (params && params.api) {
                params.api.addEventListener('modelUpdated', function (newModel) {
                    //    console.log('Model updated', newModel);
                });
            }
        };
        AdaptableBlotterToolPanel.prototype.getGui = function () {
            if (!this.gui) {
                this.init();
            }
            return this.gui;
        };
        AdaptableBlotterToolPanel.prototype.refresh = function () {
            // no refresh logic needed
        };
        return AdaptableBlotterToolPanel;
    }());
};
