import * as React from 'react';
import { AdaptableWizardStep, AdaptableWizardStepProps } from '../../Wizard/Interface/IAdaptableWizard';
import { ConditionalStyleScope } from '../../../PredefinedConfig/Common/Enums';
import { ColumnCategory } from '../../../PredefinedConfig/RunTimeState/ColumnCategoryState';
import { ConditionalStyle } from '../../../PredefinedConfig/RunTimeState/ConditionalStyleState';
export interface ConditionalStyleScopeWizardProps extends AdaptableWizardStepProps<ConditionalStyle> {
    ColumnCategories: Array<ColumnCategory>;
}
export interface ConditionalStyleScopeWizardState {
    ColumnId: string;
    ColumnCategoryId: string;
    ConditionalStyleScope: ConditionalStyleScope;
}
export declare class ConditionalStyleScopeWizard extends React.Component<ConditionalStyleScopeWizardProps, ConditionalStyleScopeWizardState> implements AdaptableWizardStep {
    constructor(props: ConditionalStyleScopeWizardProps);
    render(): any;
    private onColumnSelectedChanged;
    private onColumnCategorySelectedChanged;
    private onScopeSelectChanged;
    canNext(): boolean;
    canBack(): boolean;
    Next(): void;
    Back(): void;
    GetIndexStepIncrement(): number;
    GetIndexStepDecrement(): number;
}
