"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_redux_1 = require("react-redux");
var StrategyConstants = require("../../Utilities/Constants/StrategyConstants");
var PanelWithButton_1 = require("../Components/Panels/PanelWithButton");
var UIHelper_1 = require("../UIHelper");
var Enums_1 = require("../../PredefinedConfig/Common/Enums");
var rebass_1 = require("rebass");
var SimpleButton_1 = require("../../components/SimpleButton");
var DataManagementPopupComponent = /** @class */ (function (_super) {
    tslib_1.__extends(DataManagementPopupComponent, _super);
    function DataManagementPopupComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = UIHelper_1.UIHelper.getEmptyConfigState();
        return _this;
    }
    DataManagementPopupComponent.prototype.render = function () {
        var _this = this;
        var infoBody = ['Function that clears user config - for development use only.'];
        var clearButton = (React.createElement(SimpleButton_1.default, { onClick: function () { return _this.onClear(); }, tooltip: "Clear User Data", tone: "error", variant: "raised", marginTop: 2, AccessLevel: Enums_1.AccessLevel.Full }, "Clear User Data"));
        return (React.createElement(rebass_1.Flex, { flex: 1, flexDirection: "column" },
            React.createElement(PanelWithButton_1.PanelWithButton, { headerText: StrategyConstants.DataManagementStrategyName, button: null, glyphicon: StrategyConstants.DataManagementGlyph, infoBody: infoBody },
                React.createElement(rebass_1.Box, null,
                    "Click below to clear all current state.",
                    React.createElement("br", null),
                    React.createElement("br", null),
                    "When you restart / refresh the Blotter any state that you have previously created will be lost and only the 'predefined config' will be re-added.",
                    React.createElement("br", null),
                    React.createElement("br", null),
                    React.createElement("b", null, "This option only appears in non production builds.")),
                clearButton)));
    };
    DataManagementPopupComponent.prototype.onClear = function () {
        this.props.Blotter.api.configApi.configDeleteLocalStorage();
    };
    return DataManagementPopupComponent;
}(React.Component));
function mapStateToProps(state, ownProps) {
    return {};
}
function mapDispatchToProps(dispatch) {
    return {};
}
exports.DataManagementPopup = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(DataManagementPopupComponent);
