"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_redux_1 = require("react-redux");
var PanelWithButton_1 = require("../Components/Panels/PanelWithButton");
var PopupRedux = require("../../Redux/ActionsReducers/PopupRedux");
var ExportRedux = require("../../Redux/ActionsReducers/ExportRedux");
var SystemRedux = require("../../Redux/ActionsReducers/SystemRedux");
var StringExtensions_1 = require("../../Utilities/Extensions/StringExtensions");
var Enums_1 = require("../../PredefinedConfig/Common/Enums");
var ListGroupItem_1 = require("../../components/List/ListGroupItem");
var ListGroup_1 = require("../../components/List/ListGroup");
var ErrorBox_1 = require("../../components/ErrorBox");
var SimpleButton_1 = require("../../components/SimpleButton");
var icons_1 = require("../../components/icons");
var IPushPullDomainPageSelectorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IPushPullDomainPageSelectorComponent, _super);
    function IPushPullDomainPageSelectorComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.state = { SelectedFolder: null, SelectedPage: null };
        return _this;
    }
    IPushPullDomainPageSelectorComponent.prototype.render = function () {
        var _this = this;
        var itemsElements = [];
        // this line is total rubbish and just here to get the build to work!
        var tempToFixBuild = this.props.LiveReports.find(function (lr) { return lr.Report.Name == _this.props.PopupParams; }).Report;
        this.props.IPPDomainsPages.forEach(function (x) {
            // let itemsElements = this.props.IPPDomainsPages.map(x => {
            if (x.Name == _this.state.SelectedFolder) {
                itemsElements.push(React.createElement(ListGroupItem_1.default, { key: x.Name, onClick: function () {
                        _this.UnSelectFolder();
                    }, value: x.Name },
                    React.createElement(icons_1.Icon, { name: "folder-open" }),
                    " ",
                    x.Name));
                x.Pages.forEach(function (page) {
                    itemsElements.push(React.createElement(ListGroupItem_1.default, { key: page, style: { paddingLeft: '30px' }, disabled: _this.props.LiveReports.findIndex(function (x) { return x.WorkbookName == page; }) > -1, onClick: function () {
                            _this.SelectPage(page);
                        }, active: _this.state.SelectedPage == page, value: page },
                        React.createElement(icons_1.Icon, { name: "cloud-download" }),
                        " ",
                        page));
                });
            }
            else {
                itemsElements.push(React.createElement(ListGroupItem_1.default, { key: x.Name, onClick: function () {
                        _this.SelectFolder(x.Name);
                    }, value: x.Name }, x.Name));
            }
        });
        return (React.createElement(PanelWithButton_1.PanelWithButton, { headerText: "iPushPull Folder and Page Selector", glyphicon: "export" },
            StringExtensions_1.StringExtensions.IsNotNullOrEmpty(this.props.ErrorMsg) ? (React.createElement(ErrorBox_1.default, null,
                "Error getting iPushPull Pages : ",
                this.props.ErrorMsg)) : (React.createElement(ListGroup_1.default, null, itemsElements)),
            React.createElement(SimpleButton_1.default, { onClick: function () {
                    _this.props.onCancel();
                } }, "Cancel"),
            React.createElement(SimpleButton_1.default, { disabled: StringExtensions_1.StringExtensions.IsNullOrEmpty(this.state.SelectedPage), className: "ab_right_modal_button", onClick: function () {
                    _this.props.onApplyExport(tempToFixBuild, _this.state.SelectedFolder, _this.state.SelectedPage);
                } }, "remove Select")));
    };
    IPushPullDomainPageSelectorComponent.prototype.SelectFolder = function (folder) {
        this.setState({ SelectedFolder: folder });
    };
    IPushPullDomainPageSelectorComponent.prototype.SelectPage = function (page) {
        this.setState({ SelectedPage: page });
    };
    IPushPullDomainPageSelectorComponent.prototype.UnSelectFolder = function () {
        this.setState({ SelectedFolder: '', SelectedPage: '' });
    };
    return IPushPullDomainPageSelectorComponent;
}(React.Component));
function mapStateToProps(state, ownProps) {
    return {
        IPPDomainsPages: state.System.IPPDomainsPages,
        ErrorMsg: state.System.ReportErrorMessage,
        LiveReports: state.System.CurrentLiveReports,
    };
}
function mapDispatchToProps(dispatch) {
    return {
        onApplyExport: function (value, folder, page) {
            return dispatch(ExportRedux.ExportApply(value, Enums_1.ExportDestination.iPushPull, folder, page));
        },
        onCancel: function () {
            dispatch(PopupRedux.PopupHideScreen());
            dispatch(SystemRedux.ReportSetErrorMessage(''));
        },
    };
}
exports.IPushPullDomainPageSelector = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(IPushPullDomainPageSelectorComponent);
