"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var WizardSummaryPage_1 = require("../../Components/WizardSummaryPage");
var StrategyConstants = require("../../../Utilities/Constants/StrategyConstants");
var ReportHelper_1 = require("../../../Utilities/Helpers/ReportHelper");
var UIHelper_1 = require("../../UIHelper");
var ReportSummaryWizard = /** @class */ (function (_super) {
    tslib_1.__extends(ReportSummaryWizard, _super);
    function ReportSummaryWizard(props) {
        return _super.call(this, props) || this;
    }
    ReportSummaryWizard.prototype.render = function () {
        var scheduleDescription = this.props.Data.AutoExport
            ? ' (' + UIHelper_1.UIHelper.getScheduleDescription(this.props.Data.AutoExport.Schedule) + ')'
            : 'None';
        var keyValuePairs = [
            { Key: 'Name', Value: this.props.Data.Name },
            {
                Key: 'Columns',
                Value: ReportHelper_1.ReportHelper.GetReportColumnsDescription(this.props.Data, this.props.Columns),
            },
            {
                Key: 'Rows',
                Value: ReportHelper_1.ReportHelper.GetReportExpressionDescription(this.props.Data, this.props.Columns),
            },
            { Key: 'Schedule', Value: scheduleDescription },
        ];
        var summaryPage = (React.createElement(WizardSummaryPage_1.WizardSummaryPage, { KeyValuePairs: keyValuePairs, header: StrategyConstants.ExportStrategyName }));
        return React.createElement("div", null, summaryPage);
    };
    ReportSummaryWizard.prototype.canNext = function () {
        return true;
    };
    ReportSummaryWizard.prototype.canBack = function () {
        return true;
    };
    ReportSummaryWizard.prototype.Next = function () {
        //
    };
    ReportSummaryWizard.prototype.Back = function () {
        //todo
    };
    ReportSummaryWizard.prototype.GetIndexStepIncrement = function () {
        return 1;
    };
    ReportSummaryWizard.prototype.GetIndexStepDecrement = function () {
        return 1;
    };
    return ReportSummaryWizard;
}(React.Component));
exports.ReportSummaryWizard = ReportSummaryWizard;
