import * as React from 'react';
import { IColumn } from '../../Utilities/Interface/IColumn';
import { ExpressionMode, QueryBuildStatus, QueryTab } from '../../PredefinedConfig/Common/Enums';
import { IRawValueDisplayValuePair } from '../UIInterfaces';
import { Expression } from '../../PredefinedConfig/Common/Expression/Expression';
import { IAdaptableBlotter } from '../../Utilities/Interface/IAdaptableBlotter';
import { UserFilter } from '../../PredefinedConfig/RunTimeState/UserFilterState';
import { QueryRange } from '../../PredefinedConfig/Common/Expression/QueryRange';
import { NamedFilter } from '../../PredefinedConfig/RunTimeState/NamedFilterState';
import { ColumnCategory } from '../../PredefinedConfig/RunTimeState/ColumnCategoryState';
export interface ExpressionBuilderConditionSelectorProps extends React.ClassAttributes<ExpressionBuilderConditionSelector> {
    ColumnsList: Array<IColumn>;
    Expression: Expression;
    ExpressionMode: ExpressionMode;
    onExpressionChange: (Expression: Expression) => void;
    onSelectedColumnChange: (ColumnId: string, Tab: QueryTab) => void;
    UserFilters: UserFilter[];
    SystemFilters: string[];
    NamedFilters: NamedFilter[];
    ColumnCategories: ColumnCategory[];
    SelectedColumnId: string;
    SelectedTab: QueryTab;
    QueryBuildStatus: QueryBuildStatus;
    Blotter: IAdaptableBlotter;
}
export interface ExpressionBuilderConditionSelectorState {
    SelectedColumnId: string;
    ColumnRawValueDisplayValuePairs: IRawValueDisplayValuePair[];
    SelectedColumnDisplayValues: Array<any>;
    AllFilterExpresions: Array<string>;
    SelectedFilterExpressions: Array<string>;
    SelectedColumnRanges: Array<QueryRange>;
    QueryBuildStatus: QueryBuildStatus;
    ShowWaitingMessage: boolean;
    SelectedTab: QueryTab;
}
export declare class ExpressionBuilderConditionSelector extends React.Component<ExpressionBuilderConditionSelectorProps, ExpressionBuilderConditionSelectorState> {
    constructor(props: ExpressionBuilderConditionSelectorProps);
    static getDerivedStateFromProps(props: ExpressionBuilderConditionSelectorProps, state: ExpressionBuilderConditionSelectorState): any;
    private static buildState;
    private static buildColumnValuesState;
    render(): JSX.Element;
    onSelectTab(): any;
    onTabChanged(tab: QueryTab): any;
    onSelectedColumnChanged(): void;
    onSelectedColumnRangesChange(selectedRanges: Array<QueryRange>): void;
    onSelectedColumnValuesChange(selectedColumnDisplayValues: Array<any>): void;
    onSelectedFiltersChanged(selectedFilters: Array<string>): void;
    private onColumnSelectChange;
    private getRawValuesForDisplayValues;
}
