import * as React from 'react';
import { IColumn } from '../../Utilities/Interface/IColumn';
import { AdaptableWizardStep } from '../Wizard/Interface/IAdaptableWizard';
import { ExpressionMode, QueryBuildStatus, QueryTab } from '../../PredefinedConfig/Common/Enums';
import { UserFilter } from '../../PredefinedConfig/RunTimeState/UserFilterState';
import { Expression } from '../../PredefinedConfig/Common/Expression/Expression';
import { IAdaptableBlotter } from '../../Utilities/Interface/IAdaptableBlotter';
import { NamedFilter } from '../../PredefinedConfig/RunTimeState/NamedFilterState';
import { ColumnCategory } from '../../PredefinedConfig/RunTimeState/ColumnCategoryState';
export interface ExpressionBuilderPageProps extends React.ClassAttributes<ExpressionBuilderPage> {
    UserFilters: Array<UserFilter>;
    SystemFilters: Array<string>;
    NamedFilters: Array<NamedFilter>;
    ColumnCategories: Array<ColumnCategory>;
    ExpressionMode?: ExpressionMode;
    UpdateGoBackState?(finish?: boolean): void;
    StepName?: string;
    Columns?: Array<IColumn>;
    Blotter?: IAdaptableBlotter;
}
export interface ExpressionBuilderPageState {
    Expression: Expression;
    SelectedColumnId: string;
    SelectedTab: QueryTab;
}
export declare class ExpressionBuilderPage extends React.Component<ExpressionBuilderPageProps, ExpressionBuilderPageState> implements AdaptableWizardStep {
    render(): JSX.Element;
    getQueryBuildStatus(): QueryBuildStatus;
    onSelectedColumnChanged(): void;
    DeleteColumnValue(columnId: string, value: any): void;
    DeleteUserFilterExpression(columnId: string, index: number): void;
    DeleteRange(columnId: string, index: number): void;
    DeleteAllColumnExpression(columnId: string): void;
    onChangeExpression(newExpression: Expression): void;
    onSelectedColumnChange(columnId: string, tab: QueryTab): void;
    canNext(): boolean;
    canBack(): boolean;
    Next(): void;
    Back(): void;
    GetIndexStepIncrement(): number;
    GetIndexStepDecrement(): number;
    StepName: string;
}
