import * as React from 'react';
import { StrategySummaryProps } from '../Components/SharedProps/StrategySummaryProps';
import { EditableConfigEntityState } from '../Components/SharedProps/EditableConfigEntityState';
import * as FormatColumnRedux from '../../Redux/ActionsReducers/FormatColumnRedux';
import * as TeamSharingRedux from '../../Redux/ActionsReducers/TeamSharingRedux';
import { AdaptableBlotterObject } from '../../PredefinedConfig/AdaptableBlotterObject';
import { FormatColumn } from '../../PredefinedConfig/RunTimeState/FormatColumnState';
export interface FormatColumnSummaryProps extends StrategySummaryProps<FormatColumnSummaryComponent> {
    FormatColumns: FormatColumn[];
    ColorPalette: string[];
    StyleClassNames: string[];
    onAddFormatColumn: (FormatColumn: FormatColumn) => FormatColumnRedux.FormatColumnAddAction;
    onEditFormatColumn: (FormatColumn: FormatColumn) => FormatColumnRedux.FormatColumnEditAction;
    onShare: (entity: AdaptableBlotterObject) => TeamSharingRedux.TeamSharingShareAction;
}
export declare class FormatColumnSummaryComponent extends React.Component<FormatColumnSummaryProps, EditableConfigEntityState> {
    constructor(props: FormatColumnSummaryProps);
    render(): any;
    onNew(): void;
    onEdit(formatColumn: FormatColumn): void;
    onCloseWizard(): void;
    onFinishWizard(): void;
    canFinishWizard(): boolean;
}
export declare let FormatColumnSummary: React.ComponentClass<any, any>;
