"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var WizardSummaryPage_1 = require("../../Components/WizardSummaryPage");
var StrategyConstants = require("../../../Utilities/Constants/StrategyConstants");
var LayoutHelper_1 = require("../../../Utilities/Helpers/LayoutHelper");
var ColumnHelper_1 = require("../../../Utilities/Helpers/ColumnHelper");
var LayoutSummaryWizard = /** @class */ (function (_super) {
    tslib_1.__extends(LayoutSummaryWizard, _super);
    function LayoutSummaryWizard(props) {
        return _super.call(this, props) || this;
    }
    LayoutSummaryWizard.prototype.render = function () {
        var keyValuePairs = [
            { Key: 'Name', Value: this.props.Data.Name },
            { Key: 'Columns', Value: this.getColumnNames() },
            {
                Key: 'Column Sorts',
                Value: LayoutHelper_1.LayoutHelper.getColumnSort(this.props.Data.ColumnSorts, this.props.Columns),
            },
        ];
        var summaryPage = (React.createElement(WizardSummaryPage_1.WizardSummaryPage, { KeyValuePairs: keyValuePairs, header: StrategyConstants.LayoutStrategyName }));
        return React.createElement("div", null, summaryPage);
    };
    LayoutSummaryWizard.prototype.canNext = function () {
        return true;
    };
    LayoutSummaryWizard.prototype.getColumnNames = function () {
        return ColumnHelper_1.ColumnHelper.getFriendlyNamesFromColumnIds(this.props.Data.Columns, this.props.Columns).join(', ');
    };
    LayoutSummaryWizard.prototype.canBack = function () {
        return true;
    };
    LayoutSummaryWizard.prototype.Next = function () {
        //
    };
    LayoutSummaryWizard.prototype.Back = function () {
        // todo
    };
    LayoutSummaryWizard.prototype.GetIndexStepIncrement = function () {
        return 1;
    };
    LayoutSummaryWizard.prototype.GetIndexStepDecrement = function () {
        return 1;
    };
    return LayoutSummaryWizard;
}(React.Component));
exports.LayoutSummaryWizard = LayoutSummaryWizard;
