"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var AdaptableWizard_1 = require("../../Wizard/AdaptableWizard");
var LayoutSelectionWizard_1 = require("./LayoutSelectionWizard");
var LayoutColumnWizard_1 = require("./LayoutColumnWizard");
var LayoutSettingsWizard_1 = require("./LayoutSettingsWizard");
var LayoutGridSortWizard_1 = require("./LayoutGridSortWizard");
var LayoutSummaryWizard_1 = require("./LayoutSummaryWizard");
var StrategyConstants = require("../../../Utilities/Constants/StrategyConstants");
var LayoutWizard = /** @class */ (function (_super) {
    tslib_1.__extends(LayoutWizard, _super);
    function LayoutWizard() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LayoutWizard.prototype.render = function () {
        var _this = this;
        var layouts = this.props.ConfigEntities;
        return (React.createElement("div", null,
            React.createElement(AdaptableWizard_1.AdaptableWizard, { FriendlyName: StrategyConstants.LayoutStrategyName, ModalContainer: this.props.ModalContainer, Blotter: this.props.Blotter, Columns: this.props.Columns, Steps: [
                    {
                        StepName: 'Layout Source',
                        Index: 0,
                        Element: (React.createElement(LayoutSelectionWizard_1.LayoutSelectionWizard, { Layouts: layouts, ColumnSorts: this.props.ColumnSorts })),
                    },
                    {
                        StepName: 'Select Columns',
                        Index: 1,
                        Element: React.createElement(LayoutColumnWizard_1.LayoutColumnWizard, null),
                    },
                    {
                        StepName: 'Set Column Sorts',
                        Index: 2,
                        Element: React.createElement(LayoutGridSortWizard_1.LayoutGridSortWizard, null),
                    },
                    {
                        StepName: 'Settings',
                        Index: 3,
                        Element: React.createElement(LayoutSettingsWizard_1.LayoutSettingsWizard, { Layouts: layouts }),
                    },
                    {
                        StepName: 'Summary',
                        Index: 4,
                        Element: React.createElement(LayoutSummaryWizard_1.LayoutSummaryWizard, null),
                    },
                ], Data: this.props.EditedAdaptableBlotterObject, StepStartIndex: this.props.WizardStartIndex, onHide: function () { return _this.props.onCloseWizard(); }, onFinish: function () { return _this.props.onFinishWizard(); }, canFinishWizard: function () { return _this.props.canFinishWizard(); } }),
            ">"));
    };
    return LayoutWizard;
}(React.Component));
exports.LayoutWizard = LayoutWizard;
