"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var StringExtensions_1 = require("../../../Utilities/Extensions/StringExtensions");
var Enums_1 = require("../../../PredefinedConfig/Common/Enums");
var ColumnSelector_1 = require("../../Components/Selectors/ColumnSelector");
var ColumnHelper_1 = require("../../../Utilities/Helpers/ColumnHelper");
var WizardPanel_1 = require("../../../components/WizardPanel");
var PercentBarSelectColumnWizard = /** @class */ (function (_super) {
    tslib_1.__extends(PercentBarSelectColumnWizard, _super);
    function PercentBarSelectColumnWizard(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            ColumnId: _this.props.Data.ColumnId,
            MinValue: _this.props.Data.MinValue,
            MaxValue: _this.props.Data.MaxValue,
        };
        return _this;
    }
    PercentBarSelectColumnWizard.prototype.render = function () {
        var _this = this;
        return (React.createElement(WizardPanel_1.default, null,
            React.createElement(ColumnSelector_1.ColumnSelector, { SelectedColumnIds: [this.state.ColumnId], ColumnList: ColumnHelper_1.ColumnHelper.getNumericColumns(this.props.Columns), onColumnChange: function (columns) { return _this.onColumnSelectedChanged(columns); }, SelectionMode: Enums_1.SelectionMode.Single })));
    };
    PercentBarSelectColumnWizard.prototype.onColumnSelectedChanged = function (columns) {
        var _this = this;
        if (columns.length > 0) {
            var distinctColumnsValues = this.props.Blotter.getColumnValueDisplayValuePairDistinctList(columns[0].ColumnId, Enums_1.DistinctCriteriaPairValue.RawValue, false).map(function (pair) {
                return pair.RawValue;
            });
            var minValue = Math.min.apply(Math, tslib_1.__spread(distinctColumnsValues));
            var maxValue = Math.max.apply(Math, tslib_1.__spread(distinctColumnsValues));
            this.setState({
                ColumnId: columns[0].ColumnId,
                MinValue: minValue,
                MaxValue: maxValue,
            }, function () { return _this.props.UpdateGoBackState(); });
        }
        else {
            this.setState({ ColumnId: '' }, function () {
                return _this.props.UpdateGoBackState();
            });
        }
    };
    PercentBarSelectColumnWizard.prototype.canNext = function () {
        return StringExtensions_1.StringExtensions.IsNotNullOrEmpty(this.state.ColumnId);
    };
    PercentBarSelectColumnWizard.prototype.canBack = function () {
        return true;
    };
    PercentBarSelectColumnWizard.prototype.Next = function () {
        this.props.Data.ColumnId = this.state.ColumnId;
        this.props.Data.MinValue = this.state.MinValue;
        this.props.Data.MaxValue = this.state.MaxValue;
    };
    PercentBarSelectColumnWizard.prototype.Back = function () {
        //todo
    };
    PercentBarSelectColumnWizard.prototype.GetIndexStepIncrement = function () {
        return 1;
    };
    PercentBarSelectColumnWizard.prototype.GetIndexStepDecrement = function () {
        return 1;
    };
    return PercentBarSelectColumnWizard;
}(React.Component));
exports.PercentBarSelectColumnWizard = PercentBarSelectColumnWizard;
