import * as React from 'react';
import { AdaptableWizardStep, AdaptableWizardStepProps } from '../../Wizard/Interface/IAdaptableWizard';
import { PercentBar } from '../../../PredefinedConfig/RunTimeState/PercentBarState';
export interface PercentBarSettingsWizardProps extends AdaptableWizardStepProps<PercentBar> {
    ColorPalette: Array<string>;
}
export interface PercentBarSettingsWizardState {
    PositiveColor: string;
    NegativeColor: string;
    ShowValue: boolean;
    ShowTooltip: boolean;
}
export declare class PercentBarSettingsWizard extends React.Component<PercentBarSettingsWizardProps, PercentBarSettingsWizardState> implements AdaptableWizardStep {
    constructor(props: PercentBarSettingsWizardProps);
    render(): any;
    private onPositiveColorSelectChanged;
    private onNegativeColorSelectChanged;
    private onShowValueChanged;
    private onShowTooltipChanged;
    canNext(): boolean;
    canBack(): boolean;
    Next(): void;
    Back(): void;
    GetIndexStepIncrement(): number;
    GetIndexStepDecrement(): number;
}
