"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var Enums_1 = require("../../../PredefinedConfig/Common/Enums");
var AdaptablePopover_1 = require("../../AdaptablePopover");
var ColumnSelector_1 = require("../../Components/Selectors/ColumnSelector");
var StringExtensions_1 = require("../../../Utilities/Extensions/StringExtensions");
var WizardPanel_1 = require("../../../components/WizardPanel");
var Panel_1 = require("../../../components/Panel");
var Radio_1 = require("../../../components/Radio");
var rebass_1 = require("rebass");
var Input_1 = require("../../../components/Input");
var PercentBarValuesWizard = /** @class */ (function (_super) {
    tslib_1.__extends(PercentBarValuesWizard, _super);
    function PercentBarValuesWizard(props) {
        var _this = _super.call(this, props) || this;
        _this.onMinValueChanged = function (e) {
            _this.setState({ MinValue: e.target.value }, function () {
                return _this.props.UpdateGoBackState();
            });
        };
        _this.onMaxValueChanged = function (e) {
            _this.setState({ MaxValue: e.target.value }, function () {
                return _this.props.UpdateGoBackState();
            });
        };
        _this.state = {
            MinValue: _this.props.Data.MinValue,
            MaxValue: _this.props.Data.MaxValue,
            MinValueColumnId: _this.props.Data.MinValueColumnId,
            MaxValueColumnId: _this.props.Data.MaxValueColumnId,
            UseMinColumn: StringExtensions_1.StringExtensions.IsNotNullOrEmpty(_this.props.Data.MinValueColumnId),
            UseMaxColumn: StringExtensions_1.StringExtensions.IsNotNullOrEmpty(_this.props.Data.MaxValueColumnId),
        };
        return _this;
    }
    PercentBarValuesWizard.prototype.render = function () {
        var _this = this;
        return (React.createElement(WizardPanel_1.default, null,
            React.createElement(Panel_1.default, { header: 'Minimum Value', marginTop: 2 },
                React.createElement(rebass_1.Flex, { flexDirection: "row", alignItems: "center" },
                    React.createElement(rebass_1.Text, { style: { flex: 3 }, textAlign: "end", marginRight: 2 }, "Use:"),
                    React.createElement(rebass_1.Flex, { flex: 7, alignItems: "center" },
                        React.createElement(Radio_1.default, { marginRight: 2, value: "value", checked: this.state.UseMinColumn == false, onChange: function (_, e) { return _this.onUseMinColumnSelectChanged(e); } }, "Static Value"),
                        ' ',
                        React.createElement(Radio_1.default, { marginRight: 2, value: "column", checked: this.state.UseMinColumn == true, onChange: function (_, e) { return _this.onUseMinColumnSelectChanged(e); } }, "Another Column Value"),
                        React.createElement(AdaptablePopover_1.AdaptablePopover, { headerText: 'Percent Bar: Minimum Value', bodyText: [
                                'The minimum value of the column (can be minus).  Defaults to the currenty smallest value in the column.  If the column only contains positive numbers use 0.  Additionally, you can set the value to be that in another column.',
                            ] }))),
                React.createElement(rebass_1.Flex, { flexDirection: "row", alignItems: "center" },
                    React.createElement(rebass_1.Text, { style: { flex: 3 }, textAlign: "end", marginRight: 2 }, this.state.UseMinColumn == false ? 'Value' : 'Column'),
                    React.createElement(rebass_1.Flex, { flex: 7, alignItems: "center" }, this.state.UseMinColumn == false ? (React.createElement(Input_1.default, { type: "number", placeholder: "Enter Number", onChange: this.onMinValueChanged, value: this.state.MinValue })) : (React.createElement(ColumnSelector_1.ColumnSelector, { SelectedColumnIds: [this.state.MinValueColumnId], ColumnList: this.props.Columns, onColumnChange: function (columns) { return _this.onColumnMinValueSelectedChanged(columns); }, SelectionMode: Enums_1.SelectionMode.Single }))))),
            React.createElement(Panel_1.default, { header: "Maximum Value", marginTop: 2 },
                React.createElement(rebass_1.Flex, { flexDirection: "row", alignItems: "center" },
                    React.createElement(rebass_1.Text, { style: { flex: 3 }, textAlign: "end", marginRight: 2 }, "Use:"),
                    React.createElement(rebass_1.Flex, { flex: 7, alignItems: "center" },
                        React.createElement(Radio_1.default, { marginRight: 2, value: "value", checked: this.state.UseMaxColumn == false, onChange: function (checked, e) { return _this.onUseMaxColumnSelectChanged(e); } }, "Static Value"),
                        ' ',
                        React.createElement(Radio_1.default, { marginRight: 2, value: "column", checked: this.state.UseMaxColumn == true, onChange: function (checked, e) { return _this.onUseMaxColumnSelectChanged(e); } }, "Another Column Value"),
                        React.createElement(AdaptablePopover_1.AdaptablePopover, { headerText: 'Percent Bar: Maximum Value', bodyText: [
                                'The maximum value of the bar.  Defaults to the currently largest value in the column.  Additionally, you can set the value to be that in another column.',
                            ] }))),
                React.createElement(rebass_1.Flex, { flexDirection: "row", alignItems: "center", marginTop: 2 },
                    React.createElement(rebass_1.Text, { style: { flex: 3 }, textAlign: "end", marginRight: 2 }, this.state.UseMaxColumn == false ? 'Value' : 'Column'),
                    React.createElement(rebass_1.Flex, { flex: 7, alignItems: "center" }, this.state.UseMaxColumn == false ? (React.createElement(Input_1.default, { type: "number", placeholder: "Enter Number", onChange: this.onMaxValueChanged, value: this.state.MaxValue })) : (React.createElement(ColumnSelector_1.ColumnSelector, { SelectedColumnIds: [this.state.MaxValueColumnId], ColumnList: this.props.Columns, onColumnChange: function (columns) { return _this.onColumnMaxValueSelectedChanged(columns); }, SelectionMode: Enums_1.SelectionMode.Single })))))));
    };
    PercentBarValuesWizard.prototype.onUseMinColumnSelectChanged = function (event) {
        var _this = this;
        var e = event.target;
        this.setState({ UseMinColumn: e.value == 'column' }, function () {
            return _this.props.UpdateGoBackState();
        });
    };
    PercentBarValuesWizard.prototype.onColumnMinValueSelectedChanged = function (columns) {
        var _this = this;
        this.setState({
            MinValueColumnId: columns.length > 0 ? columns[0].ColumnId : '',
        }, function () { return _this.props.UpdateGoBackState(); });
    };
    PercentBarValuesWizard.prototype.onUseMaxColumnSelectChanged = function (event) {
        var _this = this;
        var e = event.target;
        this.setState({ UseMaxColumn: e.value == 'column' }, function () {
            return _this.props.UpdateGoBackState();
        });
    };
    PercentBarValuesWizard.prototype.onColumnMaxValueSelectedChanged = function (columns) {
        var _this = this;
        this.setState({
            MaxValueColumnId: columns.length > 0 ? columns[0].ColumnId : '',
        }, function () { return _this.props.UpdateGoBackState(); });
    };
    PercentBarValuesWizard.prototype.canNext = function () {
        if (StringExtensions_1.StringExtensions.IsNullOrEmpty(this.props.Data.ColumnId)) {
            return false;
        }
        if (this.state.UseMinColumn && StringExtensions_1.StringExtensions.IsNullOrEmpty(this.state.MinValueColumnId)) {
            return false;
        }
        if (this.state.UseMaxColumn && StringExtensions_1.StringExtensions.IsNullOrEmpty(this.state.MaxValueColumnId)) {
            return false;
        }
        return true;
    };
    PercentBarValuesWizard.prototype.canBack = function () {
        return true;
    };
    PercentBarValuesWizard.prototype.Next = function () {
        this.props.Data.MinValue = this.state.UseMinColumn ? 0 : this.state.MinValue;
        this.props.Data.MaxValue = this.state.UseMaxColumn ? 100 : this.state.MaxValue;
        this.props.Data.MinValueColumnId = this.state.UseMinColumn ? this.state.MinValueColumnId : null;
        this.props.Data.MaxValueColumnId = this.state.UseMaxColumn ? this.state.MaxValueColumnId : null;
    };
    PercentBarValuesWizard.prototype.Back = function () {
        //todo
    };
    PercentBarValuesWizard.prototype.GetIndexStepIncrement = function () {
        return 1;
    };
    PercentBarValuesWizard.prototype.GetIndexStepDecrement = function () {
        return 1;
    };
    return PercentBarValuesWizard;
}(React.Component));
exports.PercentBarValuesWizard = PercentBarValuesWizard;
