import * as React from 'react';
import { AdaptableWizardStep, AdaptableWizardStepProps } from '../../Wizard/Interface/IAdaptableWizard';
import { MessageType } from '../../../PredefinedConfig/Common/Enums';
import { Reminder } from '../../../PredefinedConfig/RunTimeState/ReminderState';
export interface ReminderMessageWizardProps extends AdaptableWizardStepProps<Reminder> {
}
export interface ReminderMessageWizardState {
    Header: string;
    Msg: string;
    MessageType: MessageType;
    ShowAsPopup: boolean;
}
export declare class ReminderMessageWizard extends React.Component<ReminderMessageWizardProps, ReminderMessageWizardState> implements AdaptableWizardStep {
    constructor(props: ReminderMessageWizardProps);
    render(): any;
    private onHeaderChanged;
    private onMessageChanged;
    private onMessageTypeChanged;
    private onShowAsPopupChanged;
    canNext(): boolean;
    canBack(): boolean;
    Next(): void;
    Back(): void;
    GetIndexStepIncrement(): number;
    GetIndexStepDecrement(): number;
}
