"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var Enums_1 = require("../../../PredefinedConfig/Common/Enums");
var ArrayExtensions_1 = require("../../../Utilities/Extensions/ArrayExtensions");
var WizardPanel_1 = require("../../../components/WizardPanel");
var rebass_1 = require("rebass");
var Dropdown_1 = require("../../../components/Dropdown");
var Radio_1 = require("../../../components/Radio");
var CheckBox_1 = require("../../../components/CheckBox");
var Input_1 = require("../../../components/Input");
var ReminderScheduleWizard = /** @class */ (function (_super) {
    tslib_1.__extends(ReminderScheduleWizard, _super);
    function ReminderScheduleWizard(props) {
        var _this = _super.call(this, props) || this;
        _this.onOneOffDateChanged = function (event) {
            var e = event.target;
            _this.setState({ OneOffDate: e.value }, function () {
                return _this.props.UpdateGoBackState();
            });
        };
        _this.state = {
            IsRecurringDate: _this.props.Data.Schedule.OneOffDate == null ? true : false,
            Hour: _this.props.Data.Schedule.Hour,
            Minute: _this.props.Data.Schedule.Minute,
            DaysOfWeek: _this.props.Data.Schedule.DaysOfWeek,
            OneOffDate: _this.props.Data.Schedule.OneOffDate
                ? _this.props.Data.Schedule.OneOffDate
                : new Date(),
        };
        return _this;
    }
    ReminderScheduleWizard.prototype.render = function () {
        var _this = this;
        var hours = [];
        var i;
        for (i = 0; i < 24; i++) {
            hours.push({
                label: i,
                value: i,
            });
        }
        var minutes = [];
        var j;
        for (j = 0; j < 60; j++) {
            minutes.push({
                label: j,
                value: j,
            });
        }
        return (React.createElement("div", null,
            React.createElement(WizardPanel_1.default, null,
                React.createElement(rebass_1.Flex, { alignItems: "center", flexDirection: "row" },
                    React.createElement(rebass_1.Text, { style: { flex: 1 } }, "Hour"),
                    React.createElement(rebass_1.Box, { style: { flex: 6 } },
                        React.createElement(Dropdown_1.default, { placeholder: "select", value: this.state.Hour, onChange: function (value) { return _this.onHourChanged(value); }, options: hours }))),
                React.createElement(rebass_1.Flex, { alignItems: "center", flexDirection: "row", marginTop: 2 },
                    React.createElement(rebass_1.Text, { style: { flex: 1 } }, "Minute:"),
                    React.createElement(rebass_1.Box, { style: { flex: 6 } },
                        React.createElement(Dropdown_1.default, { placeholder: "select", value: this.state.Minute, onChange: function (value) { return _this.onMinuteChanged(value); }, options: minutes }))),
                React.createElement(rebass_1.Flex, { alignItems: "center", flexDirection: "row", marginTop: 2, marginBottom: 2 },
                    React.createElement(rebass_1.Text, { style: { flex: 1 } }, "Date:"),
                    React.createElement(rebass_1.Box, { style: { flex: 6 } },
                        React.createElement(Radio_1.default, { marginRight: 3, value: "recurring", checked: this.state.IsRecurringDate == true, onChange: function (checked) { return _this.onRecurringDateChanged(checked); } }, "Recurring Days"),
                        React.createElement(Radio_1.default, { value: "oneoff", checked: this.state.IsRecurringDate == false, onChange: function (checked) { return _this.onRecurringDateChanged(!checked); } }, "One Off Date"))),
                this.state.IsRecurringDate ? (React.createElement(rebass_1.Flex, null,
                    React.createElement("div", { style: { flex: 1 } }),
                    React.createElement(rebass_1.Flex, { padding: 2, style: { flex: 6 }, flexDirection: "column" },
                        React.createElement(CheckBox_1.default, { value: Enums_1.DayOfWeek.Monday, checked: ArrayExtensions_1.ArrayExtensions.ContainsItem(this.state.DaysOfWeek, Enums_1.DayOfWeek.Monday), onChange: function (checked, e) { return _this.onDayChecked(e); } }, "Monday"),
                        React.createElement(CheckBox_1.default, { value: Enums_1.DayOfWeek.Tuesday, checked: ArrayExtensions_1.ArrayExtensions.ContainsItem(this.state.DaysOfWeek, Enums_1.DayOfWeek.Tuesday), onChange: function (checked, e) { return _this.onDayChecked(e); } }, "Tuesday"),
                        React.createElement(CheckBox_1.default, { value: Enums_1.DayOfWeek.Wednesday, checked: ArrayExtensions_1.ArrayExtensions.ContainsItem(this.state.DaysOfWeek, Enums_1.DayOfWeek.Wednesday), onChange: function (checked, e) { return _this.onDayChecked(e); } }, "Wednesday"),
                        React.createElement(CheckBox_1.default, { value: Enums_1.DayOfWeek.Thursday, checked: ArrayExtensions_1.ArrayExtensions.ContainsItem(this.state.DaysOfWeek, Enums_1.DayOfWeek.Thursday), onChange: function (checked, e) { return _this.onDayChecked(e); } }, "Thursday"),
                        React.createElement(CheckBox_1.default, { value: Enums_1.DayOfWeek.Friday, checked: ArrayExtensions_1.ArrayExtensions.ContainsItem(this.state.DaysOfWeek, Enums_1.DayOfWeek.Friday), onChange: function (checked, e) { return _this.onDayChecked(e); } }, "Friday"),
                        React.createElement(CheckBox_1.default, { value: Enums_1.DayOfWeek.Saturday, checked: ArrayExtensions_1.ArrayExtensions.ContainsItem(this.state.DaysOfWeek, Enums_1.DayOfWeek.Saturday), onChange: function (checked, e) { return _this.onDayChecked(e); } }, "Saturday"),
                        React.createElement(CheckBox_1.default, { value: Enums_1.DayOfWeek.Sunday, checked: ArrayExtensions_1.ArrayExtensions.ContainsItem(this.state.DaysOfWeek, Enums_1.DayOfWeek.Sunday), onChange: function (checked, e) { return _this.onDayChecked(e); } }, "Sunday")))) : (React.createElement(rebass_1.Flex, null,
                    React.createElement("div", { style: { flex: 1 } }),
                    React.createElement(rebass_1.Box, { style: { flex: 6 } },
                        React.createElement(Input_1.default, { style: { maxWidth: 400 }, type: "date", placeholder: "Date", onChange: function (x) { return _this.onOneOffDateChanged(x); }, value: this.state.OneOffDate })))))));
    };
    ReminderScheduleWizard.prototype.onDayChecked = function (event) {
        var _this = this;
        var e = event.target;
        var dayOfWeek = Number(e.value);
        var daysOfWeek = this.state.DaysOfWeek;
        if (e.checked) {
            daysOfWeek.push(dayOfWeek);
        }
        else {
            var index = daysOfWeek.indexOf(dayOfWeek);
            daysOfWeek.splice(index, 1);
        }
        this.setState({ DaysOfWeek: daysOfWeek }, function () {
            return _this.props.UpdateGoBackState();
        });
    };
    ReminderScheduleWizard.prototype.onRecurringDateChanged = function (checked) {
        var _this = this;
        this.setState({ IsRecurringDate: checked }, function () {
            return _this.props.UpdateGoBackState();
        });
    };
    ReminderScheduleWizard.prototype.onHourChanged = function (value) {
        var _this = this;
        this.setState({ Hour: Number(value) }, function () {
            return _this.props.UpdateGoBackState();
        });
    };
    ReminderScheduleWizard.prototype.onMinuteChanged = function (value) {
        var _this = this;
        this.setState({ Minute: Number(value) }, function () {
            return _this.props.UpdateGoBackState();
        });
    };
    ReminderScheduleWizard.prototype.canNext = function () {
        if (this.state.Hour == null || this.state.Minute == null) {
            return false;
        }
        if (this.state.IsRecurringDate && ArrayExtensions_1.ArrayExtensions.IsEmpty(this.state.DaysOfWeek)) {
            return false;
        }
        if (!this.state.IsRecurringDate && this.state.OneOffDate == null) {
            return false;
        }
        return true;
    };
    ReminderScheduleWizard.prototype.canBack = function () {
        return true;
    };
    ReminderScheduleWizard.prototype.Next = function () {
        var schedule = {
            Hour: this.state.Hour,
            Minute: this.state.Minute,
            OneOffDate: this.state.IsRecurringDate ? null : this.state.OneOffDate,
            DaysOfWeek: this.state.IsRecurringDate ? this.state.DaysOfWeek : [],
        };
        this.props.Data.Schedule = schedule;
    };
    ReminderScheduleWizard.prototype.Back = function () {
        //todo
    };
    ReminderScheduleWizard.prototype.GetIndexStepIncrement = function () {
        return 1;
    };
    ReminderScheduleWizard.prototype.GetIndexStepDecrement = function () {
        return 1;
    };
    return ReminderScheduleWizard;
}(React.Component));
exports.ReminderScheduleWizard = ReminderScheduleWizard;
