"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var WizardSummaryPage_1 = require("../../Components/WizardSummaryPage");
var StrategyConstants = require("../../../Utilities/Constants/StrategyConstants");
var UIHelper_1 = require("../../UIHelper");
var ReminderSummaryWizard = /** @class */ (function (_super) {
    tslib_1.__extends(ReminderSummaryWizard, _super);
    function ReminderSummaryWizard(props) {
        return _super.call(this, props) || this;
    }
    ReminderSummaryWizard.prototype.render = function () {
        var keyValuePairs = [
            { Key: 'Header', Value: this.props.Data.Alert.Header },
            { Key: 'Message', Value: this.props.Data.Alert.Msg },
            { Key: 'Message Type', Value: this.props.Data.Alert.MessageType },
            { Key: 'Show as Popup', Value: this.props.Data.Alert.ShowAsPopup ? 'True' : 'False' },
            { Key: 'Schedule', Value: UIHelper_1.UIHelper.getScheduleDescription(this.props.Data.Schedule) },
        ];
        var summaryPage = (React.createElement(WizardSummaryPage_1.WizardSummaryPage, { KeyValuePairs: keyValuePairs, header: StrategyConstants.ReminderStrategyName }));
        return React.createElement("div", null, summaryPage);
    };
    ReminderSummaryWizard.prototype.canNext = function () {
        return true;
    };
    ReminderSummaryWizard.prototype.canBack = function () {
        return true;
    };
    ReminderSummaryWizard.prototype.Next = function () {
        /* no implementation */
    };
    ReminderSummaryWizard.prototype.Back = function () {
        /* no implementation */
    };
    ReminderSummaryWizard.prototype.GetIndexStepIncrement = function () {
        return 1;
    };
    ReminderSummaryWizard.prototype.GetIndexStepDecrement = function () {
        return 1;
    };
    return ReminderSummaryWizard;
}(React.Component));
exports.ReminderSummaryWizard = ReminderSummaryWizard;
