"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var AdaptableWizard_1 = require("../../Wizard/AdaptableWizard");
var StrategyConstants = require("../../../Utilities/Constants/StrategyConstants");
var ReminderSummaryWizard_1 = require("./ReminderSummaryWizard");
var ReminderMessageWizard_1 = require("./ReminderMessageWizard");
var ReminderScheduleWizard_1 = require("./ReminderScheduleWizard");
var ReminderWizard = /** @class */ (function (_super) {
    tslib_1.__extends(ReminderWizard, _super);
    function ReminderWizard() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ReminderWizard.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", null,
            React.createElement(AdaptableWizard_1.AdaptableWizard, { FriendlyName: StrategyConstants.ReminderStrategyName, ModalContainer: this.props.ModalContainer, Blotter: this.props.Blotter, Columns: this.props.Columns, Steps: [
                    {
                        StepName: 'Message',
                        Index: 0,
                        Element: React.createElement(ReminderMessageWizard_1.ReminderMessageWizard, null),
                    },
                    {
                        StepName: 'Schedule',
                        Index: 1,
                        Element: React.createElement(ReminderScheduleWizard_1.ReminderScheduleWizard, null),
                    },
                    {
                        StepName: 'Summary',
                        Index: 2,
                        Element: React.createElement(ReminderSummaryWizard_1.ReminderSummaryWizard, null),
                    },
                ], Data: this.props.EditedAdaptableBlotterObject, StepStartIndex: this.props.WizardStartIndex, onHide: function () { return _this.props.onCloseWizard(); }, onFinish: function () { return _this.props.onFinishWizard(); }, canFinishWizard: function () { return _this.props.canFinishWizard(); } })));
    };
    return ReminderWizard;
}(React.Component));
exports.ReminderWizard = ReminderWizard;
