import { CSSProperties } from 'react';
import { EditableConfigEntityState } from './Components/SharedProps/EditableConfigEntityState';
import { DataType, StatusColour, MessageType } from '../PredefinedConfig/Common/Enums';
import { AdaptableBlotterOptions } from '../BlotterOptions/AdaptableBlotterOptions';
import { IStyle } from '../PredefinedConfig/Common/IStyle';
import { ExpressionBuilderPageState } from './ExpressionBuilder/ExpressionBuilderPage';
import { Expression } from '../PredefinedConfig/Common/Expression/Expression';
import { Schedule } from '../PredefinedConfig/Common/Schedule';
export declare function getDefaultColors(): string[];
export declare function getEmptyConfigState(): EditableConfigEntityState;
export declare function getExpressionBuilderState(expression: Expression): ExpressionBuilderPageState;
export declare function getExpressionBuilderStateWithColumn(expression: Expression, columnId: string): ExpressionBuilderPageState;
export declare function getDescriptionForDataType(dataType: DataType): "string" | "number" | "date";
export declare function getPlaceHolderforDataType(dataType: DataType): "Enter Value" | "Enter Number" | "Enter Date";
export declare function getModalContainer(blotterOptions: AdaptableBlotterOptions, document: Document): HTMLElement;
export declare function getChartContainer(blotterOptions: AdaptableBlotterOptions, document: Document, showModal: boolean): HTMLElement;
export declare function isValidUserChartContainer(blotterOptions: AdaptableBlotterOptions, document: Document): boolean;
export declare function IsNotEmptyStyle(style: IStyle): boolean;
export declare function getMessageTypeByStatusColour(statusColour: StatusColour): MessageType;
export declare function getGlyphByMessageType(messageType: MessageType): string;
export declare function getColorByMessageType(messageType: MessageType): string;
export declare function getStyleForStatusColour(statusColour: StatusColour): CSSProperties;
export declare function getStyleForMessageType(messageType: MessageType): CSSProperties;
export declare function getGlyphForStatusColour(statusColour: StatusColour): string;
export declare function getGlyphForMessageType(messageType: MessageType): string;
export declare function getScheduleDescription(schedule: Schedule): string;
export declare const UIHelper: {
    getDefaultColors: typeof getDefaultColors;
    getEmptyConfigState: typeof getEmptyConfigState;
    getExpressionBuilderState: typeof getExpressionBuilderState;
    getExpressionBuilderStateWithColumn: typeof getExpressionBuilderStateWithColumn;
    getDescriptionForDataType: typeof getDescriptionForDataType;
    getPlaceHolderforDataType: typeof getPlaceHolderforDataType;
    getModalContainer: typeof getModalContainer;
    getChartContainer: typeof getChartContainer;
    isValidUserChartContainer: typeof isValidUserChartContainer;
    IsNotEmptyStyle: typeof IsNotEmptyStyle;
    getMessageTypeByStatusColour: typeof getMessageTypeByStatusColour;
    getGlyphByMessageType: typeof getGlyphByMessageType;
    getStyleForStatusColour: typeof getStyleForStatusColour;
    getGlyphForStatusColour: typeof getGlyphForStatusColour;
    getScheduleDescription: typeof getScheduleDescription;
    getColorByMessageType: typeof getColorByMessageType;
    getGlyphForMessageType: typeof getGlyphForMessageType;
    getStyleForMessageType: typeof getStyleForMessageType;
};
export default UIHelper;
