/// <reference types="react" />
import { IColumn } from '../../../Utilities/Interface/IColumn';
import { IAdaptableBlotter } from '../../../Utilities/Interface/IAdaptableBlotter';
import { UserFilter } from '../../../PredefinedConfig/RunTimeState/UserFilterState';
import { AdaptableBlotterObject } from '../../../PredefinedConfig/AdaptableBlotterObject';
import { NamedFilter } from '../../../PredefinedConfig/RunTimeState/NamedFilterState';
import { ColumnCategory } from '../../../PredefinedConfig/RunTimeState/ColumnCategoryState';
export interface AdaptableWizardStep {
    canNext(): boolean;
    canBack(): boolean;
    Next(): void;
    Back(): void;
    GetIndexStepIncrement(): number;
    GetIndexStepDecrement(): number;
}
export interface AdaptableWizardStepProps<T> {
    Data?: T;
    UpdateGoBackState?(): void;
    Blotter?: IAdaptableBlotter;
    Columns?: IColumn[];
}
export interface ExpressionWizardProps<T> extends AdaptableWizardStepProps<T> {
    UserFilters: UserFilter[];
    SystemFilters: string[];
    NamedFilters: NamedFilter[];
    ColumnCategories: ColumnCategory[];
}
export interface AdaptableBlotterObjectExpressionAdaptableWizardProps<View> extends AdaptableBlotterObjectAdaptableWizardProps<View> {
    Columns: Array<IColumn>;
    UserFilters: UserFilter[];
    SystemFilters: string[];
    NamedFilters: NamedFilter[];
    ColumnCategories: ColumnCategory[];
    Blotter: IAdaptableBlotter;
}
export interface AdaptableWizardProps<View> extends React.ClassAttributes<View> {
    WizardStartIndex: number;
    onCloseWizard: () => void;
    onFinishWizard: () => void;
    ModalContainer: HTMLElement;
    canFinishWizard: Function;
}
export interface AdaptableBlotterObjectAdaptableWizardProps<View> extends AdaptableWizardProps<View> {
    ConfigEntities: AdaptableBlotterObject[];
    EditedAdaptableBlotterObject: AdaptableBlotterObject;
}
