"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var StringExtensions_1 = require("../Utilities/Extensions/StringExtensions");
var ArrayExtensions_1 = require("../Utilities/Extensions/ArrayExtensions");
var StrategyConstants = require("../Utilities/Constants/StrategyConstants");
var AlertStrategy_1 = require("../Strategy/AlertStrategy");
var AdvancedSearchStrategy_1 = require("../Strategy/AdvancedSearchStrategy");
var ApplicationStrategy_1 = require("../Strategy/ApplicationStrategy");
var BulkUpdateStrategy_1 = require("../Strategy/BulkUpdateStrategy");
var CalculatedColumnStrategy_1 = require("../Strategy/CalculatedColumnStrategy");
var CalendarStrategy_1 = require("../Strategy/CalendarStrategy");
var CellValidationStrategy_1 = require("../Strategy/CellValidationStrategy");
var ChartStrategy_1 = require("../Strategy/ChartStrategy");
var ColumnChooserStrategy_1 = require("../Strategy/ColumnChooserStrategy");
var ColumnFilterStrategy_1 = require("../Strategy/ColumnFilterStrategy");
var ColumnInfoStrategy_1 = require("../Strategy/ColumnInfoStrategy");
var ConditionalStyleStrategyagGrid_1 = require("./Strategy/ConditionalStyleStrategyagGrid");
var CustomSortStrategyagGrid_1 = require("./Strategy/CustomSortStrategyagGrid");
var DashboardStrategy_1 = require("../Strategy/DashboardStrategy");
var DataManagementStrategy_1 = require("../Strategy/DataManagementStrategy");
var DataSourceStrategy_1 = require("../Strategy/DataSourceStrategy");
var ExportStrategy_1 = require("../Strategy/ExportStrategy");
var FlashingCellsStrategyagGrid_1 = require("./Strategy/FlashingCellsStrategyagGrid");
var FormatColumnStrategyagGrid_1 = require("./Strategy/FormatColumnStrategyagGrid");
var FreeTextColumnStrategy_1 = require("../Strategy/FreeTextColumnStrategy");
var HomeStrategy_1 = require("../Strategy/HomeStrategy");
var LayoutStrategy_1 = require("../Strategy/LayoutStrategy");
var ColumnCategoryStrategy_1 = require("../Strategy/ColumnCategoryStrategy");
var PercentBarStrategy_1 = require("../Strategy/PercentBarStrategy");
var PieChartStrategy_1 = require("../Strategy/PieChartStrategy");
var PlusMinusStrategy_1 = require("../Strategy/PlusMinusStrategy");
var QuickSearchStrategy_1 = require("../Strategy/QuickSearchStrategy");
var SmartEditStrategy_1 = require("../Strategy/SmartEditStrategy");
var ShortcutStrategy_1 = require("../Strategy/ShortcutStrategy");
var TeamSharingStrategy_1 = require("../Strategy/TeamSharingStrategy");
var ThemeStrategy_1 = require("../Strategy/ThemeStrategy");
var CellSummaryStrategy_1 = require("../Strategy/CellSummaryStrategy");
var UserFilterStrategy_1 = require("../Strategy/UserFilterStrategy");
var ReminderStrategy_1 = require("../Strategy/ReminderStrategy");
/**
 * AdaptableBlotter ag-Grid implementation is getting really big and unwieldy
 * So lets put some of the more obvious 'Helper' functions here
 * This is a bit crap - it should take a GridOptions object...
 */
// tslint:disable-next-line: class-name
var agGridHelper = /** @class */ (function () {
    function agGridHelper(blotter, gridOptions) {
        this.blotter = blotter;
        this.gridOptions = gridOptions;
        this.blotter = blotter;
        this.gridOptions = gridOptions;
    }
    agGridHelper.prototype.getVendorLightThemeName = function () {
        return 'ag-theme-balham';
    };
    agGridHelper.prototype.getVendorDarkThemeName = function () {
        return 'ag-theme-balham-dark';
    };
    agGridHelper.prototype.setUpStrategies = function () {
        var strategies = new Map();
        var blotter = this.blotter;
        strategies.set(StrategyConstants.AlertStrategyId, new AlertStrategy_1.AlertStrategy(blotter));
        strategies.set(StrategyConstants.AdvancedSearchStrategyId, new AdvancedSearchStrategy_1.AdvancedSearchStrategy(blotter));
        strategies.set(StrategyConstants.ApplicationStrategyId, new ApplicationStrategy_1.ApplicationStrategy(blotter));
        strategies.set(StrategyConstants.BulkUpdateStrategyId, new BulkUpdateStrategy_1.BulkUpdateStrategy(blotter));
        strategies.set(StrategyConstants.CalculatedColumnStrategyId, new CalculatedColumnStrategy_1.CalculatedColumnStrategy(blotter));
        strategies.set(StrategyConstants.CalendarStrategyId, new CalendarStrategy_1.CalendarStrategy(blotter));
        strategies.set(StrategyConstants.CellValidationStrategyId, new CellValidationStrategy_1.CellValidationStrategy(blotter));
        strategies.set(StrategyConstants.ChartStrategyId, new ChartStrategy_1.ChartStrategy(blotter));
        strategies.set(StrategyConstants.ColumnChooserStrategyId, new ColumnChooserStrategy_1.ColumnChooserStrategy(blotter));
        strategies.set(StrategyConstants.ColumnFilterStrategyId, new ColumnFilterStrategy_1.ColumnFilterStrategy(blotter));
        strategies.set(StrategyConstants.ColumnInfoStrategyId, new ColumnInfoStrategy_1.ColumnInfoStrategy(blotter));
        strategies.set(StrategyConstants.ConditionalStyleStrategyId, new ConditionalStyleStrategyagGrid_1.ConditionalStyleStrategyagGrid(blotter));
        strategies.set(StrategyConstants.CustomSortStrategyId, new CustomSortStrategyagGrid_1.CustomSortStrategyagGrid(blotter));
        strategies.set(StrategyConstants.DashboardStrategyId, new DashboardStrategy_1.DashboardStrategy(blotter));
        strategies.set(StrategyConstants.DataManagementStrategyId, new DataManagementStrategy_1.DataManagementStrategy(blotter));
        strategies.set(StrategyConstants.DataSourceStrategyId, new DataSourceStrategy_1.DataSourceStrategy(blotter));
        strategies.set(StrategyConstants.ExportStrategyId, new ExportStrategy_1.ExportStrategy(blotter));
        strategies.set(StrategyConstants.FlashingCellsStrategyId, new FlashingCellsStrategyagGrid_1.FlashingCellStrategyagGrid(blotter));
        strategies.set(StrategyConstants.FormatColumnStrategyId, new FormatColumnStrategyagGrid_1.FormatColumnStrategyagGrid(blotter));
        strategies.set(StrategyConstants.FreeTextColumnStrategyId, new FreeTextColumnStrategy_1.FreeTextColumnStrategy(blotter));
        strategies.set(StrategyConstants.HomeStrategyId, new HomeStrategy_1.HomeStrategy(blotter));
        strategies.set(StrategyConstants.LayoutStrategyId, new LayoutStrategy_1.LayoutStrategy(blotter));
        strategies.set(StrategyConstants.ColumnCategoryStrategyId, new ColumnCategoryStrategy_1.ColumnCategoryStrategy(blotter));
        strategies.set(StrategyConstants.PercentBarStrategyId, new PercentBarStrategy_1.PercentBarStrategy(blotter));
        strategies.set(StrategyConstants.PieChartStrategyId, new PieChartStrategy_1.PieChartStrategy(blotter));
        strategies.set(StrategyConstants.PlusMinusStrategyId, new PlusMinusStrategy_1.PlusMinusStrategy(blotter));
        strategies.set(StrategyConstants.QuickSearchStrategyId, new QuickSearchStrategy_1.QuickSearchStrategy(blotter));
        strategies.set(StrategyConstants.SmartEditStrategyId, new SmartEditStrategy_1.SmartEditStrategy(blotter));
        strategies.set(StrategyConstants.ShortcutStrategyId, new ShortcutStrategy_1.ShortcutStrategy(blotter));
        strategies.set(StrategyConstants.TeamSharingStrategyId, new TeamSharingStrategy_1.TeamSharingStrategy(blotter));
        strategies.set(StrategyConstants.ThemeStrategyId, new ThemeStrategy_1.ThemeStrategy(blotter));
        strategies.set(StrategyConstants.CellSummaryStrategyId, new CellSummaryStrategy_1.CellSummaryStrategy(blotter));
        strategies.set(StrategyConstants.UserFilterStrategyId, new UserFilterStrategy_1.UserFilterStrategy(blotter));
        strategies.set(StrategyConstants.ReminderStrategyId, new ReminderStrategy_1.ReminderStrategy(blotter));
        return strategies;
    };
    agGridHelper.prototype.TrySetUpNodeIds = function () {
        if (StringExtensions_1.StringExtensions.IsNullOrEmpty(this.blotter.blotterOptions.primaryKey)) {
            // if no valid pk then always false
            return false;
        }
        // need some way of checking if running on client on server: if on server then we return false
        if (this.gridOptions.getRowNodeId != null) {
            return true;
        }
        // also we can check if they have done it
        var primaryKey = this.blotter.blotterOptions.primaryKey;
        // otherwise lets set the Id so that it returns the primaryKey
        this.gridOptions.getRowNodeId = function (data) {
            return data[primaryKey];
        };
        return true;
    };
    agGridHelper.prototype.createPercentBarCellRendererFunc = function (pcr, blotterId) {
        var _this = this;
        var showNegatives = pcr.MinValue < 0;
        var showPositives = pcr.MaxValue > 0;
        var cellRendererFunc = function (params) {
            var isNegativeValue = params.value < 0;
            var value = params.value;
            var maxValue = StringExtensions_1.StringExtensions.IsNotNullOrEmpty(pcr.MaxValueColumnId)
                ? _this.blotter.getRawValueFromRecord(params.node, pcr.MaxValueColumnId)
                : pcr.MaxValue;
            var minValue = StringExtensions_1.StringExtensions.IsNotNullOrEmpty(pcr.MinValueColumnId)
                ? _this.blotter.getRawValueFromRecord(params.node, pcr.MinValueColumnId)
                : pcr.MinValue;
            if (isNegativeValue) {
                value = value * -1;
            }
            var percentagePositiveValue = (100 / maxValue) * value;
            var percentageNegativeValue = (100 / (minValue * -1)) * value;
            if (showNegatives && showPositives) {
                // if need both then half the space
                percentagePositiveValue = percentagePositiveValue / 2;
                percentageNegativeValue = percentageNegativeValue / 2;
            }
            var eOuterDiv = document.createElement('div');
            eOuterDiv.className = 'ab_div-colour-render-div';
            if (pcr.ShowValue) {
                var showValueBar = document.createElement('div');
                showValueBar.id = 'ab_div-colour-render-text_' + blotterId + '_' + pcr.ColumnId;
                showValueBar.className = 'ab_div-colour-render-text';
                if (showNegatives && showPositives) {
                    showValueBar.style.paddingLeft = isNegativeValue ? '50%' : '20%';
                }
                else {
                    showValueBar.style.paddingLeft = '5px';
                }
                showValueBar.innerHTML = params.value;
                eOuterDiv.appendChild(showValueBar);
            }
            if (showNegatives) {
                var fullWidth = showPositives ? 50 : 100;
                var negativeDivBlankBar = document.createElement('div');
                negativeDivBlankBar.className = 'ab_div-colour-render-bar';
                negativeDivBlankBar.id = 'ab_div-colour-blank-bar_' + blotterId + '_' + pcr.ColumnId;
                negativeDivBlankBar.style.width = fullWidth - percentageNegativeValue + '%';
                eOuterDiv.appendChild(negativeDivBlankBar);
                var negativeDivPercentBar = document.createElement('div');
                negativeDivPercentBar.className = 'ab_div-colour-render-bar';
                negativeDivBlankBar.id = 'ab_div-colour-negative-bar_' + blotterId + '_' + pcr.ColumnId;
                negativeDivPercentBar.style.width = percentageNegativeValue + '%';
                if (isNegativeValue) {
                    negativeDivPercentBar.style.backgroundColor = pcr.NegativeColor;
                }
                eOuterDiv.appendChild(negativeDivPercentBar);
            }
            if (showPositives) {
                var positivePercentBarDiv = document.createElement('div');
                positivePercentBarDiv.className = 'ab_div-colour-render-bar';
                positivePercentBarDiv.id = 'ab_div-colour-positive-bar_' + blotterId + '_' + pcr.ColumnId;
                positivePercentBarDiv.style.width = percentagePositiveValue + '%';
                if (!isNegativeValue) {
                    positivePercentBarDiv.style.backgroundColor = pcr.PositiveColor;
                }
                eOuterDiv.appendChild(positivePercentBarDiv);
            }
            return eOuterDiv;
        };
        return cellRendererFunc;
    };
    agGridHelper.prototype.getCleanValue = function (value) {
        if (value == null || value == 'null' || value == undefined || value == 'undefined') {
            return undefined;
        }
        else {
            return String(value) || '';
        }
    };
    agGridHelper.prototype.getRenderedValue = function (percentBars, colDef, valueToRender) {
        var isRenderedColumn = ArrayExtensions_1.ArrayExtensions.ContainsItem(percentBars, colDef.field);
        if (isRenderedColumn) {
            return valueToRender;
        }
        var render = colDef.cellRenderer;
        if (typeof render == 'string') {
            return this.getCleanValue(valueToRender);
        }
        return render({ value: valueToRender }) || '';
    };
    agGridHelper.prototype.safeSetColDefs = function (colDefs) {
        // bizarrely we need this line otherwise ag-Grid mangles the ColIds (e.g. 'tradeId' becomes 'tradeId_1')
        this.gridOptions.api.setColumnDefs([]);
        this.gridOptions.api.setColumnDefs(colDefs);
    };
    agGridHelper.prototype.createAdaptableBlotterSideBarDefs = function (showFilterPanel, showColumnsPanel) {
        var toolPanelDef = [];
        if (showFilterPanel) {
            var filterToolPanel = {
                id: 'filters',
                labelDefault: 'Filters',
                labelKey: 'filters',
                iconKey: 'filter',
                toolPanel: 'agFiltersToolPanel',
            };
            toolPanelDef.push(filterToolPanel);
        }
        if (showColumnsPanel) {
            var columnsToolPanel = {
                id: 'columns',
                labelDefault: 'Columns',
                labelKey: 'columns',
                iconKey: 'columns',
                toolPanel: 'agColumnsToolPanel',
            };
            toolPanelDef.push(columnsToolPanel);
        }
        toolPanelDef.push(this.createAdaptableBlotterToolPanel());
        var abSideBarDef = {
            toolPanels: toolPanelDef,
            defaultToolPanel: '',
        };
        return abSideBarDef;
    };
    agGridHelper.prototype.createAdaptableBlotterToolPanel = function () {
        return {
            id: 'adaptableBlotterToolPanel',
            labelDefault: 'Adaptable Blotter',
            labelKey: 'adaptableBlotterToolPanel',
            iconKey: 'menu',
            toolPanel: 'adaptableBlotterToolPanel',
        };
    };
    // This method reselects cells - only IF they are in a single column
    // Might be able to change that later
    // We do this by gettng the selected cells, clearing the selection and then re-applying
    agGridHelper.prototype.reselectSelectedCells = function () {
        var selectedCellRanges = this.gridOptions.api.getCellRanges();
        if (ArrayExtensions_1.ArrayExtensions.CorrectLength(selectedCellRanges, 1)) {
            var selectedCellRange = selectedCellRanges[0];
            var cellRangeParams = {
                rowStartIndex: selectedCellRange.startRow.rowIndex,
                rowEndIndex: selectedCellRange.endRow.rowIndex,
                columns: selectedCellRange.columns,
            };
            this.gridOptions.api.clearRangeSelection();
            this.gridOptions.api.addCellRange(cellRangeParams);
        }
    };
    agGridHelper.prototype.setUpRowStyles = function () {
        var rowStyles = this.blotter.api.userInterfaceApi.getUserInterfaceState().RowStyles;
        if (ArrayExtensions_1.ArrayExtensions.IsNotNullOrEmpty(rowStyles)) {
            // First lets deal with Alls - we will get the first one and then get out
            var allRowStyle = rowStyles.find(function (rs) { return rs.RowType == 'All'; });
            if (allRowStyle) {
                if (StringExtensions_1.StringExtensions.IsNotNullOrEmpty(allRowStyle.Style.ClassName)) {
                    // we have a row style name so we can just set that for the whole grid and no need to use the function
                    this.gridOptions.rowClass = allRowStyle.Style.ClassName;
                }
                else {
                    // no row style name so se the rowstyle - again no need to use a function
                    this.gridOptions.rowStyle = {
                        background: allRowStyle.Style.BackColor,
                        color: allRowStyle.Style.ForeColor,
                        fontWeight: allRowStyle.Style.FontWeight,
                        fontStyle: allRowStyle.Style.FontStyle,
                    };
                }
            }
            else {
                // we dont have an all row style so now things get hard and we need to see if we have one alternating style or 2
                var evenRowStyle_1 = rowStyles.find(function (rs) { return rs.RowType == 'Even'; });
                var oddRowStyle_1 = rowStyles.find(function (rs) { return rs.RowType == 'Odd'; });
                // this logic feels a bit OTT but the idea is to avoid having to create this getRowClass or getRowStyle functions when not needed.
                var evenRowStyleName_1 = evenRowStyle_1 && evenRowStyle_1.Style.ClassName;
                var oddRowStyleName_1 = oddRowStyle_1 && oddRowStyle_1.Style.ClassName;
                var emptyEvenRowStyleName_1 = StringExtensions_1.StringExtensions.IsNullOrEmpty(evenRowStyleName_1);
                var emptyOddRowStyleName_1 = StringExtensions_1.StringExtensions.IsNullOrEmpty(oddRowStyleName_1);
                var atLeastOneNormalStyle = (evenRowStyle_1 && emptyEvenRowStyleName_1) || (oddRowStyle_1 && emptyOddRowStyleName_1);
                if (evenRowStyleName_1 || oddRowStyleName_1) {
                    this.gridOptions.getRowClass = function (params) {
                        if (evenRowStyleName_1) {
                            if (params.node.rowIndex % 2 === 0) {
                                return evenRowStyleName_1;
                            }
                        }
                        if (oddRowStyleName_1) {
                            if (params.node.rowIndex % 2 === 1) {
                                return oddRowStyleName_1;
                            }
                        }
                    };
                }
                if (atLeastOneNormalStyle) {
                    this.gridOptions.getRowStyle = function (params) {
                        if (evenRowStyle_1 && emptyEvenRowStyleName_1) {
                            if (params.node.rowIndex % 2 === 0) {
                                return {
                                    background: evenRowStyle_1.Style.BackColor,
                                    color: evenRowStyle_1.Style.ForeColor,
                                    fontWeight: evenRowStyle_1.Style.FontWeight,
                                    fontStyle: evenRowStyle_1.Style.FontStyle,
                                };
                            }
                        }
                        if (oddRowStyle_1 && emptyOddRowStyleName_1) {
                            if (params.node.rowIndex % 2 === 1) {
                                return {
                                    background: oddRowStyle_1.Style.BackColor,
                                    color: oddRowStyle_1.Style.ForeColor,
                                    fontWeight: oddRowStyle_1.Style.FontWeight,
                                    fontStyle: oddRowStyle_1.Style.FontStyle,
                                };
                            }
                        }
                    };
                }
            }
        }
    };
    agGridHelper.prototype.fireSelectionChangedEvent = function () {
        var selectionChangedArgs = {
            selectedCellInfo: this.blotter.api.gridApi.getGridState().SelectedCellInfo,
            selectedRowInfo: this.blotter.api.gridApi.getGridState().SelectedRowInfo,
        };
        this.blotter.api.eventApi._onSelectionChanged.Dispatch(this.blotter, selectionChangedArgs);
    };
    return agGridHelper;
}());
exports.agGridHelper = agGridHelper;
