"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("react");
var styled_components_1 = require("styled-components");
var rebass_1 = require("rebass");
var join_1 = require("../utils/join");
var DefaultIcon_1 = require("../icons/DefaultIcon");
var checked = styled_components_1.keyframes(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  100% {\n    stroke-dashoffset: 0;\n  }\n"], ["\n  100% {\n    stroke-dashoffset: 0;\n  }\n"])));
var CheckSvg = styled_components_1.default.svg(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n  position: relative;\n  z-index: 1;\n\n  pointer-events: none;\n\n  color: var(--ab-color-inputcolor);\n  background: var(--ab-color-defaultbackground);\n\n  rect,\n  polyline {\n    fill: none;\n    stroke-width: 4;\n  }\n  rect {\n    stroke: currentColor;\n  }\n"], ["\n  position: relative;\n  z-index: 1;\n\n  pointer-events: none;\n\n  color: var(--ab-color-inputcolor);\n  background: var(--ab-color-defaultbackground);\n\n  rect,\n  polyline {\n    fill: none;\n    stroke-width: 4;\n  }\n  rect {\n    stroke: currentColor;\n  }\n"])));
var CheckboxInput = styled_components_1.default.input(templateObject_3 || (templateObject_3 = tslib_1.__makeTemplateObject(["\n  width: 0;\n  &:focus + svg rect {\n    stroke: var(--ab-color-inputcolor);\n    stroke-width: 2;\n  }\n  &:focus + svg {\n    outline: 2px solid var(--ab-color-focus);\n  }\n  &:checked + svg rect,\n  &:checked + svg polyline {\n    stroke: currentColor;\n  }\n  &:checked + svg polyline {\n    animation: ", " 0.5s ease forwards;\n    stroke-dasharray: 50;\n    stroke-dashoffset: 50;\n  }\n"], ["\n  width: 0;\n  &:focus + svg rect {\n    stroke: var(--ab-color-inputcolor);\n    stroke-width: 2;\n  }\n  &:focus + svg {\n    outline: 2px solid var(--ab-color-focus);\n  }\n  &:checked + svg rect,\n  &:checked + svg polyline {\n    stroke: currentColor;\n  }\n  &:checked + svg polyline {\n    animation: ", " 0.5s ease forwards;\n    stroke-dasharray: 50;\n    stroke-dashoffset: 50;\n  }\n"])), checked);
var CheckBox = function (_a) {
    var children = _a.children, checked = _a.checked, onChange = _a.onChange, value = _a.value, name = _a.name, _b = _a.gapDistance, gapDistance = _b === void 0 ? 'var(--ab-space-1)' : _b, _c = _a.childrenPosition, childrenPosition = _c === void 0 ? 'end' : _c, _d = _a.as, as = _d === void 0 ? 'label' : _d, props = tslib_1.__rest(_a, ["children", "checked", "onChange", "value", "name", "gapDistance", "childrenPosition", "as"]);
    var _e = tslib_1.__read(react_1.useState(false), 2), stateChecked = _e[0], setStateChecked = _e[1];
    var computedChecked = checked !== undefined ? checked : stateChecked;
    var onInputChange = function (event) {
        var newChecked = event.target.checked;
        if (checked === undefined) {
            setStateChecked(newChecked);
        }
        if (onChange) {
            onChange(newChecked, event);
        }
    };
    var gap = React.createElement("div", { style: { marginLeft: gapDistance, display: 'inline-block' } });
    children = React.createElement("div", { style: { display: 'inline-block' } }, children);
    var before = childrenPosition === 'start' ? children : null;
    var beforeGap = childrenPosition === 'start' ? gap : null;
    var after = childrenPosition === 'end' ? children : null;
    var afterGap = childrenPosition === 'end' ? gap : null;
    return (React.createElement(rebass_1.Box, tslib_1.__assign({ my: 2 }, props, { className: join_1.default('ab-CheckBox', props.className), style: tslib_1.__assign({ display: 'inline-flex', flexFlow: 'row', alignItems: 'center', cursor: 'pointer', position: 'relative' }, props.style), as: as }),
        before,
        beforeGap,
        React.createElement(CheckboxInput, { checked: computedChecked, type: "checkbox", name: name, value: value, style: {
                verticalAlign: 'middle',
                opacity: 0,
                cursor: 'pointer',
                position: 'relative',
                top: -2,
            }, onChange: onInputChange }),
        React.createElement(CheckSvg, { viewBox: "0 0 40 40", height: DefaultIcon_1.getSize(19) },
            React.createElement("rect", { x: "2", y: "2", width: "36", height: "36" }),
            React.createElement("polyline", { points: "9,22 18,30 33,14" })),
        afterGap,
        after));
};
exports.default = CheckBox;
var templateObject_1, templateObject_2, templateObject_3;
