"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var ReactDOMServer = require("react-dom/server");
var arrow_right_1 = require("./arrow-right");
var arrow_down_1 = require("./arrow-down");
var arrow_up_1 = require("./arrow-up");
var arrow_left_1 = require("./arrow-left");
var triangle_up_1 = require("./triangle-up");
var triangle_down_1 = require("./triangle-down");
var check_1 = require("./check");
var plus_1 = require("./plus");
var clear_1 = require("./clear");
var search_1 = require("./search");
var info_1 = require("./info");
var alert_1 = require("./alert");
var list_1 = require("./list");
var edit_1 = require("./edit");
var view_columns_1 = require("./view-columns");
var home_1 = require("./home");
var justify_1 = require("./justify");
var error_1 = require("./error");
var export_1 = require("./export");
var build_1 = require("./build");
var warning_1 = require("./warning");
var conditional_style_1 = require("./conditional-style");
var dashboard_1 = require("./dashboard");
var undo_1 = require("./undo");
var fast_forward_1 = require("./fast-forward");
var fast_backward_1 = require("./fast-backward");
var sort_asc_1 = require("./sort-asc");
var sort_desc_1 = require("./sort-desc");
var calendar_1 = require("./calendar");
var delete_1 = require("./delete");
var color_drop_1 = require("./color-drop");
var check_circle_1 = require("./check-circle");
var refresh_1 = require("./refresh");
var save_1 = require("./save");
var bar_chart_1 = require("./bar-chart");
var laptop_1 = require("./laptop");
var update_1 = require("./update");
var import_export_1 = require("./import-export");
var phone_setup_1 = require("./phone-setup");
var view_module_1 = require("./view-module");
var flag_1 = require("./flag");
var table_chart_1 = require("./table-chart");
var filter_list_1 = require("./filter-list");
var column_info_1 = require("./column-info");
var swap_vert_1 = require("./swap-vert");
var data_source_1 = require("./data-source");
var flash_on_1 = require("./flash-on");
var color_lens_1 = require("./color-lens");
var short_text_1 = require("./short-text");
var comment_1 = require("./comment");
var apps_1 = require("./apps");
var assignment_1 = require("./assignment");
var linear_scale_1 = require("./linear-scale");
var pie_chart_1 = require("./pie-chart");
var add_circle_1 = require("./add-circle");
var page_view_1 = require("./page-view");
var alarm_1 = require("./alarm");
var link_1 = require("./link");
var person_1 = require("./person");
var align_justify_1 = require("./align-justify");
var color_fill_1 = require("./color-fill");
var check_box_1 = require("./check-box");
var check_box_outline_1 = require("./check-box-outline");
var tab_unselected_1 = require("./tab-unselected");
var allIcons = {
    assignment: assignment_1.default,
    'linear-scale': linear_scale_1.default,
    'pie-chart': pie_chart_1.default,
    'add-circle': add_circle_1.default,
    'page-view': page_view_1.default,
    'tab-unselected': tab_unselected_1.default,
    'check-box': check_box_1.default,
    'check-box-outline': check_box_outline_1.default,
    unchecked: check_box_outline_1.default,
    checked: check_box_1.default,
    alarm: alarm_1.default,
    person: person_1.default,
    link: link_1.default,
    'arrow-right': arrow_right_1.default,
    'arrow-up': arrow_up_1.default,
    'triangle-up': triangle_up_1.default,
    'arrow-down': arrow_down_1.default,
    'triangle-down': triangle_down_1.default,
    'color-lens': color_lens_1.default,
    'short-text': short_text_1.default,
    'arrow-left': arrow_left_1.default,
    'bar-chart': bar_chart_1.default,
    'color-drop': color_drop_1.default,
    'column-info': column_info_1.default,
    'check-circle': check_circle_1.default,
    'view-columns': view_columns_1.default,
    'conditional-style': conditional_style_1.default,
    apps: apps_1.default,
    'filter-list': filter_list_1.default,
    comment: comment_1.default,
    list: list_1.default,
    undo: undo_1.default,
    'table-chart': table_chart_1.default,
    flag: flag_1.default,
    update: update_1.default,
    'phone-setup': phone_setup_1.default,
    'view-module': view_module_1.default,
    delete: delete_1.default,
    build: build_1.default,
    save: save_1.default,
    trash: delete_1.default,
    refresh: refresh_1.default,
    error: error_1.default,
    exclamation: error_1.default,
    'exclamation-sign': error_1.default,
    'fast-forward': fast_forward_1.default,
    'fast-backward': fast_backward_1.default,
    warning: warning_1.default,
    alert: alert_1.default,
    laptop: laptop_1.default,
    'notification-important': alert_1.default,
    'warning-sign': warning_1.default,
    justify: justify_1.default,
    check: check_1.default,
    ok: check_1.default,
    'ok-sign': check_1.default,
    plus: plus_1.default,
    calendar: calendar_1.default,
    home: home_1.default,
    'sort-asc': sort_asc_1.default,
    'sort-desc': sort_desc_1.default,
    'swap-vert': swap_vert_1.default,
    'data-source': data_source_1.default,
    dashboard: dashboard_1.default,
    'align-justify': align_justify_1.default,
    edit: edit_1.default,
    clear: clear_1.default,
    'import-export': import_export_1.default,
    'color-fill': color_fill_1.default,
    info: info_1.default,
    'info-sign': info_1.default,
    add: plus_1.default,
    'flash-on': flash_on_1.default,
    flash: flash_on_1.default,
    export: export_1.default,
    search: search_1.default,
};
exports.Icon = function (_a) {
    var name = _a.name, style = _a.style, props = tslib_1.__rest(_a, ["name", "style"]);
    var IconCmp = (allIcons[name] || null);
    if (!IconCmp) {
        console.warn('NO icon found for ' + name);
        return React.createElement("svg", null);
    }
    return React.createElement(IconCmp, tslib_1.__assign({}, props, { style: style }));
};
exports.iconToString = function (name, props) {
    return ReactDOMServer.renderToString(React.createElement(exports.Icon, tslib_1.__assign({ name: name }, props)));
};
exports.default = allIcons;
